

/*   Names of external functions which contain upper case letters are
 *   modified by the VMS GNU C compiler to prevent confusion between
 *   names such as XOpen and xopen.  GNU C does this by translating a
 *   name like XOpen into xopen_aaaaaaaax with "aaaaaaaa" a hexadecimal
 *   string.  However, this causes problems when we link against the
 *   X library which doesn't contain a routine named xopen_aaaaaaaax.
 *   So, we use #define's to map all X routine names to lower case.
 *   (Note that routines like BlackPixelOfScreen, which are [for VMS]
 *   preprocessor macros, do not appear here.)
 */


#ifndef CASEHACK_LOADED
#define CASEHACK_LOADED



#define     CvtStringToCompString                         cvtstringtocompstring
#define     CvtStringToFontList                           cvtstringtofontlist
#define     DXmActivateWidget                             dxmactivatewidget
#define     DXmCSContainsStringCharSet                    dxmcscontainsstringcharset
#define     DXmCSTextClearSelection                       dxmcstextclearselection
#define     DXmCSTextCopy                                 dxmcstextcopy
#define     DXmCSTextCut                                  dxmcstextcut
#define     DXmCSTextDisableRedisplay                     dxmcstextdisableredisplay
#define     DXmCSTextEnableRedisplay                      dxmcstextenableredisplay
#define     DXmCSTextGetCursorPosition                    dxmcstextgetcursorposition
#define     DXmCSTextGetEditable                          dxmcstextgeteditable
#define     DXmCSTextGetInsertionPosition                 dxmcstextgetinsertionposition
#define     DXmCSTextGetLastPosition                      dxmcstextgetlastposition
#define     DXmCSTextGetMaxLength                         dxmcstextgetmaxlength
#define     DXmCSTextGetSelection                         dxmcstextgetselection
#define     DXmCSTextGetSelectionInfo                     dxmcstextgetselectioninfo
#define     DXmCSTextGetString                            dxmcstextgetstring
#define     DXmCSTextGetStringWrapped                     dxmcstextgetstringwrapped
#define     DXmCSTextGetTextPath                          dxmcstextgettextpath
#define     DXmCSTextGetTopPosition                       dxmcstextgettopposition
#define     DXmCSTextHasSelection                         dxmcstexthasselection
#define     DXmCSTextHorizontalScroll                     dxmcstexthorizontalscroll
#define     DXmCSTextInsert                               dxmcstextinsert
#define     DXmCSTextInsertChar                           dxmcstextinsertchar
#define     DXmCSTextInvalidate                           dxmcstextinvalidate
#define     DXmCSTextMarkRedraw                           dxmcstextmarkredraw
#define     DXmCSTextNumLines                             dxmcstextnumlines
#define     DXmCSTextPaste                                dxmcstextpaste
#define     DXmCSTextPosToLine                            dxmcstextpostoline
#define     DXmCSTextPosToXY                              dxmcstextpostoxy
#define     DXmCSTextRead                                 dxmcstextread
#define     DXmCSTextRemove                               dxmcstextremove
#define     DXmCSTextReplace                              dxmcstextreplace
#define     DXmCSTextSetCursorPosition                    dxmcstextsetcursorposition
#define     DXmCSTextSetEditable                          dxmcstextseteditable
#define     DXmCSTextSetHighlight                         dxmcstextsethighlight
#define     DXmCSTextSetInsertionPosition                 dxmcstextsetinsertionposition
#define     DXmCSTextSetMaxLength                         dxmcstextsetmaxlength
#define     DXmCSTextSetSelection                         dxmcstextsetselection
#define     DXmCSTextSetString                            dxmcstextsetstring
#define     DXmCSTextSetTextPath                          dxmcstextsettextpath
#define     DXmCSTextSetTopPosition                       dxmcstextsettopposition
#define     DXmCSTextShowPosition                         dxmcstextshowposition
#define     DXmCSTextVerticalScroll                       dxmcstextverticalscroll
#define     DXmCSTextXYToPos                              dxmcstextxytopos
#define     DXmChangeWindowGeometry                       dxmchangewindowgeometry
#define     DXmChildren                                   dxmchildren
#define     DXmColorMixGetNewColor                        dxmcolormixgetnewcolor
#define     DXmColorMixSetNewColor                        dxmcolormixsetnewcolor
#define     DXmCreateCSText                               dxmcreatecstext
#define     DXmCreateColorMix                             dxmcreatecolormix
#define     DXmCreateColorMixDialog                       dxmcreatecolormixdialog
#define     DXmCreateCursor                               dxmcreatecursor
#define     DXmCreateHelp                                 dxmcreatehelp
#define     DXmCreateHelpDialog                           dxmcreatehelpdialog
#define     DXmCreatePrintBox                             dxmcreateprintbox
#define     DXmCreatePrintDialog                          dxmcreateprintdialog
#define     DXmCreateScrolledCSText                       dxmcreatescrolledcstext
#define     DXmCreateSvn                                  dxmcreatesvn
#define     DXmCvtCStoDDIF                                dxmcvtcstoddif
#define     DXmCvtCStoFC                                  dxmcvtcstofc
#define     DXmCvtCStoOS                                  dxmcvtcstoos
#define     DXmCvtDDIFtoCS                                dxmcvtddiftocs
#define     DXmCvtFCtoCS                                  dxmcvtfctocs
#define     DXmCvtOStoCS                                  dxmcvtostocs
#define     DXmDescToNull                                 dxmdesctonull
#define     DXmDisplayCSMessage                           dxmdisplaycsmessage
#define     DXmDisplayVmsMessage                          dxmdisplayvmsmessage
#define     DXmFindFontFallback                           dxmfindfontfallback
#define     DXmFontListCreateDefault                      dxmfontlistcreatedefault
#define     DXmFormSpaceButtonsEqually                    dxmformspacebuttonsequally
#define     DXmGetLocaleCharset                           dxmgetlocalecharset
#define     DXmGetLocaleCharsets                          dxmgetlocalecharsets
#define     DXmGetLocaleMnemonic                          dxmgetlocalemnemonic
#define     DXmGetLocaleString                            dxmgetlocalestring
#define     DXmHelpOnContext                              dxmhelponcontext
#define     DXmHelpSystemClose                            dxmhelpsystemclose
#define     DXmHelpSystemDisplay                          dxmhelpsystemdisplay
#define     DXmHelpSystemOpen                             dxmhelpsystemopen
#define     DXmInitialize                                 dxminitialize
#define     DXmLoadQueryFont                              dxmloadqueryfont
#define     DXmMakeGeometryRequest                        dxmmakegeometryrequest
#define     DXmNumChildren                                dxmnumchildren
#define     DXmPositionWidget                             dxmpositionwidget
#define     DXmPrintWgtAugmentList                        dxmprintwgtaugmentlist
#define     DXmPrintWgtPrintJob                           dxmprintwgtprintjob
#define     DXmStringCheck                                dxmstringcheck
#define     DXmSvnAddEntries                              dxmsvnaddentries
#define     DXmSvnAutoScrollCheck                         dxmsvnautoscrollcheck
#define     DXmSvnAutoScrollDisplay                       dxmsvnautoscrolldisplay
#define     DXmSvnClearHighlight                          dxmsvnclearhighlight
#define     DXmSvnClearHighlighting                       dxmsvnclearhighlighting
#define     DXmSvnClearSelection                          dxmsvnclearselection
#define     DXmSvnClearSelections                         dxmsvnclearselections
#define     DXmSvnDeleteEntries                           dxmsvndeleteentries
#define     DXmSvnDisableDisplay                          dxmsvndisabledisplay
#define     DXmSvnEnableDisplay                           dxmsvnenabledisplay
#define     DXmSvnFlushEntry                              dxmsvnflushentry
#define     DXmSvnGetComponentNumber                      dxmsvngetcomponentnumber
#define     DXmSvnGetComponentTag                         dxmsvngetcomponenttag
#define     DXmSvnGetComponentText                        dxmsvngetcomponenttext
#define     DXmSvnGetComponentWidth                       dxmsvngetcomponentwidth
#define     DXmSvnGetDisplayed                            dxmsvngetdisplayed
#define     DXmSvnGetEntryLevel                           dxmsvngetentrylevel
#define     DXmSvnGetEntryNumber                          dxmsvngetentrynumber
#define     DXmSvnGetEntryPosition                        dxmsvngetentryposition
#define     DXmSvnGetEntrySensitivity                     dxmsvngetentrysensitivity
#define     DXmSvnGetEntryTag                             dxmsvngetentrytag
#define     DXmSvnGetHighlighted                          dxmsvngethighlighted
#define     DXmSvnGetNumDisplayed                         dxmsvngetnumdisplayed
#define     DXmSvnGetNumHighlighted                       dxmsvngetnumhighlighted
#define     DXmSvnGetNumSelections                        dxmsvngetnumselections
#define     DXmSvnGetPrimaryWorkWidget                    dxmsvngetprimaryworkwidget
#define     DXmSvnGetSecondaryWorkWidget                  dxmsvngetsecondaryworkwidget
#define     DXmSvnGetSelections                           dxmsvngetselections
#define     DXmSvnGetTreePosition                         dxmsvngettreeposition
#define     DXmSvnHideHighlighting                        dxmsvnhidehighlighting
#define     DXmSvnHideSelections                          dxmsvnhideselections
#define     DXmSvnHighlightAll                            dxmsvnhighlightall
#define     DXmSvnHighlightEntry                          dxmsvnhighlightentry
#define     DXmSvnInitializeForMRM                        dxmsvninitializeformrm
#define     DXmSvnInsertComponent                         dxmsvninsertcomponent
#define     DXmSvnInvalidateEntry                         dxmsvninvalidateentry
#define     DXmSvnMapPosition                             dxmsvnmapposition
#define     DXmSvnPositionDisplay                         dxmsvnpositiondisplay
#define     DXmSvnRemoveComponent                         dxmsvnremovecomponent
#define     DXmSvnSelectAll                               dxmsvnselectall
#define     DXmSvnSelectComponent                         dxmsvnselectcomponent
#define     DXmSvnSelectEntry                             dxmsvnselectentry
#define     DXmSvnSetApplDragging                         dxmsvnsetappldragging
#define     DXmSvnSetComponentHidden                      dxmsvnsetcomponenthidden
#define     DXmSvnSetComponentPixmap                      dxmsvnsetcomponentpixmap
#define     DXmSvnSetComponentTag                         dxmsvnsetcomponenttag
#define     DXmSvnSetComponentText                        dxmsvnsetcomponenttext
#define     DXmSvnSetComponentWidget                      dxmsvnsetcomponentwidget
#define     DXmSvnSetComponentWidth                       dxmsvnsetcomponentwidth
#define     DXmSvnSetEntry                                dxmsvnsetentry
#define     DXmSvnSetEntryIndexWindow                     dxmsvnsetentryindexwindow
#define     DXmSvnSetEntryNumComponents                   dxmsvnsetentrynumcomponents
#define     DXmSvnSetEntryPosition                        dxmsvnsetentryposition
#define     DXmSvnSetEntrySensitivity                     dxmsvnsetentrysensitivity
#define     DXmSvnSetEntryTag                             dxmsvnsetentrytag
#define     DXmSvnSetTreePosition                         dxmsvnsettreeposition
#define     DXmSvnShowHighlighting                        dxmsvnshowhighlighting
#define     DXmSvnShowSelections                          dxmsvnshowselections
#define     DXmSvnValidateAll                             dxmsvnvalidateall
#define     DXmSvnWidget                                  dxmsvnwidget
#define     DwtActivateWidget                             dwtactivatewidget
#define     DwtAddFontList                                dwtaddfontlist
#define     DwtAttachedDB                                 dwtattacheddb
#define     DwtAttachedDBCreate                           dwtattacheddbcreate
#define     DwtAttachedDBPopupCreate                      dwtattacheddbpopupcreate
#define     DwtBeginCopyToClipboard                       dwtbegincopytoclipboard
#define     DwtCSString                                   dwtcsstring
#define     DwtCSText                                     dwtcstext
#define     DwtCSTextCreate                               dwtcstextcreate
#define     DwtCSTextGetEditable                          dwtcstextgeteditable
#define     DwtCSTextGetMaxLength                         dwtcstextgetmaxlength
#define     DwtCSTextGetSelection                         dwtcstextgetselection
#define     DwtCSTextGetString                            dwtcstextgetstring
#define     DwtCSTextReplace                              dwtcstextreplace
#define     DwtCSTextSetEditable                          dwtcstextseteditable
#define     DwtCSTextSetMaxLength                         dwtcstextsetmaxlength
#define     DwtCSTextSetSelection                         dwtcstextsetselection
#define     DwtCSTextSetString                            dwtcstextsetstring
#define     DwtCSbytecmp                                  dwtcsbytecmp
#define     DwtCSempty                                    dwtcsempty
#define     DwtCStrcat                                    dwtcstrcat
#define     DwtCStrcpy                                    dwtcstrcpy
#define     DwtCStrlen                                    dwtcstrlen
#define     DwtCStrncat                                   dwtcstrncat
#define     DwtCStrncpy                                   dwtcstrncpy
#define     DwtCancelCopyToClipboard                      dwtcancelcopytoclipboard
#define     DwtCautionBox                                 dwtcautionbox
#define     DwtCautionBoxCreate                           dwtcautionboxcreate
#define     DwtChildren                                   dwtchildren
#define     DwtClipboardLock                              dwtclipboardlock
#define     DwtClipboardUnlock                            dwtclipboardunlock
#define     DwtCloseHierarchy                             dwtclosehierarchy
#define     DwtColorMixCreate                             dwtcolormixcreate
#define     DwtColorMixGetNewColor                        dwtcolormixgetnewcolor
#define     DwtColorMixSetNewColor                        dwtcolormixsetnewcolor
#define     DwtCommandAppend                              dwtcommandappend
#define     DwtCommandErrorMessage                        dwtcommanderrormessage
#define     DwtCommandSet                                 dwtcommandset
#define     DwtCommandWindow                              dwtcommandwindow
#define     DwtCommandWindowCreate                        dwtcommandwindowcreate
#define     DwtCopyFromClipboard                          dwtcopyfromclipboard
#define     DwtCopyToClipboard                            dwtcopytoclipboard
#define     DwtCreateFontList                             dwtcreatefontlist
#define     DwtDialogBox                                  dwtdialogbox
#define     DwtDialogBoxCreate                            dwtdialogboxcreate
#define     DwtDialogBoxPopupCreate                       dwtdialogboxpopupcreate
#define     DwtDrmFreeResourceContext                     dwtdrmfreeresourcecontext
#define     DwtDrmGetIndexedLiteral                       dwtdrmgetindexedliteral
#define     DwtDrmGetResourceContext                      dwtdrmgetresourcecontext
#define     DwtDrmHGetIndexedLiteral                      dwtdrmhgetindexedliteral
#define     DwtDrmResizeResourceContext                   dwtdrmresizeresourcecontext
#define     DwtDrm__OpenHierarchy                         dwtdrm__openhierarchy
#define     DwtEndCopyToClipboard                         dwtendcopytoclipboard
#define     DwtFetchColorLiteral                          dwtfetchcolorliteral
#define     DwtFetchIconLiteral                           dwtfetchiconliteral
#define     DwtFetchInterfaceModule                       dwtfetchinterfacemodule
#define     DwtFetchLiteral                               dwtfetchliteral
#define     DwtFetchSetValues                             dwtfetchsetvalues
#define     DwtFetchWidget                                dwtfetchwidget
#define     DwtFetchWidgetOverride                        dwtfetchwidgetoverride
#define     DwtFileSelection                              dwtfileselection
#define     DwtFileSelectionCreate                        dwtfileselectioncreate
#define     DwtFileSelectionDoSearch                      dwtfileselectiondosearch
#define     DwtGetDisplay                                 dwtgetdisplay
#define     DwtGetNextSegment                             dwtgetnextsegment
#define     DwtGetScreen                                  dwtgetscreen
#define     DwtGetSlider                                  dwtgetslider
#define     DwtGetWindow                                  dwtgetwindow
#define     DwtHelp                                       dwthelp
#define     DwtHelpCreate                                 dwthelpcreate
#define     DwtInitGetSegment                             dwtinitgetsegment
#define     DwtInitializeDRM                              dwtinitializedrm
#define     DwtInquireNextPasteCount                      dwtinquirenextpastecount
#define     DwtInquireNextPasteFormat                     dwtinquirenextpasteformat
#define     DwtInquireNextPasteLength                     dwtinquirenextpastelength
#define     DwtLabel                                      dwtlabel
#define     DwtLabelCreate                                dwtlabelcreate
#define     DwtLabelGadgetCreate                          dwtlabelgadgetcreate
#define     DwtLatin1String                               dwtlatin1string
#define     DwtListBox                                    dwtlistbox
#define     DwtListBoxAddItem                             dwtlistboxadditem
#define     DwtListBoxCreate                              dwtlistboxcreate
#define     DwtListBoxDeleteItem                          dwtlistboxdeleteitem
#define     DwtListBoxDeletePos                           dwtlistboxdeletepos
#define     DwtListBoxDeselectAllItems                    dwtlistboxdeselectallitems
#define     DwtListBoxDeselectItem                        dwtlistboxdeselectitem
#define     DwtListBoxDeselectPos                         dwtlistboxdeselectpos
#define     DwtListBoxItemExists                          dwtlistboxitemexists
#define     DwtListBoxSelectItem                          dwtlistboxselectitem
#define     DwtListBoxSelectPos                           dwtlistboxselectpos
#define     DwtListBoxSetHorizPos                         dwtlistboxsethorizpos
#define     DwtListBoxSetItem                             dwtlistboxsetitem
#define     DwtListBoxSetPos                              dwtlistboxsetpos
#define     DwtListPendingItems                           dwtlistpendingitems
#define     DwtMainSetAreas                               dwtmainsetareas
#define     DwtMainWindow                                 dwtmainwindow
#define     DwtMainWindowCreate                           dwtmainwindowcreate
#define     DwtMenu                                       dwtmenu
#define     DwtMenuBar                                    dwtmenubar
#define     DwtMenuBarCreate                              dwtmenubarcreate
#define     DwtMenuCreate                                 dwtmenucreate
#define     DwtMenuPopupCreate                            dwtmenupopupcreate
#define     DwtMenuPulldownCreate                         dwtmenupulldowncreate
#define     DwtMessageBox                                 dwtmessagebox
#define     DwtMessageBoxCreate                           dwtmessageboxcreate
#define     DwtNumChildren                                dwtnumchildren
#define     DwtOpenHierarchy                              dwtopenhierarchy
#define     DwtOptionMenu                                 dwtoptionmenu
#define     DwtOptionMenuCreate                           dwtoptionmenucreate
#define     DwtPropAttributes                             dwtpropattributes
#define     DwtPullDownMenuEntry                          dwtpulldownmenuentry
#define     DwtPullDownMenuEntryCreate                    dwtpulldownmenuentrycreate
#define     DwtPullEntryGadgetCreate                      dwtpullentrygadgetcreate
#define     DwtPushButton                                 dwtpushbutton
#define     DwtPushButtonCreate                           dwtpushbuttoncreate
#define     DwtPushButtonGadgetCreate                     dwtpushbuttongadgetcreate
#define     DwtRadioBox                                   dwtradiobox
#define     DwtRadioBoxCreate                             dwtradioboxcreate
#define     DwtReCopyToClipboard                          dwtrecopytoclipboard
#define     DwtRegisterClass                              dwtregisterclass
#define     DwtRegisterDRMCallbacks                       dwtregisterdrmcallbacks
#define     DwtRegisterDRMNames                           dwtregisterdrmnames
#define     DwtSText                                      dwtstext
#define     DwtSTextCreate                                dwtstextcreate
#define     DwtSTextGetEditable                           dwtstextgeteditable
#define     DwtSTextGetMaxLength                          dwtstextgetmaxlength
#define     DwtSTextGetSelection                          dwtstextgetselection
#define     DwtSTextGetString                             dwtstextgetstring
#define     DwtSTextReplace                               dwtstextreplace
#define     DwtSTextSetEditable                           dwtstextseteditable
#define     DwtSTextSetMaxLength                          dwtstextsetmaxlength
#define     DwtSTextSetSelection                          dwtstextsetselection
#define     DwtSTextSetString                             dwtstextsetstring
#define     DwtScale                                      dwtscale
#define     DwtScaleCreate                                dwtscalecreate
#define     DwtScrollBar                                  dwtscrollbar
#define     DwtScrollBarCreate                            dwtscrollbarcreate
#define     DwtScrollBarGetSlider                         dwtscrollbargetslider
#define     DwtScrollBarSetSlider                         dwtscrollbarsetslider
#define     DwtScrollWindow                               dwtscrollwindow
#define     DwtScrollWindowCreate                         dwtscrollwindowcreate
#define     DwtScrollWindowSetAreas                       dwtscrollwindowsetareas
#define     DwtSelection                                  dwtselection
#define     DwtSelectionCreate                            dwtselectioncreate
#define     DwtSeparator                                  dwtseparator
#define     DwtSeparatorCreate                            dwtseparatorcreate
#define     DwtSeparatorGadgetCreate                      dwtseparatorgadgetcreate
#define     DwtSetArg                                     dwtsetarg
#define     DwtSetSlider                                  dwtsetslider
#define     DwtString                                     dwtstring
#define     DwtTextCreate                                 dwttextcreate
#define     DwtTextDisableRedisplay                       dwttextdisableredisplay
#define     DwtTextEnableRedisplay                        dwttextenableredisplay
#define     DwtTextGetInsertionPosition                   dwttextgetinsertionposition
#define     DwtTextGetSource                              dwttextgetsource
#define     DwtTextGetTopPosition                         dwttextgettopposition
#define     DwtTextScroll                                 dwttextscroll
#define     DwtTextSetInsertionPosition                   dwttextsetinsertionposition
#define     DwtTextSetSource                              dwttextsetsource
#define     DwtTextSetTopPosition                         dwttextsettopposition
#define     DwtTextShowPosition                           dwttextshowposition
#define     DwtToggleButton                               dwttogglebutton
#define     DwtToggleButtonCreate                         dwttogglebuttoncreate
#define     DwtToggleButtonGadgetCreate                   dwttogglebuttongadgetcreate
#define     DwtToggleButtonGetState                       dwttogglebuttongetstate
#define     DwtToggleButtonSetState                       dwttogglebuttonsetstate
#define     DwtUndoCopyToClipboard                        dwtundocopytoclipboard
#define     DwtWindow                                     dwtwindow
#define     DwtWindowCreate                               dwtwindowcreate
#define     DwtWorkBox                                    dwtworkbox
#define     DwtWorkBoxCreate                              dwtworkboxcreate
#define     Idb__BM_Decommit                              idb__bm_decommit
#define     Idb__BM_DecommitAll                           idb__bm_decommitall
#define     Idb__BM_GetBuffer                             idb__bm_getbuffer
#define     Idb__BM_GetRecord                             idb__bm_getrecord
#define     Idb__BM_InitBufferVector                      idb__bm_initbuffervector
#define     Idb__BM_InitDataRecord                        idb__bm_initdatarecord
#define     Idb__BM_InitRecord                            idb__bm_initrecord
#define     Idb__BM_MarkActivity                          idb__bm_markactivity
#define     Idb__BM_MarkModified                          idb__bm_markmodified
#define     Idb__DB_GetDataEntry                          idb__db_getdataentry
#define     Idb__DB_MatchFilter                           idb__db_matchfilter
#define     Idb__DB_PutDataEntry                          idb__db_putdataentry
#define     Idb__FIL_Valid                                idb__fil_valid
#define     Idb__FU_CloseFile                             idb__fu_closefile
#define     Idb__FU_GetBlock                              idb__fu_getblock
#define     Idb__FU_OpenFile                              idb__fu_openfile
#define     Idb__FU_PutBlock                              idb__fu_putblock
#define     Idb__HDR_EnterItem                            idb__hdr_enteritem
#define     Idb__HDR_GetDataEntry                         idb__hdr_getdataentry
#define     Idb__HDR_GetHeader                            idb__hdr_getheader
#define     Idb__HDR_InitHeader                           idb__hdr_initheader
#define     Idb__HDR_MatchFilter                          idb__hdr_matchfilter
#define     Idb__HDR_NextRID                              idb__hdr_nextrid
#define     Idb__HDR_PutDataEntry                         idb__hdr_putdataentry
#define     Idb__HDR_PutHeader                            idb__hdr_putheader
#define     Idb__HDR_ReturnItem                           idb__hdr_returnitem
#define     Idb__HDR_UpdateHeader                         idb__hdr_updateheader
#define     Idb__INX_CollapseLeafRecord                   idb__inx_collapseleafrecord
#define     Idb__INX_CollapseNodeRecord                   idb__inx_collapsenoderecord
#define     Idb__INX_ConfirmNodeSpace                     idb__inx_confirmnodespace
#define     Idb__INX_CopyLeafRecord                       idb__inx_copyleafrecord
#define     Idb__INX_CopyNodeRecord                       idb__inx_copynoderecord
#define     Idb__INX_EnterItem                            idb__inx_enteritem
#define     Idb__INX_EnterLeafIndex                       idb__inx_enterleafindex
#define     Idb__INX_EnterNodeIndex                       idb__inx_enternodeindex
#define     Idb__INX_FindIndex                            idb__inx_findindex
#define     Idb__INX_FindResources                        idb__inx_findresources
#define     Idb__INX_FixNodeChildren                      idb__inx_fixnodechildren
#define     Idb__INX_GetBtreeRecord                       idb__inx_getbtreerecord
#define     Idb__INX_InitRootLeafRecord                   idb__inx_initrootleafrecord
#define     Idb__INX_InitRootNodeRecord                   idb__inx_initrootnoderecord
#define     Idb__INX_ReturnItem                           idb__inx_returnitem
#define     Idb__INX_SearchIndex                          idb__inx_searchindex
#define     Idb__INX_SetParent                            idb__inx_setparent
#define     Idb__INX_SplitLeafRecord                      idb__inx_splitleafrecord
#define     Idb__INX_SplitNodeRecord                      idb__inx_splitnoderecord
#define     Idb__RID_AddRecord                            idb__rid_addrecord
#define     Idb__RID_EnterItem                            idb__rid_enteritem
#define     Idb__RID_NextRID                              idb__rid_nextrid
#define     Idb__RID_ReturnItem                           idb__rid_returnitem
#define     InitializeScrollBars                          initializescrollbars
#define     MrmCloseHierarchy                             mrmclosehierarchy
#define     MrmFetchBitmapLiteral                         mrmfetchbitmapliteral
#define     MrmFetchColorLiteral                          mrmfetchcolorliteral
#define     MrmFetchIconLiteral                           mrmfetchiconliteral
#define     MrmFetchInterfaceModule                       mrmfetchinterfacemodule
#define     MrmFetchLiteral                               mrmfetchliteral
#define     MrmFetchSetValues                             mrmfetchsetvalues
#define     MrmFetchWidget                                mrmfetchwidget
#define     MrmFetchWidgetOverride                        mrmfetchwidgetoverride
#define     MrmInitialize                                 mrminitialize
#define     MrmOpenHierarchy                              mrmopenhierarchy
#define     MrmRegisterClass                              mrmregisterclass
#define     MrmRegisterNames                              mrmregisternames
#define     MrmRegisterNamesInHierarchy                   mrmregisternamesinhierarchy
#define     SetMwmStuff                                   setmwmstuff
#define     UrmCWRInit                                    urmcwrinit
#define     UrmCWRInitArglist                             urmcwrinitarglist
#define     UrmCWRInitChildren                            urmcwrinitchildren
#define     UrmCWRSetArgCStringVec                        urmcwrsetargcstringvec
#define     UrmCWRSetArgCallback                          urmcwrsetargcallback
#define     UrmCWRSetArgChar8Vec                          urmcwrsetargchar8vec
#define     UrmCWRSetArgResourceRef                       urmcwrsetargresourceref
#define     UrmCWRSetArgValue                             urmcwrsetargvalue
#define     UrmCWRSetCallbackItem                         urmcwrsetcallbackitem
#define     UrmCWRSetCallbackItemRes                      urmcwrsetcallbackitemres
#define     UrmCWRSetChild                                urmcwrsetchild
#define     UrmCWRSetClass                                urmcwrsetclass
#define     UrmCWRSetComment                              urmcwrsetcomment
#define     UrmCWRSetCompressedArgTag                     urmcwrsetcompressedargtag
#define     UrmCWRSetCreationCallback                     urmcwrsetcreationcallback
#define     UrmCWRSetExtraArgs                            urmcwrsetextraargs
#define     UrmCWRSetUncompressedArgTag                   urmcwrsetuncompressedargtag
#define     UrmCWR__AppendCString                         urmcwr__appendcstring
#define     UrmCWR__AppendResource                        urmcwr__appendresource
#define     UrmCWR__AppendString                          urmcwr__appendstring
#define     UrmCWR__BindArgPtrs                           urmcwr__bindargptrs
#define     UrmCWR__BindCallbackPtrs                      urmcwr__bindcallbackptrs
#define     UrmCWR__GuaranteeSpace                        urmcwr__guaranteespace
#define     UrmCWR__ValidateContext                       urmcwr__validatecontext
#define     UrmColorTableSize                             urmcolortablesize
#define     UrmCopyAllocatedColorTable                    urmcopyallocatedcolortable
#define     UrmCopyAllocatedIconImage                     urmcopyallocatediconimage
#define     UrmCreateBitmap                               urmcreatebitmap
#define     UrmCreatePixmap                               urmcreatepixmap
#define     UrmCreateWidgetInstance                       urmcreatewidgetinstance
#define     UrmCreateWidgetTree                           urmcreatewidgettree
#define     UrmDestroyCallback                            urmdestroycallback
#define     UrmFetchSetValues                             urmfetchsetvalues
#define     UrmFreeResourceContext                        urmfreeresourcecontext
#define     UrmGetIndexedLiteral                          urmgetindexedliteral
#define     UrmGetIndexedWidget                           urmgetindexedwidget
#define     UrmGetRIDLiteral                              urmgetridliteral
#define     UrmGetRIDWidget                               urmgetridwidget
#define     UrmGetResourceContext                         urmgetresourcecontext
#define     UrmHGetIndexedLiteral                         urmhgetindexedliteral
#define     UrmHGetIndexedResource                        urmhgetindexedresource
#define     UrmHGetWidget                                 urmhgetwidget
#define     UrmIFMGetModule                               urmifmgetmodule
#define     UrmIFMHGetModule                              urmifmhgetmodule
#define     UrmIFMInitModule                              urmifminitmodule
#define     UrmIFMPutModule                               urmifmputmodule
#define     UrmIFMSetTopmost                              urmifmsettopmost
#define     UrmIconImageSize                              urmiconimagesize
#define     UrmIdbCloseFile                               urmidbclosefile
#define     UrmIdbFindIndexedResource                     urmidbfindindexedresource
#define     UrmIdbGetIndexedResource                      urmidbgetindexedresource
#define     UrmIdbGetRIDResource                          urmidbgetridresource
#define     UrmIdbGetResourceId                           urmidbgetresourceid
#define     UrmIdbOpenFileRead                            urmidbopenfileread
#define     UrmIdbOpenFileWrite                           urmidbopenfilewrite
#define     UrmIdbPutIndexedResource                      urmidbputindexedresource
#define     UrmIdbPutRIDResource                          urmidbputridresource
#define     UrmPlistAppendPointer                         urmplistappendpointer
#define     UrmPlistAppendString                          urmplistappendstring
#define     UrmPlistFindString                            urmplistfindstring
#define     UrmPlistFree                                  urmplistfree
#define     UrmPlistFreeContents                          urmplistfreecontents
#define     UrmPlistInit                                  urmplistinit
#define     UrmPlistResize                                urmplistresize
#define     UrmPutIndexedLiteral                          urmputindexedliteral
#define     UrmPutIndexedWidget                           urmputindexedwidget
#define     UrmPutRIDLiteral                              urmputridliteral
#define     UrmPutRIDWidget                               urmputridwidget
#define     UrmResizeResourceContext                      urmresizeresourcecontext
#define     Urm__CW_AddWRef                               urm__cw_addwref
#define     Urm__CW_AppendSVWidgetRef                     urm__cw_appendsvwidgetref
#define     Urm__CW_ConvertValue                          urm__cw_convertvalue
#define     Urm__CW_CreateArglist                         urm__cw_createarglist
#define     Urm__CW_DisplayToString                       urm__cw_displaytostring
#define     Urm__CW_EvaluateValOrOffset                   urm__cw_evaluatevaloroffset
#define     Urm__CW_FindWRef                              urm__cw_findwref
#define     Urm__CW_FixupCallback                         urm__cw_fixupcallback
#define     Urm__CW_FixupValue                            urm__cw_fixupvalue
#define     Urm__CW_GetPixmapParms                        urm__cw_getpixmapparms
#define     Urm__CW_InitWRef                              urm__cw_initwref
#define     Urm__CW_LoadIconImage                         urm__cw_loadiconimage
#define     Urm__CW_LoadWidgetResource                    urm__cw_loadwidgetresource
#define     Urm__CW_ReadBitmapFile                        urm__cw_readbitmapfile
#define     Urm__CW_ReadLiteral                           urm__cw_readliteral
#define     Urm__CW_SafeCopyValue                         urm__cw_safecopyvalue
#define     Urm__CW_UpdateSVWidgetRef                     urm__cw_updatesvwidgetref
#define     Urm__CloseHierarchy                           urm__closehierarchy
#define     Urm__FetchLiteral                             urm__fetchliteral
#define     Urm__FindClassDescriptor                      urm__findclassdescriptor
#define     Urm__FixupCompressionTable                    urm__fixupcompressiontable
#define     Urm__HGetIndexedLiteral                       urm__hgetindexedliteral
#define     Urm__IsSubtreeResource                        urm__issubtreeresource
#define     Urm__LookupNameInHierarchy                    urm__lookupnameinhierarchy
#define     Urm__MapIconAllocate                          urm__mapiconallocate
#define     Urm__MapIconBitmap                            urm__mapiconbitmap
#define     Urm__MapIconBitmapDepth1                      urm__mapiconbitmapdepth1
#define     Urm__MapIconReplace                           urm__mapiconreplace
#define     Urm__OpenHierarchy                            urm__openhierarchy
#define     Urm__RealizeColorTable                        urm__realizecolortable
#define     Urm__RegisterNamesInHierarchy                 urm__registernamesinhierarchy
#define     Urm__UT_AllocString                           urm__ut_allocstring
#define     Urm__UT_Error                                 urm__ut_error
#define     Urm__UT_GetColorPixel                         urm__ut_getcolorpixel
#define     Urm__UT_GetNamedColorPixel                    urm__ut_getnamedcolorpixel
#define     Urm__UT_LatestErrorCode                       urm__ut_latesterrorcode
#define     Urm__UT_LatestErrorMessage                    urm__ut_latesterrormessage
#define     Urm__UT_SetErrorReport                        urm__ut_seterrorreport
#define     Urm__UT_Time                                  urm__ut_time
#define     Urm__UT_UrmCodeString                         urm__ut_urmcodestring
#define     Urm__UncompressCode                           urm__uncompresscode
#define     Urm__WCI_GetClRecOfName                       urm__wci_getclrecofname
#define     Urm__WCI_LookupClassDescriptor                urm__wci_lookupclassdescriptor
#define     Urm__WCI_LookupRegisteredName                 urm__wci_lookupregisteredname
#define     Urm__WCI_RegisterNames                        urm__wci_registernames
#define     WmGetDECWmHints                               wmgetdecwmhints
#define     WmGetDecorationGeoemtery                      wmgetdecorationgeoemtery
#define     WmGetIconBoxName                              wmgeticonboxname
#define     WmSetDECWmHints                               wmsetdecwmhints
#define     WmSetDecorationGeometry                       wmsetdecorationgeometry
#define     WmSetIconBoxName                              wmseticonboxname
#define     WrapGetFontNames                              wrapgetfontnames
#define     WrapGetNumFonts                               wrapgetnumfonts
#define     XAddExtension                                 xaddextension
#define     XAllPlanes                                    xallplanes
#define     XAllocClassHint                               xallocclasshint
#define     XAllocColor                                   xalloccolor
#define     XAllocColorCells                              xalloccolorcells
#define     XAllocColorPlanes                             xalloccolorplanes
#define     XAllocIconSize                                xallociconsize
#define     XAllocNamedColor                              xallocnamedcolor
#define     XAllocSizeHints                               xallocsizehints
#define     XAllocStandardColormap                        xallocstandardcolormap
#define     XAllocWMHints                                 xallocwmhints
#define     XBitmapBitOrder                               xbitmapbitorder
#define     XBitmapPad                                    xbitmappad
#define     XBitmapUnit                                   xbitmapunit
#define     XBlackPixel                                   xblackpixel
#define     XBlackPixelOfScreen                           xblackpixelofscreen
#define     XCellsOfScreen                                xcellsofscreen
#define     XCheckIfEvent                                 xcheckifevent
#define     XCheckMaskEvent                               xcheckmaskevent
#define     XCheckTypedEvent                              xchecktypedevent
#define     XCheckTypedWindowEvent                        xchecktypedwindowevent
#define     XCheckWindowEvent                             xcheckwindowevent
#define     XConnectionNumber                             xconnectionnumber
#define     XCopyArea			                  xcopyarea
#define     XCopyColormapAndFree                          xcopycolormapandfree
#define     XCreateBitmapFromData                         xcreatebitmapfromdata
#define     XCreateColormap                               xcreatecolormap
#define     XCreateFontCursor                             xcreatefontcursor
#define     XCreateGC                                     xcreategc
#define     XCreateGlyphCursor                            xcreateglyphcursor
#define     XCreateImage                                  xcreateimage
#define     XCreatePixmap                                 xcreatepixmap
#define     XCreatePixmapCursor                           xcreatepixmapcursor
#define     XCreatePixmapFromBitmapData                   xcreatepixmapfrombitmapdata
#define     XCreateRegion                                 xcreateregion
#define     XCreateSimpleWindow                           xcreatesimplewindow
#define     XCreateWindow                                 xcreatewindow
#define     XDefaultColormap                              xdefaultcolormap
#define     XDefaultColormapOfScreen                      xdefaultcolormapofscreen
#define     XDefaultDepth                                 xdefaultdepth
#define     XDefaultDepthOfScreen                         xdefaultdepthofscreen
#define     XDefaultGC                                    xdefaultgc
#define     XDefaultGCOfScreen                            xdefaultgcofscreen
#define     XDefaultRootWindow                            xdefaultrootwindow
#define     XDefaultScreen                                xdefaultscreen
#define     XDefaultScreenOfDisplay                       xdefaultscreenofdisplay
#define     XDefaultVisual                                xdefaultvisual
#define     XDefaultVisualOfScreen                        xdefaultvisualofscreen
#define     XDefineCursor                                 xdefinecursor
#define     XDeleteContext                                xdeletecontext
#define     XDeleteModifiermapEntry                       xdeletemodifiermapentry
#define     XDisplayCells                                 xdisplaycells
#define     XDisplayHeight                                xdisplayheight
#define     XDisplayHeightMM                              xdisplayheightmm
#define     XDisplayMotionBufferSize                      xdisplaymotionbuffersize
#define     XDisplayName                                  xdisplayname
#define     XDisplayOfScreen                              xdisplayofscreen
#define     XDisplayPlanes                                xdisplayplanes
#define     XDisplayString                                xdisplaystring
#define     XDisplayWidth                                 xdisplaywidth
#define     XDisplayWidthMM                               xdisplaywidthmm
#define     XDrawLine                                     xdrawline
#define     XDrawString                                   xdrawstring
#define     XDoesBackingStore                             xdoesbackingstore
#define     XDoesSaveUnders                               xdoessaveunders
#define     XEHeadOfExtensionList                         xeheadofextensionlist
#define     XEventMaskOfScreen                            xeventmaskofscreen
#define     XEventsQueued                                 xeventsqueued
#define     XFetchBuffer                                  xfetchbuffer
#define     XFetchBytes                                   xfetchbytes
#define     XFetchName                                    xfetchname
#define     XFindContext                                  xfindcontext
#define     XFindOnExtensionList                          xfindonextensionlist
#define     XFillArc                                      xfillarc
#define     XFillPolygon                                  xfillpolygon
#define     XFillRectangle                                xfillrectangle
#define     XFillRectangles                               xfillrectangles
#define     XFlush                                        xflush
#define     XFree                                         xfree
#define     XFreeCursor                                   xfreecursor
#define     XFreeFont                                     xfreefont
#define     XFreeFontNames                                xfreefontnames
#define     XFreeGC                                       xfreegc
#define     XFreePixmap                                   xfreepixmap
#define     XFreeStringList                               xfreestringlist
#define     XGContextFromGC                               xgcontextfromgc
#define     XGeometry                                     xgeometry
#define     XGetAtomName                                  xgetatomname
#define     XGetClassHint                                 xgetclasshint
#define     XGetCommand                                   xgetcommand
#define     XGetDefault                                   xgetdefault
#define     XGetFontPath                                  xgetfontpath
#define     XGetFontProperty                              xgetfontproperty
#define     XGetGCValues                                  xgetgcvalues
#define     XGetGeometry                                  xgetgeometry
#define     XGetIconName                                  xgeticonname
#define     XGetIconSizes                                 xgeticonsizes
#define     XGetIconWindow                                xgeticonwindow
#define     XGetImage                                     xgetimage
#define     XGetKeyboardMapping                           xgetkeyboardmapping
#define     XGetModifierMapping                           xgetmodifiermapping
#define     XGetMotionEvents                              xgetmotionevents
#define     XGetNormalHints                               xgetnormalhints
#define     XGetPointerMapping                            xgetpointermapping
#define     XGetRGBColormaps                              xgetrgbcolormaps
#define     XGetSelectionOwner                            xgetselectionowner
#define     XGetSizeHints                                 xgetsizehints
#define     XGetStandardColormap                          xgetstandardcolormap
#define     XGetSubImage                                  xgetsubimage
#define     XGetTextProperty                              xgettextproperty
#define     XGetTransientForHint                          xgettransientforhint
#define     XGetVisualInfo                                xgetvisualinfo
#define     XGetWMClientMachine                           xgetwmclientmachine
#define     XGetWMColormapWindows                         xgetwmcolormapwindows
#define     XGetWMHints                                   xgetwmhints
#define     XGetWMIconName                                xgetwmiconname
#define     XGetWMName                                    xgetwmname
#define     XGetWMNormalHints                             xgetwmnormalhints
#define     XGetWMProtocols                               xgetwmprotocols
#define     XGetWMSizeHints                               xgetwmsizehints
#define     XGetWindowAttributes                          xgetwindowattributes
#define     XGetWindowProperty                            xgetwindowproperty
#define     XGetZoomHints                                 xgetzoomhints
#define     XGrabKeyboard                                 xgrabkeyboard
#define     XGrabPointer                                  xgrabpointer
#define     XHeightMMOfScreen                             xheightmmofscreen
#define     XHeightOfScreen                               xheightofscreen
#define     XIconifyWindow                                xiconifywindow
#define     XImageByteOrder                               ximagebyteorder
#define     XInitExtension                                xinitextension
#define     XInsertModifiermapEntry                       xinsertmodifiermapentry
#define     XInternAtom                                   xinternatom
#define     XKeycodeToKeysym                              xkeycodetokeysym
#define     XKeysymToKeycode                              xkeysymtokeycode
#define     XKeysymToString                               xkeysymtostring
#define     XLastKnownRequestProcessed                    xlastknownrequestprocessed
#define     XListDepths                                   xlistdepths
#define     XListExtensions                               xlistextensions
#define     XListFonts                                    xlistfonts
#define     XListFontsWithInfo                            xlistfontswithinfo
#define     XListHosts                                    xlisthosts
#define     XListInstalledColormaps                       xlistinstalledcolormaps
#define     XListPixmapFormats                            xlistpixmapformats
#define     XListProperties                               xlistproperties
#define     XLoadFont                                     xloadfont
#define     XLoadQueryFont                                xloadqueryfont
#define     XLookupColor                                  xlookupcolor
#define     XLookupKeysym                                 xlookupkeysym
#define     XLookupString                                 xlookupstring
#define     XMatchVisualInfo                              xmatchvisualinfo
#define     XMaxCmapsOfScreen                             xmaxcmapsofscreen
#define     XMaxRequestSize                               xmaxrequestsize
#define     XMinCmapsOfScreen                             xmincmapsofscreen
#define     XMissingExtension                             xmissingextension
#define     XNewModifiermap                               xnewmodifiermap
#define     XNextRequest                                  xnextrequest
#define     XOpenDisplay                                  xopendisplay
#define     XParseColor                                   xparsecolor
#define     XParseGeometry                                xparsegeometry
#define     XPending                                      xpending
#define     XPlanesOfScreen                               xplanesofscreen
#define     XPointInRegion                                xpointinregion
#define     XPolygonRegion                                xpolygonregion
#define     XProtocolRevision                             xprotocolrevision
#define     XProtocolVersion                              xprotocolversion
#define     XQLength                                      xqlength
#define     XQueryBestCursor                              xquerybestcursor
#define     XQueryBestSize                                xquerybestsize
#define     XQueryBestStipple                             xquerybeststipple
#define     XQueryBestTile                                xquerybesttile
#define     XQueryExtension                               xqueryextension
#define     XQueryFont                                    xqueryfont
#define     XQueryPointer                                 xquerypointer
#define     XQueryTree                                    xquerytree
#define     XRaiseWindow                                  xraisewindow
#define     XReadBitmapFile                               xreadbitmapfile
#define     XReconfigureWMWindow                          xreconfigurewmwindow
#define     XRectInRegion                                 xrectinregion
#define     XResourceManagerString                        xresourcemanagerstring
#define     XRootWindow                                   xrootwindow
#define     XRootWindowOfScreen                           xrootwindowofscreen
#define     XSaveContext                                  xsavecontext
#define     XScreenCount                                  xscreencount
#define     XScreenNumberOfScreen                         xscreennumberofscreen
#define     XScreenOfDisplay                              xscreenofdisplay
#define     XSendEvent                                    xsendevent
#define     XServerVendor                                 xservervendor
#define     XSetBackground                                xsetbackground
#define     XSetClassHint                                 xsetclasshint
#define     XSetErrorHandler                              xseterrorhandler
#define     XSetForeground                                xsetforeground
#define     XSetFunction                                  xsetfunction
#define     XSetIOErrorHandler                            xsetioerrorhandler
#define     XSetLineAttributes                            xsetlineattributes
#define     XSetModifierMapping                           xsetmodifiermapping
#define     XSetPointerMapping                            xsetpointermapping
#define     XSetRGBColormaps                              xsetrgbcolormaps
#define     XSetStandardColormap                          xsetstandardcolormap
#define     XSetTextProperty                              xsettextproperty
#define     XSetTransientForHint                          xsettransientforhint
#define     XSetWMClientMachine                           xsetwmclientmachine
#define     XSetWMColormapWindows                         xsetwmcolormapwindows
#define     XSetWMIconName                                xsetwmiconname
#define     XSetWMName                                    xsetwmname
#define     XSetWMNormalHints                             xsetwmnormalhints
#define     XSetWMProperties                              xsetwmproperties
#define     XSetWMProtocols                               xsetwmprotocols
#define     XSetWMSizeHints                               xsetwmsizehints
#define     XShapeCombineMask                             xshapecombinemask
#define     XShapeCombineRectangles                       xshapecombinerectangles
#define     XShapeCombineRegion                           xshapecombineregion
#define     XShapeCombineShape                            xshapecombineshape
#define     XShapeGetRectangles                           xshapegetrectangles
#define     XShapeInputSelected                           xshapeinputselected
#define     XShapeOffsetShape                             xshapeoffsetshape
#define     XShapeQueryExtension                          xshapequeryextension
#define     XShapeQueryExtents                            xshapequeryextents
#define     XShapeQueryVersion                            xshapequeryversion
#define     XShapeSelectInput                             xshapeselectinput
#define     XStringListToTextProperty                     xstringlisttotextproperty
#define     XStringToKeysym                               xstringtokeysym
#define     XTextPropertyToStringList                     xtextpropertytostringlist
#define     XTextWidth                                    xtextwidth
#define     XTextWidth16                                  xtextwidth16
#define     XTranslateCoordinates                         xtranslatecoordinates
#define     XUniqueContext                                xuniquecontext
#define     XUndefineCursor                               xundefinecursor
#define     XUnmapWindow                                  xunmapwindow
#define     XVendorRelease                                xvendorrelease
#define     XVisualIDFromVisual                           xvisualidfromvisual
#define     XWMGeometry                                   xwmgeometry
#define     XWhitePixel                                   xwhitepixel
#define     XWhitePixelOfScreen                           xwhitepixelofscreen
#define     XWidthMMOfScreen                              xwidthmmofscreen
#define     XWidthOfScreen                                xwidthofscreen
#define     XWithdrawWindow                               xwithdrawwindow
#define     XWriteBitmapFile                              xwritebitmapfile
#define     XextAddDisplay                                xextadddisplay
#define     XextCreateExtension                           xextcreateextension
#define     XextDestroyExtension                          xextdestroyextension
#define     XextFindDisplay                               xextfinddisplay
#define     XextRemoveDisplay                             xextremovedisplay
#define     XmActivateProtocol                            xmactivateprotocol
#define     XmAddProtocolCallback                         xmaddprotocolcallback
#define     XmAddProtocols                                xmaddprotocols
#define     XmAddTabGroup                                 xmaddtabgroup
#define     XmCascadeButtonGadgetHighlight                xmcascadebuttongadgethighlight
#define     XmCascadeButtonHighlight                      xmcascadebuttonhighlight
#define     XmClipboardBeginCopy                          xmclipboardbegincopy
#define     XmClipboardCancelCopy                         xmclipboardcancelcopy
#define     XmClipboardCopy                               xmclipboardcopy
#define     XmClipboardCopyByName                         xmclipboardcopybyname
#define     XmClipboardEndCopy                            xmclipboardendcopy
#define     XmClipboardEndRetrieve                        xmclipboardendretrieve
#define     XmClipboardInquireCount                       xmclipboardinquirecount
#define     XmClipboardInquireFormat                      xmclipboardinquireformat
#define     XmClipboardInquireLength                      xmclipboardinquirelength
#define     XmClipboardInquirePendingItems                xmclipboardinquirependingitems
#define     XmClipboardLock                               xmclipboardlock
#define     XmClipboardRegisterFormat                     xmclipboardregisterformat
#define     XmClipboardRetrieve                           xmclipboardretrieve
#define     XmClipboardStartCopy                          xmclipboardstartcopy
#define     XmClipboardStartRetrieve                      xmclipboardstartretrieve
#define     XmClipboardUndoCopy                           xmclipboardundocopy
#define     XmClipboardUnlock                             xmclipboardunlock
#define     XmClipboardWithdrawFormat                     xmclipboardwithdrawformat
#define     XmCloseHierarchy                              xmclosehierarchy
#define     XmCommandAppendValue                          xmcommandappendvalue
#define     XmCommandError                                xmcommanderror
#define     XmCommandGetChild                             xmcommandgetchild
#define     XmCommandSetValue                             xmcommandsetvalue
#define     XmConvertUnits                                xmconvertunits
#define     XmCreateArrowButton                           xmcreatearrowbutton
#define     XmCreateArrowButtonGadget                     xmcreatearrowbuttongadget
#define     XmCreateBulletinBoard                         xmcreatebulletinboard
#define     XmCreateBulletinBoardDialog                   xmcreatebulletinboarddialog
#define     XmCreateCascadeButton                         xmcreatecascadebutton
#define     XmCreateCascadeButtonGadget                   xmcreatecascadebuttongadget
#define     XmCreateCommand                               xmcreatecommand
#define     XmCreateDialogShell                           xmcreatedialogshell
#define     XmCreateDrawingArea                           xmcreatedrawingarea
#define     XmCreateDrawnButton                           xmcreatedrawnbutton
#define     XmCreateErrorDialog                           xmcreateerrordialog
#define     XmCreateFileSelectionBox                      xmcreatefileselectionbox
#define     XmCreateFileSelectionDialog                   xmcreatefileselectiondialog
#define     XmCreateForm                                  xmcreateform
#define     XmCreateFormDialog                            xmcreateformdialog
#define     XmCreateFrame                                 xmcreateframe
#define     XmCreateInformationDialog                     xmcreateinformationdialog
#define     XmCreateLabel                                 xmcreatelabel
#define     XmCreateLabelGadget                           xmcreatelabelgadget
#define     XmCreateList                                  xmcreatelist
#define     XmCreateMainWindow                            xmcreatemainwindow
#define     XmCreateMenuBar                               xmcreatemenubar
#define     XmCreateMenuShell                             xmcreatemenushell
#define     XmCreateMessageBox                            xmcreatemessagebox
#define     XmCreateMessageDialog                         xmcreatemessagedialog
#define     XmCreateOptionMenu                            xmcreateoptionmenu
#define     XmCreatePanedWindow                           xmcreatepanedwindow
#define     XmCreatePopupMenu                             xmcreatepopupmenu
#define     XmCreatePromptDialog                          xmcreatepromptdialog
#define     XmCreatePulldownMenu                          xmcreatepulldownmenu
#define     XmCreatePushButton                            xmcreatepushbutton
#define     XmCreatePushButtonGadget                      xmcreatepushbuttongadget
#define     XmCreateQuestionDialog                        xmcreatequestiondialog
#define     XmCreateRadioBox                              xmcreateradiobox
#define     XmCreateRowColumn                             xmcreaterowcolumn
#define     XmCreateScale                                 xmcreatescale
#define     XmCreateScrollBar                             xmcreatescrollbar
#define     XmCreateScrolledList                          xmcreatescrolledlist
#define     XmCreateScrolledText                          xmcreatescrolledtext
#define     XmCreateScrolledWindow                        xmcreatescrolledwindow
#define     XmCreateSelectionBox                          xmcreateselectionbox
#define     XmCreateSelectionDialog                       xmcreateselectiondialog
#define     XmCreateSeparator                             xmcreateseparator
#define     XmCreateSeparatorGadget                       xmcreateseparatorgadget
#define     XmCreateText                                  xmcreatetext
#define     XmCreateTextField                             xmcreatetextfield
#define     XmCreateToggleButton                          xmcreatetogglebutton
#define     XmCreateToggleButtonGadget                    xmcreatetogglebuttongadget
#define     XmCreateWarningDialog                         xmcreatewarningdialog
#define     XmCreateWorkArea                              xmcreateworkarea
#define     XmCreateWorkingDialog                         xmcreateworkingdialog
#define     XmCvtCTToXmString                             xmcvtcttoxmstring
#define     XmCvtFromHorizontalPixels                     xmcvtfromhorizontalpixels
#define     XmCvtFromVerticalPixels                       xmcvtfromverticalpixels
#define     XmCvtStringToUnitType                         xmcvtstringtounittype
#define     XmCvtTextToXmString                           xmcvttexttoxmstring
#define     XmCvtToHorizontalPixels                       xmcvttohorizontalpixels
#define     XmCvtToVerticalPixels                         xmcvttoverticalpixels
#define     XmCvtXmStringToCT                             xmcvtxmstringtoct
#define     XmCvtXmStringToText                           xmcvtxmstringtotext
#define     XmDeactivateProtocol                          xmdeactivateprotocol
#define     XmDestroyPixmap                               xmdestroypixmap
#define     XmDrmFreeResourceContext                      xmdrmfreeresourcecontext
#define     XmDrmGetResourceContext                       xmdrmgetresourcecontext
#define     XmDrmResizeResourceContext                    xmdrmresizeresourcecontext
#define     XmFetchColorLiteral                           xmfetchcolorliteral
#define     XmFetchIconLiteral                            xmfetchiconliteral
#define     XmFetchInterfaceModule                        xmfetchinterfacemodule
#define     XmFetchLiteral                                xmfetchliteral
#define     XmFetchSetValues                              xmfetchsetvalues
#define     XmFetchWidget                                 xmfetchwidget
#define     XmFetchWidgetOverride                         xmfetchwidgetoverride
#define     XmFileSelectionBoxGetChild                    xmfileselectionboxgetchild
#define     XmFileSelectionDoSearch                       xmfileselectiondosearch
#define     XmFontListAdd                                 xmfontlistadd
#define     XmFontListCopy                                xmfontlistcopy
#define     XmFontListCreate                              xmfontlistcreate
#define     XmFontListFree                                xmfontlistfree
#define     XmFontListFreeFontContext                     xmfontlistfreefontcontext
#define     XmFontListGetNextFont                         xmfontlistgetnextfont
#define     XmFontListInitFontContext                     xmfontlistinitfontcontext
#define     XmGetAtomName                                 xmgetatomname
#define     XmGetDestination                              xmgetdestination
#define     XmGetMenuCursor                               xmgetmenucursor
#define     XmGetPixmap                                   xmgetpixmap
#define     XmGetPostedFromWidget                         xmgetpostedfromwidget
#define     XmGetSecondaryResourceData                    xmgetsecondaryresourcedata
#define     XmInitializeDRM                               xminitializedrm
#define     XmInstallImage                                xminstallimage
#define     XmInternAtom                                  xminternatom
#define     XmIsMotifWMRunning                            xmismotifwmrunning
#define     XmListAddItem                                 xmlistadditem
#define     XmListAddItemUnselected                       xmlistadditemunselected
#define     XmListAddItems                                xmlistadditems
#define     XmListDeleteAllItems                          xmlistdeleteallitems
#define     XmListDeleteItem                              xmlistdeleteitem
#define     XmListDeleteItems                             xmlistdeleteitems
#define     XmListDeleteItemsPos                          xmlistdeleteitemspos
#define     XmListDeletePos                               xmlistdeletepos
#define     XmListDeselectAllItems                        xmlistdeselectallitems
#define     XmListDeselectItem                            xmlistdeselectitem
#define     XmListDeselectPos                             xmlistdeselectpos
#define     XmListGetMatchPos                             xmlistgetmatchpos
#define     XmListGetSelectedPos                          xmlistgetselectedpos
#define     XmListItemExists                              xmlistitemexists
#define     XmListItemPos                                 xmlistitempos
#define     XmListReplaceItems                            xmlistreplaceitems
#define     XmListReplaceItemsPos                         xmlistreplaceitemspos
#define     XmListSelectItem                              xmlistselectitem
#define     XmListSelectPos                               xmlistselectpos
#define     XmListSetAddMode                              xmlistsetaddmode
#define     XmListSetBottomItem                           xmlistsetbottomitem
#define     XmListSetBottomPos                            xmlistsetbottompos
#define     XmListSetHorizPos                             xmlistsethorizpos
#define     XmListSetItem                                 xmlistsetitem
#define     XmListSetPos                                  xmlistsetpos
#define     XmMainWindowSep1                              xmmainwindowsep1
#define     XmMainWindowSep2                              xmmainwindowsep2
#define     XmMainWindowSep3                              xmmainwindowsep3
#define     XmMainWindowSetAreas                          xmmainwindowsetareas
#define     XmMenuPosition                                xmmenuposition
#define     XmMessageBoxGetChild                          xmmessageboxgetchild
#define     XmOpenHierarchy                               xmopenhierarchy
#define     XmOptionButtonGadget                          xmoptionbuttongadget
#define     XmOptionLabelGadget                           xmoptionlabelgadget
#define     XmProcessTraversal                            xmprocesstraversal
#define     XmRegisterClass                               xmregisterclass
#define     XmRegisterConverters                          xmregisterconverters
#define     XmRegisterDRMCallbacks                        xmregisterdrmcallbacks
#define     XmRegisterDRMNames                            xmregisterdrmnames
#define     XmRegisterMrmCallbacks                        xmregistermrmcallbacks
#define     XmRemoveProtocolCallback                      xmremoveprotocolcallback
#define     XmRemoveProtocols                             xmremoveprotocols
#define     XmRemoveTabGroup                              xmremovetabgroup
#define     XmResolveAllPartOffsets                       xmresolveallpartoffsets
#define     XmResolvePartOffsets                          xmresolvepartoffsets
#define     XmScaleGetValue                               xmscalegetvalue
#define     XmScaleSetValue                               xmscalesetvalue
#define     XmScrollBarGetValues                          xmscrollbargetvalues
#define     XmScrollBarSetValues                          xmscrollbarsetvalues
#define     XmScrolledWindowSetAreas                      xmscrolledwindowsetareas
#define     XmSelectionBoxGetChild                        xmselectionboxgetchild
#define     XmSetFontUnit                                 xmsetfontunit
#define     XmSetFontUnits                                xmsetfontunits
#define     XmSetMenuCursor                               xmsetmenucursor
#define     XmSetProtocolHooks                            xmsetprotocolhooks
#define     XmStringBaseline                              xmstringbaseline
#define     XmStringByteCompare                           xmstringbytecompare
#define     XmStringCheck                                 xmstringcheck
#define     XmStringCompare                               xmstringcompare
#define     XmStringConcat                                xmstringconcat
#define     XmStringCopy                                  xmstringcopy
#define     XmStringCreate                                xmstringcreate
#define     XmStringCreateExternal                        xmstringcreateexternal
#define     XmStringCreateFontList                        xmstringcreatefontlist
#define     XmStringCreateLtoR                            xmstringcreateltor
#define     XmStringCreateSimple                          xmstringcreatesimple
#define     XmStringDirectionCreate                       xmstringdirectioncreate
#define     XmStringDraw                                  xmstringdraw
#define     XmStringDrawImage                             xmstringdrawimage
#define     XmStringDrawUnderline                         xmstringdrawunderline
#define     XmStringEmpty                                 xmstringempty
#define     XmStringExtent                                xmstringextent
#define     XmStringFree                                  xmstringfree
#define     XmStringFreeContext                           xmstringfreecontext
#define     XmStringGetLtoR                               xmstringgetltor
#define     XmStringGetNextComponent                      xmstringgetnextcomponent
#define     XmStringGetNextSegment                        xmstringgetnextsegment
#define     XmStringHasSubstring                          xmstringhassubstring
#define     XmStringHeight                                xmstringheight
#define     XmStringInitContext                           xmstringinitcontext
#define     XmStringLength                                xmstringlength
#define     XmStringLineCount                             xmstringlinecount
#define     XmStringLtoRCreate                            xmstringltorcreate
#define     XmStringNConcat                               xmstringnconcat
#define     XmStringNCopy                                 xmstringncopy
#define     XmStringPeekNextComponent                     xmstringpeeknextcomponent
#define     XmStringSegmentCreate                         xmstringsegmentcreate
#define     XmStringSeparatorCreate                       xmstringseparatorcreate
#define     XmStringWidth                                 xmstringwidth
#define     XmTextClearSelection                          xmtextclearselection
#define     XmTextCopy                                    xmtextcopy
#define     XmTextCut                                     xmtextcut
#define     XmTextFieldClearSelection                     xmtextfieldclearselection
#define     XmTextFieldCopy                               xmtextfieldcopy
#define     XmTextFieldCut                                xmtextfieldcut
#define     XmTextFieldGetAddMode                         xmtextfieldgetaddmode
#define     XmTextFieldGetBaseLine                        xmtextfieldgetbaseline
#define     XmTextFieldGetBaseLine                        xmtextfieldgetbaseline
#define     XmTextFieldGetCursorPosition                  xmtextfieldgetcursorposition
#define     XmTextFieldGetEditable                        xmtextfieldgeteditable
#define     XmTextFieldGetInsertionPosition               xmtextfieldgetinsertionposition
#define     XmTextFieldGetLastPosition                    xmtextfieldgetlastposition
#define     XmTextFieldGetMaxLength                       xmtextfieldgetmaxlength
#define     XmTextFieldGetSelection                       xmtextfieldgetselection
#define     XmTextFieldGetSelectionPosition               xmtextfieldgetselectionposition
#define     XmTextFieldGetString                          xmtextfieldgetstring
#define     XmTextFieldInsert                             xmtextfieldinsert
#define     XmTextFieldPaste                              xmtextfieldpaste
#define     XmTextFieldPosToXY                            xmtextfieldpostoxy
#define     XmTextFieldRemove                             xmtextfieldremove
#define     XmTextFieldReplace                            xmtextfieldreplace
#define     XmTextFieldSetAddMode                         xmtextfieldsetaddmode
#define     XmTextFieldSetCursorPosition                  xmtextfieldsetcursorposition
#define     XmTextFieldSetEditable                        xmtextfieldseteditable
#define     XmTextFieldSetHighlight                       xmtextfieldsethighlight
#define     XmTextFieldSetInsertionPosition               xmtextfieldsetinsertionposition
#define     XmTextFieldSetMaxLength                       xmtextfieldsetmaxlength
#define     XmTextFieldSetSelection                       xmtextfieldsetselection
#define     XmTextFieldSetString                          xmtextfieldsetstring
#define     XmTextFieldShowPosition                       xmtextfieldshowposition
#define     XmTextFieldXYToPos                            xmtextfieldxytopos
#define     XmTextGetAddMode                              xmtextgetaddmode
#define     XmTextGetCursorPosition                       xmtextgetcursorposition
#define     XmTextGetEditable                             xmtextgeteditable
#define     XmTextGetInsertionPosition                    xmtextgetinsertionposition
#define     XmTextGetLastPosition                         xmtextgetlastposition
#define     XmTextGetMaxLength                            xmtextgetmaxlength
#define     XmTextGetSelection                            xmtextgetselection
#define     XmTextGetSelectionPosition                    xmtextgetselectionposition
#define     XmTextGetSource                               xmtextgetsource
#define     XmTextGetString                               xmtextgetstring
#define     XmTextGetTopCharacter                         xmtextgettopcharacter
#define     XmTextInsert                                  xmtextinsert
#define     XmTextPaste                                   xmtextpaste
#define     XmTextPosToXY                                 xmtextpostoxy
#define     XmTextRemove                                  xmtextremove
#define     XmTextReplace                                 xmtextreplace
#define     XmTextScroll                                  xmtextscroll
#define     XmTextSetAddMode                              xmtextsetaddmode
#define     XmTextSetCursorPosition                       xmtextsetcursorposition
#define     XmTextSetEditable                             xmtextseteditable
#define     XmTextSetHighlight                            xmtextsethighlight
#define     XmTextSetInsertionPosition                    xmtextsetinsertionposition
#define     XmTextSetMaxLength                            xmtextsetmaxlength
#define     XmTextSetSelection                            xmtextsetselection
#define     XmTextSetSource                               xmtextsetsource
#define     XmTextSetString                               xmtextsetstring
#define     XmTextSetTopCharacter                         xmtextsettopcharacter
#define     XmTextShowPosition                            xmtextshowposition
#define     XmTextXYToPos                                 xmtextxytopos
#define     XmToggleButtonGadgetGetState                  xmtogglebuttongadgetgetstate
#define     XmToggleButtonGadgetSetState                  xmtogglebuttongadgetsetstate
#define     XmToggleButtonGetState                        xmtogglebuttongetstate
#define     XmToggleButtonSetState                        xmtogglebuttonsetstate
#define     XmTrackingLocate                              xmtrackinglocate
#define     XmUninstallImage                              xmuninstallimage
#define     XmUpdateDisplay                               xmupdatedisplay
#define     XmVaCreateSimpleCheckBox                      xmvacreatesimplecheckbox
#define     XmVaCreateSimpleMenuBar                       xmvacreatesimplemenubar
#define     XmVaCreateSimpleOptionMenu                    xmvacreatesimpleoptionmenu
#define     XmVaCreateSimplePopupMenu                     xmvacreatesimplepopupmenu
#define     XmVaCreateSimplePulldownMenu                  xmvacreatesimplepulldownmenu
#define     XmVaCreateSimpleRadioBox                      xmvacreatesimpleradiobox
#define     XmbufChangeBufferAttributes                   xmbufchangebufferattributes
#define     XmbufChangeWindowAttributes                   xmbufchangewindowattributes
#define     XmbufCreateBuffers                            xmbufcreatebuffers
#define     XmbufCreateStereoWindow                       xmbufcreatestereowindow
#define     XmbufDestroyBuffers                           xmbufdestroybuffers
#define     XmbufDisplayBuffers                           xmbufdisplaybuffers
#define     XmbufGetBufferAttributes                      xmbufgetbufferattributes
#define     XmbufGetScreenInfo                            xmbufgetscreeninfo
#define     XmbufGetVersion                               xmbufgetversion
#define     XmbufGetWindowAttributes                      xmbufgetwindowattributes
#define     XmbufQueryExtension                           xmbufqueryextension
#define     Xpermalloc                                    xpermalloc
#define     XrmCompileResourceList                        xrmcompileresourcelist
#define     XrmDestroyDatabase                            xrmdestroydatabase
#define     XrmGetFileDatabase                            xrmgetfiledatabase
#define     XrmGetResource                                xrmgetresource
#define     XrmGetStringDatabase                          xrmgetstringdatabase
#define     XrmInitialize                                 xrminitialize
#define     XrmMergeDatabases                             xrmmergedatabases
#define     XrmParseCommand                               xrmparsecommand
#define     XrmPutFileDatabase                            xrmputfiledatabase
#define     XrmPutLineResource                            xrmputlineresource
#define     XrmPutResource                                xrmputresource
#define     XrmPutStringResource                          xrmputstringresource
#define     XrmQGetSearchList                             xrmqgetsearchlist
#define     XrmQGetSearchResource                         xrmqgetsearchresource
#define     XrmQPutResource                               xrmqputresource
#define     XrmQPutStringResource                         xrmqputstringresource
#define     XrmQuarkToString                              xrmquarktostring
#define     XrmStringToBindingQuarkList                   xrmstringtobindingquarklist
#define     XrmStringToQuark                              xrmstringtoquark
#define     XrmStringToQuarkList                          xrmstringtoquarklist
#define     XrmUniqueQuark                                xrmuniquequark
#define     XtAddActions                                  xtaddactions
#define     XtAddCallback                                 xtaddcallback
#define     XtAddCallbacks                                xtaddcallbacks
#define     XtAddConverter                                xtaddconverter
#define     XtAddEventHandler                             xtaddeventhandler
#define     XtAddExposureToRegion                         xtaddexposuretoregion
#define     XtAddGrab                                     xtaddgrab
#define     XtAddInput                                    xtaddinput
#define     XtAddRawEventHandler                          xtaddraweventhandler
#define     XtAddTimeOut                                  xtaddtimeout
#define     XtAddWorkProc                                 xtaddworkproc
#define     XtAppAddActionHook                            xtappaddactionhook
#define     XtAppAddActions                               xtappaddactions
#define     XtAppAddConverter                             xtappaddconverter
#define     XtAppAddInput                                 xtappaddinput
#define     XtAppAddTimeOut                               xtappaddtimeout
#define     XtAppAddWorkProc                              xtappaddworkproc
#define     XtAppCreateShell                              xtappcreateshell
#define     XtAppError                                    xtapperror
#define     XtAppErrorMsg                                 xtapperrormsg
#define     XtAppGetErrorDatabase                         xtappgeterrordatabase
#define     XtAppGetErrorDatabaseText                     xtappgeterrordatabasetext
#define     XtAppGetSelectionTimeout                      xtappgetselectiontimeout
#define     XtAppInitialize                               xtappinitialize
#define     XtAppMainLoop                                 xtappmainloop
#define     XtAppNextEvent                                xtappnextevent
#define     XtAppPeekEvent                                xtapppeekevent
#define     XtAppPending                                  xtapppending
#define     XtAppProcessEvent                             xtappprocessevent
#define     XtAppSetErrorHandler                          xtappseterrorhandler
#define     XtAppSetErrorMsgHandler                       xtappseterrormsghandler
#define     XtAppSetFallbackResources                     xtappsetfallbackresources
#define     XtAppSetSelectionTimeout                      xtappsetselectiontimeout
#define     XtAppSetTypeConverter                         xtappsettypeconverter
#define     XtAppSetWarningHandler                        xtappsetwarninghandler
#define     XtAppSetWarningMsgHandler                     xtappsetwarningmsghandler
#define     XtAppWarning                                  xtappwarning
#define     XtAppWarningMsg                               xtappwarningmsg
#define     XtAugmentTranslations                         xtaugmenttranslations
#define     XtBuildEventMask                              xtbuildeventmask
#define     XtCallAcceptFocus                             xtcallacceptfocus
#define     XtCallActionProc                              xtcallactionproc
#define     XtCallCallbackList                            xtcallcallbacklist
#define     XtCallCallbacks                               xtcallcallbacks
#define     XtCallConverter                               xtcallconverter
#define     XtCallbackExclusive                           xtcallbackexclusive
#define     XtCallbackNone                                xtcallbacknone
#define     XtCallbackNonexclusive                        xtcallbacknonexclusive
#define     XtCallbackPopdown                             xtcallbackpopdown
#define     XtCallbackReleaseCacheRef                     xtcallbackreleasecacheref
#define     XtCallbackReleaseCacheRefList                 xtcallbackreleasecachereflist
#define     XtCalloc                                      xtcalloc
#define     XtClass                                       xtclass
#define     XtCloseDisplay                                xtclosedisplay
#define     XtConfigureWidget                             xtconfigurewidget
#define     XtConvert                                     xtconvert
#define     XtConvertAndStore                             xtconvertandstore
#define     XtConvertCase                                 xtconvertcase
#define     XtCopyAncestorSensitive                       xtcopyancestorsensitive
#define     XtCopyDefaultColormap                         xtcopydefaultcolormap
#define     XtCopyDefaultDepth                            xtcopydefaultdepth
#define     XtCopyFromParent                              xtcopyfromparent
#define     XtCopyScreen                                  xtcopyscreen
#define     XtCreateApplicationContext                    xtcreateapplicationcontext
#define     XtCreateApplicationShell                      xtcreateapplicationshell
#define     XtCreateManagedWidget                         xtcreatemanagedwidget
#define     XtCreatePopupShell                            xtcreatepopupshell
#define     XtCreateWidget                                xtcreatewidget
#define     XtCreateWindow                                xtcreatewindow
#define     XtDatabase                                    xtdatabase
#define     XtDestroyApplicationContext                   xtdestroyapplicationcontext
#define     XtDestroyGC                                   xtdestroygc
#define     XtDestroyWidget                               xtdestroywidget
#define     XtDirectConvert                               xtdirectconvert
#define     XtDisownSelection                             xtdisownselection
#define     XtDispatchEvent                               xtdispatchevent
#define     XtDisplay                                     xtdisplay
#define     XtDisplayInitialize                           xtdisplayinitialize
#define     XtDisplayOfObject                             xtdisplayofobject
#define     XtDisplayStringConvWarning                    xtdisplaystringconvwarning
#define     XtDisplayToApplicationContext                 xtdisplaytoapplicationcontext
#define     XtError                                       xterror
#define     XtErrorMsg                                    xterrormsg
#define     XtFindFile                                    xtfindfile
#define     XtFree                                        xtfree
#define     XtGetActionKeysym                             xtgetactionkeysym
#define     XtGetApplicationNameAndClass                  xtgetapplicationnameandclass
#define     XtGetApplicationResources                     xtgetapplicationresources
#define     XtGetConstraintResourceList                   xtgetconstraintresourcelist
#define     XtGetErrorDatabase                            xtgeterrordatabase
#define     XtGetErrorDatabaseText                        xtgeterrordatabasetext
#define     XtGetGC                                       xtgetgc
#define     XtGetKeysymTable                              xtgetkeysymtable
#define     XtGetMultiClickTime                           xtgetmulticlicktime
#define     XtGetResourceList                             xtgetresourcelist
#define     XtGetSelectionRequest                         xtgetselectionrequest
#define     XtGetSelectionTimeout                         xtgetselectiontimeout
#define     XtGetSelectionValue                           xtgetselectionvalue
#define     XtGetSelectionValueIncremental                xtgetselectionvalueincremental
#define     XtGetSelectionValues                          xtgetselectionvalues
#define     XtGetSelectionValuesIncremental               xtgetselectionvaluesincremental
#define     XtGetSubresources                             xtgetsubresources
#define     XtGetSubvalues                                xtgetsubvalues
#define     XtGetValues                                   xtgetvalues
#define     XtGrabButton                                  xtgrabbutton
#define     XtGrabKey                                     xtgrabkey
#define     XtGrabKeyboard                                xtgrabkeyboard
#define     XtGrabPointer                                 xtgrabpointer
#define     XtHasCallbacks                                xthascallbacks
#define     XtInitialize                                  xtinitialize
#define     XtInitializeWidgetClass                       xtinitializewidgetclass
#define     XtInsertEventHandler                          xtinserteventhandler
#define     XtInsertRawEventHandler                       xtinsertraweventhandler
#define     XtInstallAccelerators                         xtinstallaccelerators
#define     XtInstallAllAccelerators                      xtinstallallaccelerators
#define     XtIsManaged                                   xtismanaged
#define     XtIsObject                                    xtisobject
#define     XtIsRealized                                  xtisrealized
#define     XtIsSensitive                                 xtissensitive
#define     XtIsSubclass                                  xtissubclass
#define     XtKeysymToKeycodeList                         xtkeysymtokeycodelist
#define     XtLastTimestampProcessed                      xtlasttimestampprocessed
#define     XtMainLoop                                    xtmainloop
#define     XtMakeGeometryRequest                         xtmakegeometryrequest
#define     XtMakeResizeRequest                           xtmakeresizerequest
#define     XtMalloc                                      xtmalloc
#define     XtManageChild                                 xtmanagechild
#define     XtManageChildren                              xtmanagechildren
#define     XtMenuPopupAction                             xtmenupopupaction
#define     XtMergeArgLists                               xtmergearglists
#define     XtMoveWidget                                  xtmovewidget
#define     XtName                                        xtname
#define     XtNameToWidget                                xtnametowidget
#define     XtNextEvent                                   xtnextevent
#define     XtOpenDisplay                                 xtopendisplay
#define     XtOverrideTranslations                        xtoverridetranslations
#define     XtOwnSelection                                xtownselection
#define     XtOwnSelectionIncremental                     xtownselectionincremental
#define     XtParent                                      xtparent
#define     XtParseAcceleratorTable                       xtparseacceleratortable
#define     XtParseTranslationTable                       xtparsetranslationtable
#define     XtPeekEvent                                   xtpeekevent
#define     XtPending                                     xtpending
#define     XtPopdown                                     xtpopdown
#define     XtPopup                                       xtpopup
#define     XtPopupSpringLoaded                           xtpopupspringloaded
#define     XtProcessEvent                                xtprocessevent
#define     XtQueryGeometry                               xtquerygeometry
#define     XtRealizeWidget                               xtrealizewidget
#define     XtRealloc                                     xtrealloc
#define     XtRegisterCaseConverter                       xtregistercaseconverter
#define     XtRegisterGrabAction                          xtregistergrabaction
#define     XtReleaseCacheRef                             xtreleasecacheref
#define     XtReleaseGC                                   xtreleasegc
#define     XtRemoveActionHook                            xtremoveactionhook
#define     XtRemoveAllCallbacks                          xtremoveallcallbacks
#define     XtRemoveCallback                              xtremovecallback
#define     XtRemoveCallbacks                             xtremovecallbacks
#define     XtRemoveEventHandler                          xtremoveeventhandler
#define     XtRemoveGrab                                  xtremovegrab
#define     XtRemoveInput                                 xtremoveinput
#define     XtRemoveRawEventHandler                       xtremoveraweventhandler
#define     XtRemoveTimeOut                               xtremovetimeout
#define     XtRemoveWorkProc                              xtremoveworkproc
#define     XtResizeWidget                                xtresizewidget
#define     XtResolvePathname                             xtresolvepathname
#define     XtScreen                                      xtscreen
#define     XtScreenOfObject                              xtscreenofobject
#define     XtSetErrorHandler                             xtseterrorhandler
#define     XtSetErrorMsgHandler                          xtseterrormsghandler
#define     XtSetKeyTranslator                            xtsetkeytranslator
#define     XtSetKeyboardFocus                            xtsetkeyboardfocus
#define     XtSetMappedWhenManaged                        xtsetmappedwhenmanaged
#define     XtSetMultiClickTime                           xtsetmulticlicktime
#define     XtSetSelectionTimeout                         xtsetselectiontimeout
#define     XtSetSensitive                                xtsetsensitive
#define     XtSetSubvalues                                xtsetsubvalues
#define     XtSetTypeConverter                            xtsettypeconverter
#define     XtSetValues                                   xtsetvalues
#define     XtSetWMColormapWindows                        xtsetwmcolormapwindows
#define     XtSetWarningHandler                           xtsetwarninghandler
#define     XtSetWarningMsgHandler                        xtsetwarningmsghandler
#define     XtStringConversionWarning                     xtstringconversionwarning
#define     XtSuperclass                                  xtsuperclass
#define     XtToolkitInitialize                           xttoolkitinitialize
#define     XtTranslateCoords                             xttranslatecoords
#define     XtTranslateKey                                xttranslatekey
#define     XtTranslateKeycode                            xttranslatekeycode
#define     XtUngrabButton                                xtungrabbutton
#define     XtUngrabKey                                   xtungrabkey
#define     XtUngrabKeyboard                              xtungrabkeyboard
#define     XtUngrabPointer                               xtungrabpointer
#define     XtUninstallTranslations                       xtuninstalltranslations
#define     XtUnmanageChild                               xtunmanagechild
#define     XtUnmanageChildren                            xtunmanagechildren
#define     XtVaAppCreateShell                            xtvaappcreateshell
#define     XtVaAppInitialize                             xtvaappinitialize
#define     XtVaCreateArgsList                            xtvacreateargslist
#define     XtVaCreateManagedWidget                       xtvacreatemanagedwidget
#define     XtVaCreatePopupShell                          xtvacreatepopupshell
#define     XtVaCreateWidget                              xtvacreatewidget
#define     XtVaGetApplicationResources                   xtvagetapplicationresources
#define     XtVaGetSubresources                           xtvagetsubresources
#define     XtVaGetSubvalues                              xtvagetsubvalues
#define     XtVaGetValues                                 xtvagetvalues
#define     XtVaSetSubvalues                              xtvasetsubvalues
#define     XtVaSetValues                                 xtvasetvalues
#define     XtWarning                                     xtwarning
#define     XtWarningMsg                                  xtwarningmsg
#define     XtWidgetToApplicationContext                  xtwidgettoapplicationcontext
#define     XtWindow                                      xtwindow
#define     XtWindowOfObject                              xtwindowofobject
#define     XtWindowToWidget                              xtwindowtowidget
#define     _DXmColorMixGetApplyLabelStr                  _dxmcolormixgetapplylabelstr
#define     _DXmColorMixGetBlkLabelStr                    _dxmcolormixgetblklabelstr
#define     _DXmColorMixGetBluLabelStr                    _dxmcolormixgetblulabelstr
#define     _DXmColorMixGetBrowserLabelStr                _dxmcolormixgetbrowserlabelstr
#define     _DXmColorMixGetCancelLabelStr                 _dxmcolormixgetcancellabelstr
#define     _DXmColorMixGetClearLabelStr                  _dxmcolormixgetclearlabelstr
#define     _DXmColorMixGetCoolerLabelStr                 _dxmcolormixgetcoolerlabelstr
#define     _DXmColorMixGetDarkerLabelStr                 _dxmcolormixgetdarkerlabelstr
#define     _DXmColorMixGetDispLabelStr                   _dxmcolormixgetdisplabelstr
#define     _DXmColorMixGetEarthLabelStr                  _dxmcolormixgetearthlabelstr
#define     _DXmColorMixGetFulLabelStr                    _dxmcolormixgetfullabelstr
#define     _DXmColorMixGetGreysclLabelStr                _dxmcolormixgetgreyscllabelstr
#define     _DXmColorMixGetGrnLabelStr                    _dxmcolormixgetgrnlabelstr
#define     _DXmColorMixGetGryLabelStr                    _dxmcolormixgetgrylabelstr
#define     _DXmColorMixGetHLSLabelStr                    _dxmcolormixgethlslabelstr
#define     _DXmColorMixGetHelpLabelStr                   _dxmcolormixgethelplabelstr
#define     _DXmColorMixGetHueLabelStr                    _dxmcolormixgethuelabelstr
#define     _DXmColorMixGetITitleLabelStr                 _dxmcolormixgetititlelabelstr
#define     _DXmColorMixGetLightLabelStr                  _dxmcolormixgetlightlabelstr
#define     _DXmColorMixGetLighterLabelStr                _dxmcolormixgetlighterlabelstr
#define     _DXmColorMixGetMainLabelStr                   _dxmcolormixgetmainlabelstr
#define     _DXmColorMixGetMetallicLabelStr               _dxmcolormixgetmetalliclabelstr
#define     _DXmColorMixGetMixLabelStr                    _dxmcolormixgetmixlabelstr
#define     _DXmColorMixGetOkLabelStr                     _dxmcolormixgetoklabelstr
#define     _DXmColorMixGetOptLabelStr                    _dxmcolormixgetoptlabelstr
#define     _DXmColorMixGetPTitleLabelStr                 _dxmcolormixgetptitlelabelstr
#define     _DXmColorMixGetPastelLabelStr                 _dxmcolormixgetpastellabelstr
#define     _DXmColorMixGetPickerLabelStr                 _dxmcolormixgetpickerlabelstr
#define     _DXmColorMixGetRGBLabelStr                    _dxmcolormixgetrgblabelstr
#define     _DXmColorMixGetRedLabelStr                    _dxmcolormixgetredlabelstr
#define     _DXmColorMixGetResetLabelStr                  _dxmcolormixgetresetlabelstr
#define     _DXmColorMixGetSPInfoLabelStr                 _dxmcolormixgetspinfolabelstr
#define     _DXmColorMixGetSPLabelStr                     _dxmcolormixgetsplabelstr
#define     _DXmColorMixGetSatLabelStr                    _dxmcolormixgetsatlabelstr
#define     _DXmColorMixGetSldLabelStr                    _dxmcolormixgetsldlabelstr
#define     _DXmColorMixGetSmearLabelStr                  _dxmcolormixgetsmearlabelstr
#define     _DXmColorMixGetSpectrumLabelStr               _dxmcolormixgetspectrumlabelstr
#define     _DXmColorMixGetUndoLabelStr                   _dxmcolormixgetundolabelstr
#define     _DXmColorMixGetUserPalLabelStr                _dxmcolormixgetuserpallabelstr
#define     _DXmColorMixGetValLabelStr                    _dxmcolormixgetvallabelstr
#define     _DXmColorMixGetWarmerLabelStr                 _dxmcolormixgetwarmerlabelstr
#define     _DXmColorMixGetWhtLabelStr                    _dxmcolormixgetwhtlabelstr
#define     _DXmCreateWaitCursor                          _dxmcreatewaitcursor
#define     _PSWindowGetXYAndMatrix                       _pswindowgetxyandmatrix
#define     _PSWindowInit                                 _pswindowinit
#define     _PSWindowSetGCDrawable                        _pswindowsetgcdrawable



#define     _XmArrowPixmapCacheDelete                     _xmarrowpixmapcachedelete
#define     _XmBB_CreateButtonG                           _xmbb_createbuttong
#define     _XmBB_CreateLabelG                            _xmbb_createlabelg
#define     _XmBB_GetDialogTitle                          _xmbb_getdialogtitle
#define     _XmBaseClassPartInitialize                    _xmbaseclasspartinitialize
#define     _XmBuildGadgetResources                       _xmbuildgadgetresources
#define     _XmBuildManagerResources                      _xmbuildmanagerresources
#define     _XmBuildPrimitiveResources                    _xmbuildprimitiveresources
#define     _XmBulletinBoardCancel                        _xmbulletinboardcancel
#define     _XmBulletinBoardFocusMoved                    _xmbulletinboardfocusmoved
#define     _XmBulletinBoardReturn                        _xmbulletinboardreturn
#define     _XmBulletinBoardSetDefaultShadow              _xmbulletinboardsetdefaultshadow
#define     _XmBulletinBoardSetDynDefaultButton           _xmbulletinboardsetdyndefaultbutton
#define     _XmBulletinBoardSizeUpdate                    _xmbulletinboardsizeupdate
#define     _XmCacheCompare                               _xmcachecompare
#define     _XmCacheCopy                                  _xmcachecopy
#define     _XmCacheDelete                                _xmcachedelete
#define     _XmCachePart                                  _xmcachepart
#define     _XmCallFocusMoved                             _xmcallfocusmoved
#define     _XmChangeNavigationType                       _xmchangenavigationtype
#define     _XmCharsetCanonicalize                        _xmcharsetcanonicalize
#define     _XmClearFocusPath                             _xmclearfocuspath
#define     _XmClearKbdFocus                              _xmclearkbdfocus
#define     _XmClearRect                                  _xmclearrect
#define     _XmClearShadowType                            _xmclearshadowtype
#define     _XmClearTabGroup                              _xmcleartabgroup
#define     _XmCommandReturn                              _xmcommandreturn
#define     _XmCommandUpOrDown                            _xmcommandupordown
#define     _XmConfigureObject                            _xmconfigureobject
#define     _XmConvertUnits                               _xmconvertunits
#define     _XmCreateFocusData                            _xmcreatefocusdata
#define     _XmCreateVisibilityRect                       _xmcreatevisibilityrect
#define     _XmDestroyFocusData                           _xmdestroyfocusdata
#define     _XmDestroyParentCallback                      _xmdestroyparentcallback
#define     _XmDifferentBackground                        _xmdifferentbackground
#define     _XmDispatchGadgetInput                        _xmdispatchgadgetinput
#define     _XmDoGadgetTraversal                          _xmdogadgettraversal
#define     _XmDrawBorder                                 _xmdrawborder
#define     _XmDrawShadow                                 _xmdrawshadow
#define     _XmDrawShadowType                             _xmdrawshadowtype
#define     _XmDrawingAreaInput                           _xmdrawingareainput
#define     _XmEmptyRect                                  _xmemptyrect
#define     _XmEnterGadget                                _xmentergadget
#define     _XmEraseShadow                                _xmeraseshadow
#define     _XmFileSBGeoMatrixCreate                      _xmfilesbgeomatrixcreate
#define     _XmFileSelectionBoxCreateDirList              _xmfileselectionboxcreatedirlist
#define     _XmFileSelectionBoxCreateDirListLabel         _xmfileselectionboxcreatedirlistlabel
#define     _XmFileSelectionBoxCreateFilterLabel          _xmfileselectionboxcreatefilterlabel
#define     _XmFileSelectionBoxCreateFilterText           _xmfileselectionboxcreatefiltertext
#define     _XmFileSelectionBoxFocusMoved                 _xmfileselectionboxfocusmoved
#define     _XmFileSelectionBoxGetDirListItemCount        _xmfileselectionboxgetdirlistitemcount
#define     _XmFileSelectionBoxGetDirListItems            _xmfileselectionboxgetdirlistitems
#define     _XmFileSelectionBoxGetDirListLabelString      _xmfileselectionboxgetdirlistlabelstring
#define     _XmFileSelectionBoxGetDirMask                 _xmfileselectionboxgetdirmask
#define     _XmFileSelectionBoxGetDirectory               _xmfileselectionboxgetdirectory
#define     _XmFileSelectionBoxGetFilterLabelString       _xmfileselectionboxgetfilterlabelstring
#define     _XmFileSelectionBoxGetListItemCount           _xmfileselectionboxgetlistitemcount
#define     _XmFileSelectionBoxGetListItems               _xmfileselectionboxgetlistitems
#define     _XmFileSelectionBoxGetNoMatchString           _xmfileselectionboxgetnomatchstring
#define     _XmFileSelectionBoxGetPattern                 _xmfileselectionboxgetpattern
#define     _XmFileSelectionBoxNoGeoRequest               _xmfileselectionboxnogeorequest
#define     _XmFileSelectionBoxRestore                    _xmfileselectionboxrestore
#define     _XmFileSelectionBoxUpOrDown                   _xmfileselectionboxupordown
#define     _XmFindNextTabGroup                           _xmfindnexttabgroup
#define     _XmFindPrevTabGroup                           _xmfindprevtabgroup
#define     _XmFindTabGroup                               _xmfindtabgroup
#define     _XmFindTopMostShell                           _xmfindtopmostshell
#define     _XmFindTraversablePrim                        _xmfindtraversableprim
#define     _XmFocusInGadget                              _xmfocusingadget
#define     _XmFocusIsHere                                _xmfocusishere
#define     _XmFocusModelChanged                          _xmfocusmodelchanged
#define     _XmFocusOutGadget                             _xmfocusoutgadget
#define     _XmFontListGetDefaultFont                     _xmfontlistgetdefaultfont
#define     _XmFontListSearch                             _xmfontlistsearch
#define     _XmFreeWidgetExtData                          _xmfreewidgetextdata
#define     _XmFreeWrapperData                            _xmfreewrapperdata
#define     _XmFromHorizontalPixels                       _xmfromhorizontalpixels
#define     _XmFromVerticalPixels                         _xmfromverticalpixels
#define     _XmGadgetActivate                             _xmgadgetactivate
#define     _XmGadgetArm                                  _xmgadgetarm
#define     _XmGadgetButtonMotion                         _xmgadgetbuttonmotion
#define     _XmGadgetGetValuesHook                        _xmgadgetgetvalueshook
#define     _XmGadgetImportArgs                           _xmgadgetimportargs
#define     _XmGadgetKeyInput                             _xmgadgetkeyinput
#define     _XmGadgetMultiActivate                        _xmgadgetmultiactivate
#define     _XmGadgetMultiArm                             _xmgadgetmultiarm
#define     _XmGadgetSelect                               _xmgadgetselect
#define     _XmGadgetTraverseDown                         _xmgadgettraversedown
#define     _XmGadgetTraverseHome                         _xmgadgettraversehome
#define     _XmGadgetTraverseLeft                         _xmgadgettraverseleft
#define     _XmGadgetTraverseNext                         _xmgadgettraversenext
#define     _XmGadgetTraverseNextTabGroup                 _xmgadgettraversenexttabgroup
#define     _XmGadgetTraversePrev                         _xmgadgettraverseprev
#define     _XmGadgetTraversePrevTabGroup                 _xmgadgettraverseprevtabgroup
#define     _XmGadgetTraverseRight                        _xmgadgettraverseright
#define     _XmGadgetTraverseUp                           _xmgadgettraverseup
#define     _XmGeoAdjustBoxes                             _xmgeoadjustboxes
#define     _XmGeoArrangeBoxes                            _xmgeoarrangeboxes
#define     _XmGeoBoxesSameHeight                         _xmgeoboxessameheight
#define     _XmGeoBoxesSameWidth                          _xmgeoboxessamewidth
#define     _XmGeoGetDimensions                           _xmgeogetdimensions
#define     _XmGeoMatrixAlloc                             _xmgeomatrixalloc
#define     _XmGeoMatrixGet                               _xmgeomatrixget
#define     _XmGeoMatrixSet                               _xmgeomatrixset
#define     _XmGeoReplyYes                                _xmgeoreplyyes
#define     _XmGeoSetupKid                                _xmgeosetupkid
#define     _XmGeometryEqual                              _xmgeometryequal
#define     _XmGetActiveItem                              _xmgetactiveitem
#define     _XmGetArrowDrawRects                          _xmgetarrowdrawrects
#define     _XmGetClassExtensionPtr                       _xmgetclassextensionptr
#define     _XmGetDefaultFontList                         _xmgetdefaultfontlist
#define     _XmGetDisplayObject                           _xmgetdisplayobject
#define     _XmGetFocusData                               _xmgetfocusdata
#define     _XmGetFocusPolicy                             _xmgetfocuspolicy
#define     _XmGetFocusResetFlag                          _xmgetfocusresetflag
#define     _XmGetKidGeo                                  _xmgetkidgeo
#define     _XmGetManagedInfo                             _xmgetmanagedinfo
#define     _XmGetRealXlations                            _xmgetrealxlations
#define     _XmGetScreenObject                            _xmgetscreenobject
#define     _XmGetTabGroup                                _xmgettabgroup
#define     _XmGetTransientFlag                           _xmgettransientflag
#define     _XmGetWidgetExtData                           _xmgetwidgetextdata
#define     _XmGetWorldObject                             _xmgetworldobject
#define     _XmGetWrapperData                             _xmgetwrapperdata
#define     _XmGrabTheFocus                               _xmgrabthefocus
#define     _XmHandleGeometryManager                      _xmhandlegeometrymanager
#define     _XmHandleQueryGeometry                        _xmhandlequerygeometry
#define     _XmHandleSizeUpdate                           _xmhandlesizeupdate
#define     _XmHighlightBorder                            _xmhighlightborder
#define     _XmInitializeExtensions                       _xminitializeextensions
#define     _XmInputForGadget                             _xminputforgadget
#define     _XmInputInGadget                              _xminputingadget
#define     _XmInstallProtocols                           _xminstallprotocols
#define     _XmIntersectRect                              _xmintersectrect
#define     _XmIsSlowSubclass                             _xmisslowsubclass
#define     _XmLabelCacheCompare                          _xmlabelcachecompare
#define     _XmLeaveGadget                                _xmleavegadget
#define     _XmMakeGeometryRequest                        _xmmakegeometryrequest
#define     _XmManagerEnter                               _xmmanagerenter
#define     _XmManagerFocusIn                             _xmmanagerfocusin
#define     _XmManagerFocusInInternal                     _xmmanagerfocusininternal
#define     _XmManagerFocusOut                            _xmmanagerfocusout
#define     _XmManagerGetValuesHook                       _xmmanagergetvalueshook
#define     _XmManagerHelp                                _xmmanagerhelp
#define     _XmManagerImportArgs                          _xmmanagerimportargs
#define     _XmManagerLeave                               _xmmanagerleave
#define     _XmManagerUnmap                               _xmmanagerunmap
#define     _XmManagerVisibility                          _xmmanagervisibility
#define     _XmMenuFocus                                  _xmmenufocus
#define     _XmMessageBoxGeoMatrixCreate                  _xmmessageboxgeomatrixcreate
#define     _XmMessageBoxNoGeoRequest                     _xmmessageboxnogeorequest
#define     _XmMgrTraversal                               _xmmgrtraversal
#define     _XmMoveObject                                 _xmmoveobject
#define     _XmNavigChangeManaged                         _xmnavigchangemanaged
#define     _XmNavigDestroy                               _xmnavigdestroy
#define     _XmNavigInitialize                            _xmnaviginitialize
#define     _XmNavigSetValues                             _xmnavigsetvalues
#define     _XmOffsetArrow                                _xmoffsetarrow
#define     _XmParentProcess                              _xmparentprocess
#define     _XmPopWidgetExtData                           _xmpopwidgetextdata
#define     _XmPrimitiveEnter                             _xmprimitiveenter
#define     _XmPrimitiveFocusIn                           _xmprimitivefocusin
#define     _XmPrimitiveFocusInInternal                   _xmprimitivefocusininternal
#define     _XmPrimitiveFocusOut                          _xmprimitivefocusout
#define     _XmPrimitiveGetValuesHook                     _xmprimitivegetvalueshook
#define     _XmPrimitiveHelp                              _xmprimitivehelp
#define     _XmPrimitiveImportArgs                        _xmprimitiveimportargs
#define     _XmPrimitiveLeave                             _xmprimitiveleave
#define     _XmPrimitiveUnmap                             _xmprimitiveunmap
#define     _XmProcessTraversal                           _xmprocesstraversal
#define     _XmPushWidgetExtData                          _xmpushwidgetextdata
#define     _XmRC_GetLabelString                          _xmrc_getlabelstring
#define     _XmRC_GetMenuAccelerator                      _xmrc_getmenuaccelerator
#define     _XmRC_GetMnemonicCharSet                      _xmrc_getmnemoniccharset
#define     _XmReManageChildren                           _xmremanagechildren
#define     _XmRedisplayGadgets                           _xmredisplaygadgets
#define     _XmResizeObject                               _xmresizeobject
#define     _XmScaleGetTitleString                        _xmscalegettitlestring
#define     _XmSelectionBoxCreateApplyButton              _xmselectionboxcreateapplybutton
#define     _XmSelectionBoxCreateCancelButton             _xmselectionboxcreatecancelbutton
#define     _XmSelectionBoxCreateHelpButton               _xmselectionboxcreatehelpbutton
#define     _XmSelectionBoxCreateList                     _xmselectionboxcreatelist
#define     _XmSelectionBoxCreateListLabel                _xmselectionboxcreatelistlabel
#define     _XmSelectionBoxCreateOkButton                 _xmselectionboxcreateokbutton
#define     _XmSelectionBoxCreateSelectionLabel           _xmselectionboxcreateselectionlabel
#define     _XmSelectionBoxCreateSeparator                _xmselectionboxcreateseparator
#define     _XmSelectionBoxCreateText                     _xmselectionboxcreatetext
#define     _XmSelectionBoxGeoMatrixCreate                _xmselectionboxgeomatrixcreate
#define     _XmSelectionBoxGetApplyLabelString            _xmselectionboxgetapplylabelstring
#define     _XmSelectionBoxGetCancelLabelString           _xmselectionboxgetcancellabelstring
#define     _XmSelectionBoxGetHelpLabelString             _xmselectionboxgethelplabelstring
#define     _XmSelectionBoxGetListItemCount               _xmselectionboxgetlistitemcount
#define     _XmSelectionBoxGetListItems                   _xmselectionboxgetlistitems
#define     _XmSelectionBoxGetListLabelString             _xmselectionboxgetlistlabelstring
#define     _XmSelectionBoxGetListVisibleItemCount        _xmselectionboxgetlistvisibleitemcount
#define     _XmSelectionBoxGetOkLabelString               _xmselectionboxgetoklabelstring
#define     _XmSelectionBoxGetSelectionLabelString        _xmselectionboxgetselectionlabelstring
#define     _XmSelectionBoxGetTextColumns                 _xmselectionboxgettextcolumns
#define     _XmSelectionBoxGetTextString                  _xmselectionboxgettextstring
#define     _XmSelectionBoxNoGeoRequest                   _xmselectionboxnogeorequest
#define     _XmSelectionBoxRestore                        _xmselectionboxrestore
#define     _XmSelectionBoxUpOrDown                       _xmselectionboxupordown
#define     _XmSeparatorFix                               _xmseparatorfix
#define     _XmSetActiveTabGroup                          _xmsetactivetabgroup
#define     _XmSetDestination                             _xmsetdestination
#define     _XmSetEtchedSlider                            _xmsetetchedslider
#define     _XmSetFocusResetFlag                          _xmsetfocusresetflag
#define     _XmSetKidGeo                                  _xmsetkidgeo
#define     _XmSetRect                                    _xmsetrect
#define     _XmSetTransientFlag                           _xmsettransientflag
#define     _XmShellGetValuesHook                         _xmshellgetvalueshook
#define     _XmShellImportArgs                            _xmshellimportargs
#define     _XmSocorro                                    _xmsocorro
#define     _XmSortResourceList                           _xmsortresourcelist
#define     _XmStringBaseline                             _xmstringbaseline
#define     _XmStringByteCompare                          _xmstringbytecompare
#define     _XmStringCopy                                 _xmstringcopy
#define     _XmStringCreate                               _xmstringcreate
#define     _XmStringCreateExternal                       _xmstringcreateexternal
#define     _XmStringDraw                                 _xmstringdraw
#define     _XmStringDrawImage                            _xmstringdrawimage
#define     _XmStringDrawMnemonic                         _xmstringdrawmnemonic
#define     _XmStringDrawUnderline                        _xmstringdrawunderline
#define     _XmStringEmpty                                _xmstringempty
#define     _XmStringExtent                               _xmstringextent
#define     _XmStringFree                                 _xmstringfree
#define     _XmStringFreeContext                          _xmstringfreecontext
#define     _XmStringGetCurrentCharset                    _xmstringgetcurrentcharset
#define     _XmStringGetNextSegment                       _xmstringgetnextsegment
#define     _XmStringHasSubstring                         _xmstringhassubstring
#define     _XmStringHeight                               _xmstringheight
#define     _XmStringInitContext                          _xmstringinitcontext
#define     _XmStringIsXmString                           _xmstringisxmstring
#define     _XmStringLineCount                            _xmstringlinecount
#define     _XmStringSourceCreate                         _xmstringsourcecreate
#define     _XmStringSourceDestroy                        _xmstringsourcedestroy
#define     _XmStringSourceGetEditable                    _xmstringsourcegeteditable
#define     _XmStringSourceGetMaxLength                   _xmstringsourcegetmaxlength
#define     _XmStringSourceGetString                      _xmstringsourcegetstring
#define     _XmStringSourceGetValue                       _xmstringsourcegetvalue
#define     _XmStringSourceHasSelection                   _xmstringsourcehasselection
#define     _XmStringSourceSetEditable                    _xmstringsourceseteditable
#define     _XmStringSourceSetGappedBuffer                _xmstringsourcesetgappedbuffer
#define     _XmStringSourceSetMaxLength                   _xmstringsourcesetmaxlength
#define     _XmStringSourceSetValue                       _xmstringsourcesetvalue
#define     _XmStringUpdate                               _xmstringupdate
#define     _XmStringWidth                                _xmstringwidth
#define     _XmStringsAreEqual                            _xmstringsareequal
#define     _XmTestTraversability                         _xmtesttraversability
#define     _XmTextChangeBlinkBehavior                    _xmtextchangeblinkbehavior
#define     _XmTextChangeHOffset                          _xmtextchangehoffset
#define     _XmTextClearDestination                       _xmtextcleardestination
#define     _XmTextDestinationVisible                     _xmtextdestinationvisible
#define     _XmTextDisableRedisplay                       _xmtextdisableredisplay
#define     _XmTextDrawDestination                        _xmtextdrawdestination
#define     _XmTextEnableRedisplay                        _xmtextenableredisplay
#define     _XmTextFindScroll                             _xmtextfindscroll
#define     _XmTextGetAnchor                              _xmtextgetanchor
#define     _XmTextGetBaseLine                            _xmtextgetbaseline
#define     _XmTextInputCreate                            _xmtextinputcreate
#define     _XmTextInvalidate                             _xmtextinvalidate
#define     _XmTextLineInfo                               _xmtextlineinfo
#define     _XmTextMarkRedraw                             _xmtextmarkredraw
#define     _XmTextNumLines                               _xmtextnumlines
#define     _XmTextOutputCreate                           _xmtextoutputcreate
#define     _XmTextPosToLine                              _xmtextpostoline
#define     _XmTextScrollable                             _xmtextscrollable
#define     _XmTextSetCursorPosition                      _xmtextsetcursorposition
#define     _XmTextSetDestination                         _xmtextsetdestination
#define     _XmTextShouldWordWrap                         _xmtextshouldwordwrap
#define     _XmToHorizontalPixels                         _xmtohorizontalpixels
#define     _XmToVerticalPixels                           _xmtoverticalpixels
#define     _XmTraverseDown                               _xmtraversedown
#define     _XmTraverseHome                               _xmtraversehome
#define     _XmTraverseLeft                               _xmtraverseleft
#define     _XmTraverseNext                               _xmtraversenext
#define     _XmTraverseNextTabGroup                       _xmtraversenexttabgroup
#define     _XmTraversePrev                               _xmtraverseprev
#define     _XmTraversePrevTabGroup                       _xmtraverseprevtabgroup
#define     _XmTraverseRight                              _xmtraverseright
#define     _XmTraverseUp                                 _xmtraverseup
#define     _XmUnhighlightBorder                          _xmunhighlightborder
#define     _XmUnitTypeDefault                            _xmunittypedefault
#define     _XmVendorExtRealize                           _xmvendorextrealize
#define     _XmVirtKeysInitialize                         _xmvirtkeysinitialize
#define     _XmVirtualToActualKeysym                      _xmvirtualtoactualkeysym
#define     _XmWarning                                    _xmwarning
#define     _XtCheckSubclassFlag                          _xtchecksubclassflag
#define     _XtInherit                                    _xtinherit
#define     _XtInheritTranslations                        _xtinherittranslations
#define     _XtIsSubclassOf                               _xtissubclassof
#define     _XtWindowedAncestor                           _xtwindowedancestor



/* additionals */


#define   applicationShellWidgetClass     applicationshellwidgetclass
#define   compositeClassRec               compositeclassrec
#define   compositeWidgetClass            compositewidgetclass
#define   constraintClassRec              constraintclassrec
#define   constraintWidgetClass           constraintwidgetclass
#define   coreWidgetClass                 corewidgetclass
#define   dxmHelpWidgetClass              dxmhelpwidgetclass
#define   objectClassRec                  objectclassrec
#define   objectClass                     objectclass
#define   overrideShellWidgetClass        overrideshellwidgetclass
#define   rectObjClassRec                 rectobjclassrec
#define   rectObjClass                    rectobjclass
#define   shellWidgetClass                shellwidgetclass
#define   topLevelShellWidgetClass        toplevelshellwidgetclass
#define   transientShellWidgetClass       transientshellwidgetclass
#define   vendorShellWidgetClass          vendorshellwidgetclass
#define   widgetClassRec                  widgetclassrec
#define   widgetClass                     widgetclass
#define   wmShellWidgetClass              wmshellwidgetclass

#define   xmBulletinBoardWidgetClass     xmbulletinboardwidgetclass
#define   xmCascadeButtonGadgetClass     xmcascadebuttongadgetclass
#define   xmCascadeButtonWidgetClass     xmcascadebuttonwidgetclass


#define   xmDialogShellWidgetClass        xmdialogshellwidgetclass
#define   xmDrawingAreaWidgetClass        xmdrawingareawidgetclass
#define   XmFileSelectionBoxGetChild      xmfileselectionboxgetchild
#define   xmFileSelectionBoxWidgetClass   xmfileselectionboxwidgetclass
#define   xmSelectionBoxWidgetClass      xmselectionboxwidgetclass
#define   xmFormWidgetClass              xmformwidgetclass

#define   xmMainWindowWidgetClass        xmmainwindowwidgetclass
#define   xmManagerWidgetClass            xmmanagerwidgetclass
#define   XmMessageBoxGetChild            xmmessageboxgetchild
#define   xmMessageBoxWidgetClass         xmmessageboxwidgetclass
#define   xmPrimitiveWidgetClass          xmprimitivewidgetclass
#define   xmPushButtonGadgetClass        xmpushbuttongadgetclass
#define   xmPushButtonWidgetClass        xmpushbuttonwidgetclass
#define   xmRowColumnWidgetClass         xmrowcolumnwidgetclass
#define   xmSeparatorGadgetClass         xmseparatorgadgetclass
#define   xmScrolledWindowWidgetClass     xmscrolledwindowwidgetclass
#define   xmToggleButtonGadgetClass       xmtogglebuttongadgetclass
#define   xmUseVersion                    xmuseversion
#define   xmToggleButtonWidgetClass       xmtogglebuttonwidgetclass
#define   xmLabelGadgetClass              xmlabelgadgetclass
#define   xmTextWidgetClass               xmtextwidgetclass
#define   xmTextFieldWidgetClass          xmtextfieldwidgetclass
#define   xmScaleWidgetClass              xmscalewidgetclass
#define   xmLabelWidgetClass              xmlabelwidgetclass
#define   xmListWidgetClass               xmlistwidgetclass
#define   xmGadgetClass                   xmgadgetclass



#define   XBell                           xbell
#define   XSync                           xsync
#define   XMapWindow                      xmapwindow

#define  XChangeKeyboardControl   xchangekeyboardcontrol 
#define  XCloseDisplay            xclosedisplay
#define  XForceScreenSaver        xforcescreensaver
#define  XMapRaised               xmapraised  
#define  XSetCloseDownMode        xsetclosedownmode
#define  XSetIconName             xseticonname
#define  XSetWindowColormap       xsetwindowcolormap 
#define  XStoreName               xstorename  
#define  XWarpPointer             xwarppointer
#define  XSetWMHints              xsetwmhints 
                                  


#ifdef __cplusplus
extern "C" {
#endif


extern void XtFree(
    char*		/* ptr */
);


#ifdef __cplusplus
}
#endif




/* X11R3 doesn't have XtOffsetOf, but it has XtOffset. */
#ifndef XtOffsetOf
#  ifdef offsetof
#    define XtOffsetOf(s_type,field) offsetof(s_type,field)
#  else
#    define XtOffsetOf(s_type,field) XtOffset(s_type*,field)
#  endif
#endif


#endif  /* CASEHACK_LOADED */

