/* <vms/lib/adpdef.h>
 *
 *	LIB - Adapter Control Block definitions		[not in Starlet]
 */
#ifndef _ADPDEF_H
#define _ADPDEF_H

/*
   There is one ADP for each system interconnect adapter that is
   used for any type of I/O.  For example: MASBUSS adapter, UNIBUS
   adapter.  There is no adapter control block for main memory adapters.
 */
#define ADP$V_MAPPED		0
#define ADP$V_SHUTDOWN		1
#define ADP$V_SELFTEST		2
#define ADP$V_PORTONLY		3
#define ADP$V_BVP_LOCK		4
#define ADP$M_MAPPED		(1<<ADP$V_MAPPED)	/* 0x01 */
#define ADP$M_SHUTDOWN		(1<<ADP$V_SHUTDOWN)	/* 0x02 */
#define ADP$M_SELFTEST		(1<<ADP$V_SELFTEST)	/* 0x04 */
#define ADP$M_PORTONLY		(1<<ADP$V_PORTONLY)	/* 0x08 */
#define ADP$M_BVP_LOCK		(1<<ADP$V_BVP_LOCK)	/* 0x10 */
#define ADP$V_POWER_FAIL	0
#define ADP$V_POWER_FAIL_RECOVERY 1
#define ADP$M_POWER_FAIL	(1<<ADP$V_POWER_FAIL)		 /* 0x01 */
#define ADP$M_POWER_FAIL_RECOVERY (1<<ADP$V_POWER_FAIL_RECOVERY) /* 0x02 */
#define ADP$V_BI_USE		0
#define ADP$V_BLA		1
#define ADP$M_BI_USE		(1<<ADP$V_BI_USE)	/* 0x01 */
#define ADP$M_BLA		(1<<ADP$V_BLA)		/* 0x02 */
#define ADP$V_ADPDISP_INIT	0
#define ADP$V_ADAP_MAPPING	1
#define ADP$V_DIRECT_VECTOR	2
#define ADP$V_AUTOPURGE_DP	3
#define ADP$V_BUFFERED_DP	4
#define ADP$V_ODD_XFER_BDP	5
#define ADP$V_ODD_XFER_DDP	6
#define ADP$V_EXTENDED_MAPREG	7
#define ADP$V_QBUS		8
#define ADP$V_PSWITCH_COMMIT	9
#define ADP$M_ADPDISP_INIT	(1<<ADP$V_ADPDISP_INIT)		/* 0x01 */
#define ADP$M_ADAP_MAPPING	(1<<ADP$V_ADAP_MAPPING)		/* 0x02 */
#define ADP$M_DIRECT_VECTOR	(1<<ADP$V_DIRECT_VECTOR)	/* 0x04 */
#define ADP$M_AUTOPURGE_DP	(1<<ADP$V_AUTOPURGE_DP)		/* 0x08 */
#define ADP$M_BUFFERED_DP	(1<<ADP$V_BUFFERED_DP)		/* 0x10 */
#define ADP$M_ODD_XFER_BDP	(1<<ADP$V_ODD_XFER_BDP)		/* 0x20 */
#define ADP$M_ODD_XFER_DDP	(1<<ADP$V_ODD_XFER_DDP)		/* 0x40 */
#define ADP$M_EXTENDED_MAPREG	(1<<ADP$V_EXTENDED_MAPREG)	/* 0x80 */
#define ADP$M_QBUS		(1<<ADP$V_QBUS)			/* 0x0100 */
#define ADP$M_PSWITCH_COMMIT	(1<<ADP$V_PSWITCH_COMMIT)	/* 0x0200 */

#define ADP$S_CRB_LINKS 16
#define ADP$S_BI_ONLY	16
#define ADP$S_INTD	12
#define ADP$S_INTD2	12
#define ADP$S_INTD3	12
#define ADP$S_INTD_UBA	12
#define ADP$S_UBASCB	16
#define ADP$S_UBASPTE	8
#define ADP$S_MRNREGARY 248
#define ADP$S_MRFREGARY 248
#define ADP$S_MR2NREGAR 248
#define ADP$S_MR2FREGAR 248

#define ADP$K_MBAADPLEN 56	/* length of ADP for MASSBUS adapter */
#define ADP$C_MBAADPLEN 56
#define ADP$K_DRADPLEN	56	/* length of ADP for DR32 */
#define ADP$C_DRADPLEN	56
#define ADP$K_CIADPLEN	56	/* length of ADP for CI */
#define ADP$C_CIADPLEN	56
#define ADP$K_GBIADPLEN 56	/* length of ADP for generic BI device */
#define ADP$C_GBIADPLEN 56
#define ADP$K_MBUSADPLEN 56	/* length of ADP for MBUS */
#define ADP$C_MBUSADPLEN 56
#define ADP$K_MINADPLEN 56	/* length of smallest available ADP */
#define ADP$C_MINADPLEN 56
#define ADP$K_MPMADPLEN 76	/* length of ADP for multi-port memory */
#define ADP$C_MPMADPLEN 76
#define ADP$K_XBIADPLEN 88	/* length of ADP for XBIA */
#define ADP$C_XBIADPLEN 88
#define ADP$K_XJADPLEN	100	/* length of ADP for XJA */
#define ADP$C_XJADPLEN	100
#define ADP$K_UBAADPLEN 608	/* length of ADP for UNIBUS adapter */
#define ADP$C_UBAADPLEN 608
#define ADP$C_NUMDATAP	16	/* UBA - number of datapaths */

#define ADP$K_QBAADPLEN 1128	/* length of ADP for qbus adapter */
#define ADP$C_QBAADPLEN 1128
#define ADP$C_VMEADPLEN 1128	/* length of ADP for the VME */
#define ADP$K_VMEADPLEN 1128
#define ADP$C_BVPADPLEN 156	/* BVP ADP size with BVP extension */
#define ADP$C_BVP_PAGES 16	/* BVP Pages mapped to the adapter registers */

#define ADP$V_SGEC_SA		0
#define ADP$V_SGEC_SE		1
#define ADP$M_SGEC_SA		(1<<ADP$V_SGEC_SA)	/* 0x01 */
#define ADP$M_SGEC_SE		(1<<ADP$V_SGEC_SE)	/* 0x02 */
#define ADP$K_NIADPLEN	64
#define ADP$C_NIADPLEN	64

#define ADP$V_CIR_VALID		0
#define ADP$V_CIR_INITDEV	1
#define ADP$V_CIR_TRAENA	2
#define ADP$M_CIR_VALID		(1<<ADP$V_CIR_VALID)	/* 0x01 */
#define ADP$M_CIR_INITDEV	(1<<ADP$V_CIR_INITDEV)	/* 0x02 */
#define ADP$M_CIR_TRAENA	(1<<ADP$V_CIR_TRAENA)	/* 0x04 */
#define ADP$C_CIRADPLEN 140	/* CIRRUS ADP length */

#define ADP520$K_MODEMPTY	0	/* Empty slot */
#define ADP520$K_MODCIO		1	/* CIO (KFE52) module */
#define ADP520$K_MODMEM		3	/* Memory module */
#define ADP520$K_MODCOMM	4	/* DSF32 module */
#define ADP520$K_MODCPU		5	/* CPU module */
#define ADP520$K_MODUNK		15	/* Unknown module */
#define ADP520$K_END		6	/* CPU module */

#define ADP$S_ADPDEF	1128
struct adpdef {
    unsigned long adp$l_csr;		/* adapter configuration status register address */
    unsigned long adp$l_link;		/* address of next adapter control block */
    unsigned short adp$w_size;		/* structure size in bytes */
    unsigned char adp$b_type;		/* structure type code */
    unsigned char adp$b_number;		/* ordinal adapter number */
    unsigned short adp$w_tr;		/* configuration tr number */
    unsigned short adp$w_adptype;	/* software adapter type */
    union {
	unsigned long adp$l_vector;	/* UBA - address of vector jump table */
	unsigned long adp$l_crb;	/* MBA OR DR32 - address of adapter's CRB */
    } adp$r_vector_overlay;
    union {
	unsigned long adp$l_dpqfl;	    /* UBA - datapath wait queue forward link */
	union {
	    unsigned long adp$l_prqqfl;		/* MPM - inter-processor request wait queue flink */
	    unsigned long adp$l_mbascb;		/* MBA - SCB vector value for MBA nexus */
	    unsigned long adp$l_cimap;		/* CI - CI mapping status */
	    unsigned long adp$l_vportsts;	/* BVP - VAX port status bits */
	    struct {
		unsigned adp$v_mapped	: 1;	/* BVP,CI - adapter is mapped */
		unsigned adp$v_shutdown : 1;	/* BVP,CI - adapter microcode is stopped */
		unsigned adp$v_selftest : 1;	/* BVP - adapter self test is in progress */
		unsigned adp$v_portonly : 1;	/* BVP - port restart only -- no adapter restart */
		unsigned adp$v_bvp_lock : 1;	/* BVP - multi-port lock bit */
	    } adp$r_vportsts_bits;
	    unsigned long adp$l_xja_status;	/* XJA - interrupt handler status bits	    */
	    struct {
		unsigned adp$v_power_fail : 1;	/* set on at time of power failure */
		unsigned adp$v_power_fail_recovery : 1; /* set on at time of power failure recovery */
	    } adp$r_xja_status_bits;
	    unsigned long adp$l_bi_status;	/* BI - interrupt handler status bits */
#define adp$r_bi_status_bits adp$r_xja_status bits	/* equivalent */
	} adp$r_prqqfl_overlay;
    } adp$r_dpqfl_overlay;
    union {
	unsigned long adp$l_dpqbl;		/* UBA - datapath wait queue backward link */
	union {
	    unsigned long adp$l_prqqbl;		/* MPM - inter-processor request wait queue blink */
	    unsigned long adp$l_mbaspte;	/* MBA - SPTE value which maps mba address space */
	    unsigned long adp$l_cispte;		/* CI - SPTE value which maps CI address space */
	} adp$r_prqqbl_overlay;
    } adp$r_dpqbl_overlay;
    unsigned long adp$l_avector;	/* addr of 1st SCB vector for this adaptor */
    union {
	union {
	    unsigned long adp$l_crb_links[4];
	    unsigned long adp$l_crb_ptrs;
	    struct {
		long adp$l_sii_crb;	/* link to SII CRB */
		long adp$l_lance_crb;	/* link to LANCE CRB */
		long adp$l_dz_crb;	/* link to DZ CRB */
		long adp$l_spare_crb;	/* spare link */
	    } adp$r_crb_ptrs;
	} adp$r_crb_links_overlay;
	union {
	    unsigned long adp$l_bi_only[4];	/* BI adapter volatile info */
	    unsigned long adp$l_bi_idr;		/* BIIC interrupt destination register */
	    struct {
		unsigned    : 32;
		union {
		    unsigned short adp$w_bi_flags;  /* flags field */
		    struct {
			unsigned adp$v_bi_use : 1;  /* vector field valid if this bit is set */
			unsigned adp$v_bla    : 1;  /* if set, adapter is BLA */
		    } adp$r_bi_flags_bits;
		} adp$r_bi_flags_overlay;
		unsigned short adp$w_bi_vector; /* store SCB vector offset */
		unsigned long adp$l_scb_page;	/* store SCB page offset for BI. */
		unsigned long adp$l_bimaster;	/* ADP address for BI master (ie. XBI) */
	    } adp$r_bi_idr;
	} adp$r_bi_only_overlay;
    } adp$r_bi_crb_overlay;
    struct {
	union {
	    unsigned short adp$w_adpdisp_flags;     /* flags used by ADPDISP macro */
	    struct {
		unsigned adp$v_adpdisp_init   : 1;  /* ADPDISP flags have been initialized */
		unsigned adp$v_adap_mapping   : 1;  /* adapter mapping supported */
		unsigned adp$v_direct_vector  : 1;  /* direct vectored interrupts */
		unsigned adp$v_autopurge_dp   : 1;  /* autopurging datapath */
		unsigned adp$v_buffered_dp    : 1;  /* buffered datapath supported */
		unsigned adp$v_odd_xfer_bdp   : 1;  /* odd xfers supported ob buffered DP */
		unsigned adp$v_odd_xfer_ddp   : 1;  /* odd xfers supported on direct DP */
		unsigned adp$v_extended_mapreg: 1;  /* extended # of map regs */
		unsigned adp$v_qbus	      : 1;  /* QBUS adapter */
		unsigned adp$v_pswitch_commit : 1;  /* commit XMI adapters to primary switch */
	    } adp$r_adpdisp_flags_bits;
	} adp$r_adpdisp_flags_overlay;
	unsigned    : 8;			/* char fill; */
	unsigned char adp$b_addr_bits;		/* number of adapter addr bits */
	unsigned long adp$l_pswitch_callback;	/* primary switch XMI callback address */
#define adp$l_adpdisp_reserved adp$l_pswitch_callback	/* old name */
    } adp$r_adpdisp_fields;

    union {	/* ADP extension */

	/* MBM_extension */
	struct {
	    union {
		unsigned long adp$l_shb;		/* MPM - shared memory control block addr */
		unsigned long adp$l_xbia_csr;		/* CSR for XBIA */
		unsigned long adp$l_xmi_node_sp;	/* address of XMI Node Space */
	    } adp$r_xbi_overlay;
	    union {
		unsigned char adp$b_port;		/* MPM - port number */
		struct {
		    unsigned short adp$w_xbia_tr;	/* XMI node id */
		    unsigned char adp$b_rel_bi;		/* relative BI #, for multiple XMI systems */
		    unsigned	: 8;
		} adp$r_xbi2_structure;
		unsigned short adp$w_xmi_node_no;	/* XMI node id */
	    } adp$r_xbi2_overlay;
	    unsigned long adp$l_intd[3];	/* MPM,UBA - interrupt transfer vector */
	    unsigned long adp$l_intd2[3];	/* XBI needs 2 INTDs */
	    unsigned long adp$l_intd3[3];	/* XJA needs 3 INTDs */
	} adp$r_mpm_extension;

	/* UBA_extension */
	struct {
	    unsigned long adp$l_mrqfl;		/* UBA - map register wait queue forward link */
	    unsigned long adp$l_mrqbl;		/* UBA - map register wait queue backward link */
	    unsigned long adp$l_intd_uba[3];	/* UBA - interrupt transfer vector (same as MPM_extension) */
	    union {
		unsigned long adp$l_ubascb[4];	/* UBA - SCB vector value for 4 UBA vectors */
		struct {
		    char adpdef$$_fill_ubascb[10];
		    unsigned short adp$w_dirvecpg; /* SCB page number for UNIBUS devices */
		} adp$r_ubascb_fields;
	    } adp$r_ubascb_overlay;
	    unsigned long adp$l_ubaspte[2];	/* UBA - SPTE values for mapping UBA addresses */
	    unsigned long adp$l_mractmdrs;	/* UBA - ! active map register descriptors */
	    unsigned short adp$w_dpbitmap;	/* UBA - datapath allocation bitmap */
	    unsigned short adp$w_mrnfence;	/* fence preceeding array. Init'ed to -1 */
	    unsigned short adp$w_mrnregary[124]; /* ! map regs in an extent array */
	    unsigned short adp$w_mrffence;	/* fence precedding array. Init'ed to -1 */
	    unsigned short adp$w_mrfregary[124]; /* 1st reg in extent array. */
	    unsigned short adp$w_umr_dis;	/* num of map registers to disable */
		/* data structures for second set of map registers (497-8192) */
		/* These are uVAX2 QBUS registers not used by UNIBUS devices. */
	    unsigned long adp$l_mr2qfl;		/* QBA - 2nd map register wait queue forward link */
	    unsigned long adp$l_mr2qbl;		/* QBA - 2nd map register wait queue backward link */
	    unsigned long adp$l_mr2actmdr;	/* QBA - number of active map register descriptors */
	    unsigned	: 16;			/* short fill; (spare) */
	    unsigned short adp$w_mr2nfence;	/* fence preceeding array. Init'ed to -1 */
	    unsigned short adp$w_mr2nregar[124]; /* number of map regs in an extent array */
	    unsigned short adp$w_mr2ffence;	/* fence precedding array. Init'ed to -1 */
	    unsigned short adp$w_mr2fregar[124]; /* 1st reg in extent array. */
	    unsigned short adp$w_umr2_dis;	/* num of map registers to disable */
	    unsigned long adp$l_mr2addr;	/* address of map registers in CPU node private space */
	} adp$r_uba_extension;

	/* BVP_extension */
	struct {
	    unsigned long adp$l_hostnode;	/* BVP address of the host's BIIC nodespace base */
	    unsigned short adp$w_incarn;	/* BVP adapter incarnation - incremented on restart or self test */
	    /* the following fields are reserved for use by BVP$LOCK_WAIT, BVP$LOCK_NOWAIT and BVP$UNLOCK */
	    unsigned long adp$l_bvpowner;	/* BVP lock owner UCB (zero if free) */
	    unsigned long adp$l_bvpwaitfl;	/* BVP queue of port drivers waiting */
	    unsigned long adp$l_bvpwaitbl;	/* BVP for the ADP interlock */
	    /* the following fields are reserved for use by BVP$INIT_PORT */
	    unsigned short adp$w_bvp_state;	/* BVP software state */
	    unsigned long adp$l_bvp_count;	/* BVP timeout count */
	    unsigned long adp$l_bvp_prog;	/* BVP progress counter */
	    unsigned long adp$l_bvpsavr5;	/* BVP saved R5 */
	    unsigned long adp$l_bvpreturn;	/* BVP return address */
	    unsigned long adp$l_bvptest;	/* BVP self test action routine */
	    unsigned long adp$l_bvpstop;	/* BVP stopped state action routine */
	    unsigned long adp$l_bvpundef;	/* BVP undefined state action */
	    unsigned long adp$l_bvpinit;	/* BVP initialized state action */
	    unsigned long adp$l_bvpnotify;	/* BVP error notify fork block */
	    unsigned long adp$l_bvpctrl;	/* BVP address of the port regs */
	    /* the following queue header is a list of fork blocks to be activated on a fatal adapter error */
	    unsigned long adp$l_bvperrfl;	/* BVP error notification flink */
	    unsigned long adp$l_bvperrbl;	/* BVP error notification blink */
	    unsigned	: 32, : 32;		/* long fill[2]; */
	    /* the following field is used for CI-compatible adapter mapping and unmapping */
	    unsigned long adp$l_intserv;	/* BVP address of the interrupt service routine */
	    /* the following fields are reserved for use by BVP$ALLOC_DUMP and BVP$MEM_DUMP */
	    unsigned long adp$l_lsdump;		/* BVP address of physical contiguous */
	    /* BVP memory for the adapter memory dump. */
	    unsigned long adp$l_lsindx;		/* BVP offset into the adapter memory for start of the dump */
	    unsigned long adp$l_lslength;	/* BVP length (longwords) of the adapter memory */
	    /* The following field is a sequence number for diagnostic use in tracing events from */
	    /* multiple drivers which access a single adapter.	This field is normally unused.	  */
	    unsigned long adp$l_sequence;	/* BVP event sequence number */
	    unsigned long adp$l_adp_pages;	/* (TYC0001) # of adapter pages to map */
	} adp$r_bvp_extension;

	/* NI_extension */
	struct {
	    unsigned long adp$l_ni_hwa;		/* NI hardware address */
	    unsigned char adp$b_ni_hwo;		/* offset between HWA bytes */
	    unsigned char adp$b_ni_dipl;	/* device IPL */
	    union {		/* hardware-specific extensions */
		struct {
		    unsigned char adp$b_sgec_burst;	/* SGEC burst limit */
		    union {
			unsigned char adp$b_sgec_mode;	/* SGEC mode */
			struct {
			    unsigned adp$v_sgec_sa : 1; /* SGEC synch/asynch */
			    unsigned adp$v_sgec_se : 1; /* SGEC single-cycle enable */
			} adp$r_sgec_mode_bits;
		    } adp$r_sgec_mode_overlay;
		} adp$r_sgec_extension;
	    } adp$r_ni_overlay;
	} adp$r_ni_extension;

	/* CIR_extension */
	struct {
	    union {
		unsigned short adp$w_cirflags;	/* CIRRUS flags */
		struct {
		    unsigned adp$v_cir_valid	: 1;
		    unsigned adp$v_cir_initdev	: 1;
		    unsigned adp$v_cir_traena	: 1;
		} adp$r_cirflags_bits;
	    } adp$r_cirflags_overlay;
	    unsigned short adp$w_cirslot;	/* Cirrus slot number (1-14) */
	    unsigned short adp$w_cirmodtype;	/* CIRRUS module type */
	    unsigned short adp$w_cirserno;	/* CIRRUS serial number */
	    unsigned short adp$w_cirrevno;	/* CIRRUS revision number */
	    unsigned short adp$w_cirpagma;	/* CIRRUS pages mapped */
	    unsigned short adp$w_cirspteno;	/* CIRRUS number of SPTEs for this adapter */
	    unsigned short adp$w_cirmemmodsize; /* CIRRUS memory module size in megabytes */
	    union {
		unsigned long adp$l_cirvaios;	 /* CIRRUS virtual address IO space */
		unsigned long adp$l_circpueerom; /* base VA of CPU EEPROM */
		unsigned long adp$l_cirmemeerom; /* base VA of Memory EEPROM */
	    } adp$r_vaios_overlay;
	    unsigned long adp$l_cirspteva;	/* CIRRUS virtual address of first SPTE */
	    union {
		unsigned long adp$l_circiocomm; /* CIRRUS base VA of communications area for a CIO module */
		unsigned long adp$l_cirmempwra; /* VA of memory primary read write address register */
	    } adp$r_comm_overlay;
	    union {
		unsigned long adp$l_circioeth;	/* CIRRUS base VA of ethernet address area for a CIO module */
		unsigned long adp$l_cirmempra;	/* VA of memory primary read address register */
	    } adp$r_eth_overlay;
	    union {
		unsigned long adp$l_circiossc;	/* CIRRUS base VA of SSC (TODR) area for a CIO module */
		unsigned long adp$l_cirmemmwra; /* VA of memory mirror write read address register */
	    } adp$r_ssc_overlay;
	    union {
		unsigned long adp$l_circioslb;	/* CIRRUS base VA of buffer RAM area for a CIO module */
		unsigned long adp$l_cirmemdwr;	/* VA of memory data write read register */
	    } adp$r_slb_overlay;
	    union {
		unsigned long adp$l_circiofir;	 /* CIRRUS base VA of firewall registers area for a CIO module */
		unsigned long adp$l_cirmemwrerr; /* VA of memory write read error control register */
	    } adp$r_fir_overlay;
	    unsigned long adp$l_circiodma;	/* CIRRUS base VA of DMA registers area for a CIO module */
	    unsigned long adp$l_circiofirctl;	/* CIRRUS base VA of firewall control register on CIO module */
	    unsigned long adp$l_circiopcm;	/* CIRRUS base VA of PCM area for a CIO module */
	    union {
		unsigned long adp$l_circiocon;	/* CIRRUS base VA of console registers */
		unsigned long adp$l_cirdsfcon;	/* area for a CIO and DSF module */
	    } adp$r_con_overlay;
	    unsigned long adp$l_circiosli;	/* CIRRUS base VA of SLIM registers */
	    union {
		unsigned long adp$l_circioswi;	 /* CIRRUS base VA of SWIFT registers */
		unsigned long adp$l_cirdsfturbo; /* CIRRUS VA of DSF TURBO registers */
	    } adp$r_swi_overlay;
	    union {
		unsigned long adp$l_circiolan;	/* CIRRUS base VA of LANCE registers */
		unsigned long adp$l_cirdsfmod;	/* base VA of Modem control for DSF */
	    } adp$r_lan_overlay;
	    union {
		unsigned long adp$l_swift_crb;	/* SWIFT CRB address */
		unsigned long adp$l_dsf_crb;	/* DSF CRB address */
	    } adp$r_crb_overlay;
	    unsigned long adp$l_lancec_crb;	/* Lance CRB address */
	    unsigned long adp$l_pcm_crb;	/* PCM CRB address */
	} adp$r_cir_extension;

    } adp$r_adpextension;

}; /* adpdef */

#endif	/*_ADPDEF_H*/
