/* <armdef.h>
 *
 *	Access Rights Mask longword definitions
 */
#ifndef _ARMDEF_H
#define _ARMDEF_H

#define ARM$V_READ	0
#define ARM$V_WRITE	1
#define ARM$V_EXECUTE	2
#define ARM$V_DELETE	3
#define ARM$V_CONTROL	4
#define ARM$M_READ	(1<<ARM$V_READ)		/* 0x01 */
#define ARM$M_WRITE	(1<<ARM$V_WRITE)	/* 0x02 */
#define ARM$M_EXECUTE	(1<<ARM$V_EXECUTE)	/* 0x04 */
#define ARM$M_DELETE	(1<<ARM$V_DELETE)	/* 0x08 */
#define ARM$M_CONTROL	(1<<ARM$V_CONTROL)	/* 0x10 */
struct armdef {
    unsigned arm$v_read    : 1;		/* Read access */
    unsigned arm$v_write   : 1;		/* Write access */
    unsigned arm$v_execute : 1;		/* Execute access */
    unsigned arm$v_delete  : 1;		/* Delete access */
    unsigned arm$v_control : 1;		/* Control access (modify attributes) */
    unsigned arm$v_fill    : 27;
};

#endif	/*_ARMDEF_H*/
