/* <chpdef.h>
 *
 *	Item definitions for the $CHKPRO (check protection) service.
 */
#ifndef _CHPDEF_H
#define _CHPDEF_H

#define CHP$_END	0		/* list end */
#define CHP$_ACCESS	1		/* intended access */
#define CHP$_FLAGS	2		/* read / write flags */
#define CHP$_PRIV	3		/* privilege mask */
#define CHP$_ACMODE	4		/* accessor access mode */
#define CHP$_ACCLASS	5		/* accessor security classification */
#define CHP$_RIGHTS	6		/* rights list */
#define CHP$_ADDRIGHTS	7		/* additional rights list segments */
#define CHP$_MODE	8		/* simple access mode */
#define CHP$_MODES	9		/* per action access mode */
#define CHP$_MINCLASS	10		/* minimum security classification */
#define CHP$_MAXCLASS	11		/* maximum security classification */
#define CHP$_OWNER	12		/* object owner UIC */
#define CHP$_PROT	13		/* protection mask */
#define CHP$_ACL	14		/* access control list segment */
#define CHP$_AUDITNAME	15		/* security audit name */
#define CHP$_ALARMNAME	16		/* security alarm name */
#define CHP$_MATCHEDACE 17		/* address of matching ACE */
#define CHP$_PRIVUSED	18		/* mask of privileges used */
#define CHP$_MAX_CODE	19		/* highest CHP$ item code */

#define CHP$V_SYSPRV	0
#define CHP$V_BYPASS	1
#define CHP$V_UPGRADE	2
#define CHP$V_DOWNGRADE 3
#define CHP$V_GRPPRV	4
#define CHP$V_READALL	5
#define CHP$M_SYSPRV	(1<<CHP$V_SYSPRV)	/* 0x01 */
#define CHP$M_BYPASS	(1<<CHP$V_BYPASS)	/* 0x02 */
#define CHP$M_UPGRADE	(1<<CHP$V_UPGRADE)	/* 0x04 */
#define CHP$M_DOWNGRADE (1<<CHP$V_DOWNGRADE)	/* 0x08 */
#define CHP$M_GRPPRV	(1<<CHP$V_GRPPRV)	/* 0x10 */
#define CHP$M_READALL	(1<<CHP$V_READALL)	/* 0x20 */
struct chp$privs_used_bits {
    unsigned chp$v_sysprv	: 1;	/* access via SYSPRV privilege	*/
    unsigned chp$v_bypass	: 1;	/* access via BYPASS privilege	*/
    unsigned chp$v_upgrade	: 1;	/* access via UPGRADE privilege */
    unsigned chp$v_downgrade	: 1;	/* access via DOWNGRADE privilege */
    unsigned chp$v_grpprv	: 1;	/* access via GRPPRV privilege	*/
    unsigned chp$v_readall	: 1;	/* access via READALL privilege */
    unsigned			: 2;
};
#define CHP$V_READ	0
#define CHP$V_WRITE	1
#define CHP$V_USEREADALL 2
#define CHP$M_READ	(1<<CHP$V_READ)		/* 0x01 */
#define CHP$M_WRITE	(1<<CHP$V_WRITE)	/* 0x02 */
#define CHP$M_USEREADALL (1<<CHP$V_USEREADALL)	/* 0x04 */
struct chp$flag_bits {
    unsigned chp$v_read		: 1;	/* non-discretionary read access */
    unsigned chp$v_write	: 1;	/* non-discretionary write access */
    unsigned chp$v_usereadall	: 1;	/* READALL privilege applies */
    unsigned			: 5;
};
#define CHP$V_NOACCESS	0
#define CHP$V_REMDUPID	1
#define CHP$M_NOACCESS	(1<<CHP$V_NOACCESS)	/* 0x01 */
#define CHP$M_REMDUPID	(1<<CHP$V_REMDUPID)	/* 0x02 */
struct chp$profile_flags {
    unsigned chp$v_noaccess	: 1;	/* do not access UAF to build profile */
    unsigned chp$v_remdupid	: 1;	/* remove duplicate system rights IDs */
    unsigned			: 6;
};

#endif	/*_CHPDEF_H*/
