/* <clsdef.h>
 *
 *	Security classification mask block.
 */
#ifndef _CLSDEF_H
#define _CLSDEF_H

/*
   Contains security and integrity level and categories for
   non-discretionary access controls.
 */
struct clsdef {
    unsigned char cls$b_secur_lev;	/* security level */
    unsigned char cls$b_integ_lev;	/* integrity level */
    unsigned	: 16;			/* short fill; reserved */
    int cls$q_secur_cat[2];		/* security category mask */
    int cls$q_integ_cat[2];		/* integrity category mask */
};
#define CLS$_SECSTR	1	/* textual secrecy/security string */
#define CLS$_INTSTR	2	/* textual integrity string */
#define CLS$_CLSBLK	3	/* simple classification block */
#define CLS$_MINCLSBLK	4	/* minimum classification block */
#define CLS$_MAXCLSBLK	5	/* maximum classification block */
#define CLS$_WIDTH	6	/* width of display for $FORMAT_CLASS */
#define CLS$_TRMDSC	7	/* line terminator for $FORMAT_CLASS */
#define CLS$_INDENT	8	/* line indenting for $FORMAT_CLASS */
#define CLS$_OLDCLSBLK	9	/* previous classification block */
#define CLS$_OLDMINCLS 10	/* previous minimum class block */
#define CLS$_OLDMAXCLS 11	/* previous maximum class block */

#endif	/*_CLSDEF_H*/
