/* <dtk$routines.h>
 *
 *	DECtalk run-time library routines.
 */
#ifndef _DTK$ROUTINES_H
#define _DTK$ROUTINES_H
# ifdef __cplusplus
extern "C" {
# endif

/*	DTK$ANSWER_PHONE	-- wait for phone to ring and answer */
unsigned long dtk$answer_phone(const unsigned long *,...);
/*	DTK$CHECK_HDWR_STATUS	-- check hardware status */
unsigned long dtk$check_hdwr_status(const unsigned long *,unsigned long *);
/*	DTK$DIAL_PHONE		-- dial the telephone */
unsigned long dtk$dial_phone(const unsigned long *,const void *,...);
/*	DTK$HANGUP_PHONE	-- hang up the phone */
unsigned long dtk$hangup_phone(const unsigned long *,...);
/*	DTK$INITIALIZE		-- initialize DECtalk */
unsigned long dtk$initialize(unsigned long *,const void *,...);
/*	DTK$LOAD_DICTIONARY	-- load a word into the DECtalk dictionary */
unsigned long dtk$load_dictionary(const unsigned long *,const void *,const void *);
/*	DTK$READ_KEYSTROKE	-- read a key entered on the keypad */
unsigned long dtk$read_keystroke(const unsigned long *,unsigned long *,...);
/*	DTK$READ_STRING		-- read a series of keys entered on keypad */
unsigned long dtk$read_string(const unsigned long *,void *,...);
/*	DTK$RETURN_LAST_INDEX	-- return last index spoken */
unsigned long dtk$return_last_index(const unsigned long *,long *);
/*	DTK$SET_INDEX		-- insert an index at the current position */
unsigned long dtk$set_index(const unsigned long *,const long *);
/*	DTK$SET_KEYPAD_MODE	-- turn the phone keypad on and off */
unsigned long dtk$set_keypad_mode(const unsigned long *,const unsigned long *);
/*	DTK$SET_LOGGING_MODE	-- set logging mode for attached video terminal */
unsigned long dtk$set_logging_mode(const unsigned long *,...);
/*	DTK$SET_MODE		-- set the mode for the DECtalk terminal */
unsigned long dtk$set_mode(const unsigned long *,...);
/*	DTK$SET_SPEECH_MODE	-- turn speech mode on and off */
unsigned long dtk$set_speech_mode(const unsigned long *,...);
/*	DTK$SET_TERMINAL_MODE	-- set the mode for attached video terminal */
unsigned long dtk$set_terminal_mode(const unsigned long *,...);
/*	DTK$SET_VOICE		-- set voice characteristics */
unsigned long dtk$set_voice(const unsigned long *,...);
/*	DTK$SPEAK_FILE		-- speak the text in a specified file */
unsigned long dtk$speak_file(const unsigned long *,const void *,...);
/*	DTK$SPEAK_PHONEMIC_TEXT -- speak the specified phonemic text */
unsigned long dtk$speak_phonemic_text(const unsigned long *,const void *,...);
/*	DTK$SPEAK_TEXT		-- speak the specified text */
unsigned long dtk$speak_text(const unsigned long *,const void *,...);
/*	DTK$SPELL_TEXT		-- spell text */
unsigned long dtk$spell_text(const unsigned long *,const void *,...);
/*	DTK$TERMINATE		-- terminate DECtalk */
unsigned long dtk$terminate(const unsigned long *);

# ifdef __cplusplus
}
# endif
#endif	/*_DTK$ROUTINES_H*/
