/* <vms/lib/irpdef.h>
 *
 *	LIB - I/O Request Packet definitions		[not in Starlet]
 */
#ifndef _IRPDEF_H
#define _IRPDEF_H

/*
   I/O Request Packets are constructed by the Queue I/O Request system
   service.  The content of an I/O request packet describes a function to
   be performed on a device unit.
 */
#define IRP$V_MODE	0
#define IRP$M_MODE	0x03
#define IRP$S_MODE	2
#define IRP$V_FCODE	0
#define IRP$M_FCODE	0x3F
#define IRP$S_FCODE	6
#define IRP$V_FMOD	6
#define IRP$M_FMOD	0xFFC0
#define IRP$S_FMOD	10
#define IRP$V_CLN_READY 0
#define IRP$V_CLN_DONE	1
#define IRP$V_CPY_FINI	2
#define IRP$M_CLN_READY (1<<IRP$V_CLN_READY)	/* 0x01 */
#define IRP$M_CLN_DONE	(1<<IRP$V_CLN_DONE)	/* 0x02 */
#define IRP$M_CPY_FINI	(1<<IRP$V_CPY_FINI)	/* 0x04 */
#define IRP$V_BUFIO	0
#define IRP$V_FUNC	1
#define IRP$V_PAGIO	2
#define IRP$V_COMPLX	3
#define IRP$V_VIRTUAL	4
#define IRP$V_CHAINED	5
#define IRP$V_SWAPIO	6
#define IRP$V_DIAGBUF	7
#define IRP$V_PHYSIO	8
#define IRP$V_TERMIO	9
#define IRP$V_MBXIO	10
#define IRP$V_EXTEND	11
#define IRP$V_FILACP	12
#define IRP$V_MVIRP	13
#define IRP$V_SRVIO	14
#define IRP$V_KEY	15
#define IRP$M_BUFIO	(1<<IRP$V_BUFIO)	/* 0x01 */
#define IRP$M_FUNC	(1<<IRP$V_FUNC)		/* 0x02 */
#define IRP$M_PAGIO	(1<<IRP$V_PAGIO)	/* 0x04 */
#define IRP$M_COMPLX	(1<<IRP$V_COMPLX)	/* 0x08 */
#define IRP$M_VIRTUAL	(1<<IRP$V_VIRTUAL)	/* 0x10 */
#define IRP$M_CHAINED	(1<<IRP$V_CHAINED)	/* 0x20 */
#define IRP$M_SWAPIO	(1<<IRP$V_SWAPIO)	/* 0x40 */
#define IRP$M_DIAGBUF	(1<<IRP$V_DIAGBUF)	/* 0x80 */
#define IRP$M_PHYSIO	(1<<IRP$V_PHYSIO)	/* 0x0100 */
#define IRP$M_TERMIO	(1<<IRP$V_TERMIO)	/* 0x0200 */
#define IRP$M_MBXIO	(1<<IRP$V_MBXIO)	/* 0x0400 */
#define IRP$M_EXTEND	(1<<IRP$V_EXTEND)	/* 0x0800 */
#define IRP$M_FILACP	(1<<IRP$V_FILACP)	/* 0x1000 */
#define IRP$M_MVIRP	(1<<IRP$V_MVIRP)	/* 0x2000 */
#define IRP$M_SRVIO	(1<<IRP$V_SRVIO)	/* 0x4000 */
#define IRP$M_KEY	(1<<IRP$V_KEY)		/* 0x8000 */
#define IRP$V_START_PAST_HWM	0
#define IRP$V_END_PAST_HWM	1
#define IRP$V_ERASE		2
#define IRP$V_PART_HWM		3
#define IRP$V_LCKIO		4
#define IRP$V_SHDIO		5
#define IRP$V_CACHEIO		6
#define IRP$M_START_PAST_HWM	(1<<IRP$V_START_PAST_HWM)	/* 0x01 */
#define IRP$M_END_PAST_HWM	(1<<IRP$V_END_PAST_HWM)		/* 0x02 */
#define IRP$M_ERASE		(1<<IRP$V_ERASE)		/* 0x04 */
#define IRP$M_PART_HWM		(1<<IRP$V_PART_HWM)		/* 0x08 */
#define IRP$M_LCKIO		(1<<IRP$V_LCKIO)		/* 0x10 */
#define IRP$M_SHDIO		(1<<IRP$V_SHDIO)		/* 0x20 */
#define IRP$M_CACHEIO		(1<<IRP$V_CACHEIO)		/* 0x40 */
#define IRP$K_CDRP	96	/* offset to the CDRP within the IRP */
#define IRP$C_CDRP	96
#define IRP$V_PIO_ERROR		0
#define IRP$V_PIO_FANOUT	1
#define IRP$V_PIO_NOQUE		2
#define IRP$V_PIO_CANCEL	3
#define IRP$V_PIO_CTHRDOK	4
#define IRP$M_PIO_ERROR		(1<<IRP$V_PIO_ERROR)	/* 0x01 */
#define IRP$M_PIO_FANOUT	(1<<IRP$V_PIO_FANOUT)	/* 0x02 */
#define IRP$M_PIO_NOQUE		(1<<IRP$V_PIO_NOQUE)	/* 0x04 */
#define IRP$M_PIO_CANCEL	(1<<IRP$V_PIO_CANCEL)	/* 0x08 */
#define IRP$M_PIO_CTHRDOK	(1<<IRP$V_PIO_CTHRDOK)	/* 0x10 */

#define IRP$S_NT_PRVMSK 8
#define IRP$S_STATION	8
#define IRP$S_TT_STATE	8
#define IRP$S_LBUFHNDL	12

#define IRP$K_BT_LEN	160
#define IRP$C_BT_LEN	160
#define IRP$K_CD_LEN	168
#define IRP$C_CD_LEN	168
#define IRP$K_LENGTH	168	/* length of standard IRP */
#define IRP$C_LENGTH	168
#define IRP$S_IRPDEF	168

struct irpdef {
    unsigned long irp$l_ioqfl;		/* i/o queue forward link */
    unsigned long irp$l_ioqbl;		/* i/o queue backward link */
    unsigned short irp$w_size;		/* size of irp in bytes */
    unsigned char irp$b_type;		/* structure type for irp */
    union {
	unsigned char irp$b_rmod;	/* access mode of request */
	struct {
	    unsigned irp$v_mode : 2;	/* mode subfield */
	    unsigned		: 6;	/* padding */
	} irp$r_rmod_bits;
    } irp$r_rmod_overlay;
    unsigned long irp$l_pid;		/* process id of requesting process */
    union {
	unsigned long irp$l_ast;	/* address of AST routine */
	unsigned long irp$l_shd_iofl;	/* link to clone IRPs */
    } irp$r_ast_overlay;
    union {
	unsigned long irp$l_astprm;	/* AST parameter */
	unsigned long irp$l_shad;	/* SHAD address */
	unsigned long irp$l_hrb;	/* HRB address */
    } irp$r_astprm_overlay;
    union {
	unsigned long irp$l_wind;	/* address of window block */
	unsigned long irp$l_mirp;	/* link to master IRP */
    } irp$r_wind_overlay;
    unsigned long irp$l_ucb;		/* address of device UCB */
    union {
	unsigned short irp$w_func;	/* I/O function code and modifiers */
	struct {
	    unsigned irp$v_fcode : 6;	/* function code field */
	    unsigned irp$v_fmod  : 10;	/* function modifier field */
	} irp$r_func_bits;
    } irp$r_func_overlay;
    union {
	unsigned char irp$b_efn;	/* event flag number and event group */
	unsigned char irp$b_cln_indx;	/* shadow clone membership index */
    } irp$r_efn_overlay;
    union {
	unsigned char irp$b_pri;	/* base priority of requesting process */
	unsigned char irp$b_shd_flags;	/* shadow clone flags */
	struct {
	    unsigned irp$v_cln_ready : 1;	/* clone is ready for I/O */
	    unsigned irp$v_cln_done  : 1;	/* clone has done I/O */
	    unsigned irp$v_cpy_fini  : 1;	/* copy is complete. */
	} irp$r_shd_flag_bits;
    } irp$r_pri_overlay;
    unsigned long irp$l_iosb;		/* address of I/O status double longword */
    unsigned short irp$w_chan;		/* process I/O channel number */
    union {
	unsigned short irp$w_sts;	/* request status */
	struct {
	    unsigned irp$v_bufio   : 1; /* buffered i/o flag ;these bits */
	    unsigned irp$v_func    : 1; /* 1=>read function ;must be adjacent */
	    unsigned irp$v_pagio   : 1; /* paging i/o flag ;and in order */
	    unsigned irp$v_complx  : 1; /* complex buffered i/o */
	    unsigned irp$v_virtual : 1; /* virtual i/o function */
	    unsigned irp$v_chained : 1; /* chained buffered i/o operation */
	    unsigned irp$v_swapio  : 1; /* swap i/o operation */
	    unsigned irp$v_diagbuf : 1; /* diagnostic buffer allocated */
	    unsigned irp$v_physio  : 1; /* physical i/o */
	    unsigned irp$v_termio  : 1; /* terminal i/o (for selecting priority inc) */
	    unsigned irp$v_mbxio   : 1; /* mailbox buffered read */
	    unsigned irp$v_extend  : 1; /* an IRPE is linked to this IRP */
	    unsigned irp$v_filacp  : 1; /* file ACP i/o (both diocnt and biocnt) */
	    unsigned irp$v_mvirp   : 1; /* mount verification IRP */
	    unsigned irp$v_srvio   : 1; /* server type i/o (trigger mountver on error but don't stall) */
	    unsigned irp$v_key	   : 1; /* key for encryption */
	} irp$r_sts_bits;
    } irp$r_sts_overlay;
    unsigned long irp$l_svapte;		/* system virtual address of first PTE */
    unsigned short irp$w_boff;		/* byte offset in first page */
    union {
	unsigned long irp$l_bcnt;	/* byte count of transfer */
	unsigned short irp$w_bcnt;	/* old word definition for compatibility */
    } irp$r_bcnt_overlay;
    union {
	short irp$w_sts2;		/* extension of status word */
	struct {
	    unsigned irp$v_start_past_hwm : 1;	/* i/o starts past highwater mark */
	    unsigned irp$v_end_past_hwm : 1;	/* i/o ends past highwater mark */
	    unsigned irp$v_erase	: 1;	/* erase i/o function */
	    unsigned irp$v_part_hwm	: 1;	/* partial highwater mark update */
	    unsigned irp$v_lckio	: 1;	/* locked i/o request (DECnet) */
	    unsigned irp$v_shdio	: 1;	/* this is a shadowing IRP */
	    unsigned irp$v_cacheio	: 1;	/* uses VBN cache buffers */
	} irp$r_sts2_bits;
    } irp$r_sts2_overlay;
    union {
	unsigned long irp$l_iost1;	/* first i/o status longword (for i/o post) */
	unsigned long irp$l_media;	/* media address */
    } irp$r_iost1_overlay;
    union {
	unsigned long irp$l_iost2;	/* second i/o status longword */
	union {
	    unsigned long irp$l_tt_term; /* address of read terminators mask */
	    unsigned char irp$b_carcon;  /* carriage control */
	} irp$r_tt_term_overlay;
    } irp$r_iost2_overlay;
    union {
	long irp$q_nt_prvmsk[2];	/* privilege mask for DECnet */
	long irp$q_station[2];		/* station field for DECnet drivers */
	union {
	    long irp$q_tt_state[2];	/* terminal state definitions */
	    struct {
		union {
		    unsigned long irp$l_abcnt;	/* accumulated bytes transfered */
		    unsigned short irp$w_abcnt; /* old word definition for compatibility */
		} irp$r_abcnt_overlay;
		union {
		    unsigned long irp$l_obcnt;	/* original transfer byte count */
		    unsigned short irp$w_obcnt; /* old word definition for compatibility */
		} irp$r_obcnt_overlay;
	    } irp$r_tt_state_fields;
	} irp$r_tt_state_overlay;
    } irp$r_nt_prvmsk_overlay;
    unsigned long irp$l_segvbn;		/* virtual block number of current segment */
    union {
	unsigned long irp$l_diagbuf;	/* diagnostic buffer address */
	unsigned long irp$l_scb_buf;	/* SCB buffer address */
	unsigned short irp$w_tt_prmpt;	/* prompt size */
    } irp$r_diagbuf_overlay;
    unsigned long irp$l_seqnum;		/* sequence number */
    unsigned long irp$l_extend;		/* address of IRPE */
    union {
	unsigned long irp$l_arb;	/* access rights block address */
	unsigned long irp$l_shdspc;	/* shadowing return PC */
    } irp$r_arb_overlay;
    union {
	unsigned long irp$l_keydesc;	/* address of encryption descriptor */
	unsigned char irp$b_cpy_mode;	/* copy mode identifier */
    } irp$r_keydesc_overlay;

    /* Standard IRP must contain space for Class Driver CDRP fields. */
    unsigned long irp$l_fqfl;		/* fork queue flink */
    unsigned long irp$l_fqbl;		/* fork queue blink */
    unsigned short irp$w_cdrpsize;	/* size field for positive section only */
    unsigned char irp$b_cd_type;	/* type, always of interest */
    union {
	unsigned char irp$b_flck;	/* fork lock number */
	unsigned char irp$b_fipl;	/* fork IPL */
    } irp$r_flck_overlay;
    unsigned long irp$l_fpc;		/* fork PC */
    unsigned long irp$l_fr3;		/* fork R3 */
    unsigned long irp$l_fr4;		/* fork R4 */
    unsigned long irp$l_savd_rtn;	/* saved return address from level 1 JSB */
    union {
	unsigned long irp$l_msg_buf;	  /* address of allocated MSCP buffer */
	unsigned long irp$l_shd_lock_fr4; /* lock fork R4 */
    } irp$r_msg_buf_overlay;
    union {
	unsigned long irp$l_rspid;	  /* allocated request ID */
	unsigned long irp$l_shd_lock_fr5; /* lock fork R5 */
    } irp$r_rspid_overlay;
    union {
	unsigned long irp$l_cdt;	  /* address of connection descriptor table */
	unsigned long irp$l_shd_lock_fr0; /* R0 = lock mode */
    } irp$r_cdt_overlay;
    unsigned long irp$l_rwcptr;		/* RWAITCNT pointer */

    /* Extensions to the CDRP within the IRP */
    union {	/* CDRP extensions */

	/* Host-Based Shadowing Extension */
	struct {
	    unsigned long irp$l_shd_pio_lnk;	/* link to clone IRP(s) */
	    unsigned char irp$b_shd_pio_cnt;	/* tot num phys IRPs assoc. */
	    unsigned char irp$b_shd_pio_act;	/* tot num phys IRPs active. */
	    union {
		unsigned char irp$b_shd_pio_flags;	/* master flags byte */
		struct {
		    unsigned irp$v_pio_error   : 1;	/* errant clone in Chain */
		    unsigned irp$v_pio_fanout  : 1;	/* chained Clones. */
		    unsigned irp$v_pio_noque   : 1;	/* don't queue to server */
		    unsigned irp$v_pio_cancel  : 1;	/* this master cancelled */
		    unsigned irp$v_pio_cthrdok : 1;	/* copy thread validated. */
		} irp$r_pio_bits;
	    } irp$r_pio_overlay;
	    unsigned char irp$b_shd_pio_errcnt;		/* number of errors in chain */
	    unsigned long irp$l_shd_pio_error;		/* bcnt and srror status (SS$_) */
	    unsigned char irp$b_shd_pio_errindex;	/* index of erring device */
	    unsigned char irp$b_shd_pio_errsev;		/* relative error severity */
	    unsigned	: 16;				/* short fill; */
	    unsigned long irp$l_shd_lock_fpc;		/* lock fork PC */
	    unsigned long irp$l_shd_lock_fr1;		/* lock fork R1 */
	    unsigned long irp$l_shd_lock_fr2;		/* lock fork R2 */
	} irp$r_shadowing_extension;

	/* Block Transfer Extension */
	struct {
	    unsigned long irp$l_lbufh_ad;	/* local buffer handle adress */
	    unsigned long irp$l_lboff;		/* local byte offset */
	    union {
		unsigned long irp$l_rbufh_ad;	/* remote buffer handle adress */
		unsigned long irp$l_cdrpfl;
	    } irp$r_rbufh_ad_overlay;
	    unsigned long irp$l_rboff;		/* remote byte offset */
	    unsigned long irp$l_xct_len;	/* transfer length in bytes */
	} irp$r_blk_xfer_extension;

	/* Class Driver Extension */
	struct {
	    unsigned long irp$l_lbufh_ad;	/* local buffer handle adress */
	    char irp$t_lbufhndl[12];		/* local buffer handle */
	    unsigned long irp$l_ubarsrce;	/* UNIBUS mapping resources allocated */
	    unsigned long irp$l_dutuflags;	/* class driver status flags: */
	    unsigned short irp$w_dutucntr;	/* general purpose counter */
	    unsigned short irp$w_endmsgsiz;	/* size of most recent MSCP end message */
	} irp$r_cls_drv_extension;

	/* File system extensions */
	unsigned long irp$l_erase_vbn;		/* VBN to start HWM erase */

    } irp$r_cdrp_extensions;

}; /* irpdef */

#endif	/*_IRPDEF_H*/
