/* <opcdef.h>
 *
 *	OPCOM request definitions
 */
#ifndef _OPCDEF_H
#define _OPCDEF_H

/* operator message types */
#define OPC$_RQ_TERME	1	/* ENABLE TERMINAL */
#define OPC$_RQ_LOGI	2	/* INITIALIZE THE LOG */
#define OPC$_RQ_RQST	3	/* OPERATOR REQUEST */
#define OPC$_RQ_REPLY	4	/* OPERATOR REPLY */
#define OPC$_RQ_CANCEL	5	/* CANCEL REQUEST */
#define OPC$_RQ_STATUS	6	/* REQUEST OPERATOR STATUS */
#define OPC$_RQ_SECURITY 7	/* MESSAGE TO SECURITY OPERATOR */
#define OPC$_RQ_LICENSE 8	/* MESSAGE TO LICENSE OPERATOR */

#define OPC$V_NM_CENTRL 0
#define OPC$V_NM_PRINT	1
#define OPC$V_NM_TAPES	2
#define OPC$V_NM_DISKS	3
#define OPC$V_NM_DEVICE 4
#define OPC$V_NM_CARDS	5
#define OPC$V_NM_NTWORK 6
#define OPC$V_NM_CLUSTER  7
#define OPC$V_NM_SECURITY 8
#define OPC$V_NM_REPLY	  9
#define OPC$V_NM_SOFTWARE 10
#define OPC$V_NM_LICENSE  11
#define OPC$V_NM_OPER1	12
#define OPC$V_NM_OPER2	13
#define OPC$V_NM_OPER3	14
#define OPC$V_NM_OPER4	15
#define OPC$V_NM_OPER5	16
#define OPC$V_NM_OPER6	17
#define OPC$V_NM_OPER7	18
#define OPC$V_NM_OPER8	19
#define OPC$V_NM_OPER9	20
#define OPC$V_NM_OPER10 21
#define OPC$V_NM_OPER11 22
#define OPC$V_NM_OPER12 23
#define OPC$M_NM_CENTRL (1<<OPC$V_NM_CENTRL)	/* 0x01 */
#define OPC$M_NM_PRINT	(1<<OPC$V_NM_PRINT)	/* 0x02 */
#define OPC$M_NM_TAPES	(1<<OPC$V_NM_TAPES)	/* 0x04 */
#define OPC$M_NM_DISKS	(1<<OPC$V_NM_DISKS)	/* 0x08 */
#define OPC$M_NM_DEVICE (1<<OPC$V_NM_DEVICE)	/* 0x10 */
#define OPC$M_NM_CARDS	(1<<OPC$V_NM_CARDS)	/* 0x20 */
#define OPC$M_NM_NTWORK (1<<OPC$V_NM_NTWORK)	/* 0x40 */
#define OPC$M_NM_CLUSTER (1<<OPC$V_NM_CLUSTER)	/* 0x80 */
#define OPC$M_NM_SECURITY (1<<OPC$V_NM_SECURITY) /* 0x0100 */
#define OPC$M_NM_REPLY	(1<<OPC$V_NM_REPLY)	/* 0x0200 */
#define OPC$M_NM_SOFTWARE (1<<OPC$V_NM_SOFTWARE) /* 0x0400 */
#define OPC$M_NM_LICENSE (1<<OPC$V_NM_LICENSE)	/* 0x0800 */
#define OPC$M_NM_OPER1	(1<<OPC$V_NM_OPER1)	/* 0x1000 */
#define OPC$M_NM_OPER2	(1<<OPC$V_NM_OPER2)	/* 0x2000 */
#define OPC$M_NM_OPER3	(1<<OPC$V_NM_OPER3)	/* 0x4000 */
#define OPC$M_NM_OPER4	(1<<OPC$V_NM_OPER4)	/* 0x8000 */
#define OPC$M_NM_OPER5	(1<<OPC$V_NM_OPER5)	/* 0x010000 */
#define OPC$M_NM_OPER6	(1<<OPC$V_NM_OPER6)	/* 0x020000 */
#define OPC$M_NM_OPER7	(1<<OPC$V_NM_OPER7)	/* 0x040000 */
#define OPC$M_NM_OPER8	(1<<OPC$V_NM_OPER8)	/* 0x080000 */
#define OPC$M_NM_OPER9	(1<<OPC$V_NM_OPER9)	/* 0x100000 */
#define OPC$M_NM_OPER10 (1<<OPC$V_NM_OPER10)	/* 0x200000 */
#define OPC$M_NM_OPER11 (1<<OPC$V_NM_OPER11)	/* 0x400000 */
#define OPC$M_NM_OPER12 (1<<OPC$V_NM_OPER12)	/* 0x800000 */

struct opcdef {
    unsigned char opc$b_ms_type;	/* message type */
    union {
	unsigned char opc$b_ms_target;	/* message target */
	unsigned char opc$b_ms_enab;	/* message enables */
    } opc$r_ms_target_overlay;
    unsigned short opc$w_ms_status;	/* message status */
    union {
	unsigned long opc$l_ms_rplyid;	/* reply id */
	union {
	    unsigned long opc$l_ms_mask; /* message mask */
	    unsigned long opc$l_ms_rqstid; /* request id */
	} opc$r_ms_mask_overlay;
    } opc$r_ms_rplyid_overlay;
    union {
	unsigned long opc$l_ms_text;	/* message text */
	struct {
	    unsigned short opc$w_ms_ounit; /* operator unit number */
	    char opc$t_ms_oname;	/* operator name */
	} opc$r_ms_text_fields;
    } opc$r_ms_text_overlay;
    short opcdef_fill[7];		/* space for name */
    unsigned long opc$l_ms_otext[32];	/* operator text */
    union {
	unsigned long opc$l_ms_maxsz;	/* message max size */
	struct {
	    unsigned opc$v_nm_centrl	: 1;
	    unsigned opc$v_nm_print	: 1;
	    unsigned opc$v_nm_tapes	: 1;
	    unsigned opc$v_nm_disks	: 1;
	    unsigned opc$v_nm_device	: 1;
	    unsigned opc$v_nm_cards	: 1;
	    unsigned opc$v_nm_ntwork	: 1;
	    unsigned opc$v_nm_cluster	: 1;
	    unsigned opc$v_nm_security	: 1;
	    unsigned opc$v_nm_reply	: 1;
	    unsigned opc$v_nm_software	: 1;
	    unsigned opc$v_nm_license	: 1;
	    unsigned opc$v_nm_oper1	: 1;
	    unsigned opc$v_nm_oper2	: 1;
	    unsigned opc$v_nm_oper3	: 1;
	    unsigned opc$v_nm_oper4	: 1;
	    unsigned opc$v_nm_oper5	: 1;
	    unsigned opc$v_nm_oper6	: 1;
	    unsigned opc$v_nm_oper7	: 1;
	    unsigned opc$v_nm_oper8	: 1;
	    unsigned opc$v_nm_oper9	: 1;
	    unsigned opc$v_nm_oper10	: 1;
	    unsigned opc$v_nm_oper11	: 1;
	    unsigned opc$v_nm_oper12	: 1;
	} opc$r_ms_maxsz_bits;
    } opc$r_ms_maxsz_overlay;
};

#endif	/*_OPCDEF_H*/
