/* <vms/lib/orbdef.h>
 *
 *	LIB - object rights block		[not in Starlet]
 */
#ifndef _ORBDEF_H
#define _ORBDEF_H

/*
   Object's Rights Block - structure defining the protection information
   for various objects within the system.
 */
#define ORB$V_PROT_16		0
#define ORB$V_ACL_QUEUE		1
#define ORB$V_MODE_VECTOR	2
#define ORB$V_NOACL		3
#define ORB$V_CLASS_PROT	4
#define ORB$M_PROT_16		(1<<ORB$V_PROT_16)	/* 0x01 */
#define ORB$M_ACL_QUEUE		(1<<ORB$V_ACL_QUEUE)	/* 0x02 */
#define ORB$M_MODE_VECTOR	(1<<ORB$V_MODE_VECTOR)	/* 0x04 */
#define ORB$M_NOACL		(1<<ORB$V_NOACL)	/* 0x08 */
#define ORB$M_CLASS_PROT	(1<<ORB$V_CLASS_PROT)	/* 0x10 */

#define ORB$S_MODE_PROT 8
#define ORB$S_MIN_CLASS 20
#define ORB$S_MAX_CLASS 20

#define ORB$K_LENGTH	88	/* structure length */
#define ORB$C_LENGTH	88
#define ORB$S_ORBDEF	88

struct orbdef {
    union {
	unsigned long orb$l_owner;	/* object's owner */
	struct {
	    unsigned short orb$w_uicmember;	/* member number */
	    unsigned short orb$w_uicgroup;	/* group number */
	} orb$r_owner_fields;
    } orb$r_owner_overlay;
    unsigned long orb$l_acl_mutex;	/* mutex for this ACL */
    unsigned short orb$w_size;		/* size of the ORB in bytes */
    unsigned char orb$b_type;		/* structure type */
    union {
	unsigned char orb$b_flags;	/* field modifiers */
	struct {
	    unsigned orb$v_prot_16     : 1;	/* use word not vector protection */
	    unsigned orb$v_acl_queue   : 1;	/* use ACL queue not descriptor list */
	    unsigned orb$v_mode_vector : 1;	/* use vector not byte mode protection */
	    unsigned orb$v_noacl       : 1;	/* object cannot have an ACL */
	    unsigned orb$v_class_prot  : 1;	/* security classification is valid */
	} orb$r_flags_bits;
    } orb$r_flags_overlay;
    unsigned	: 16;			/* short fill; unused */
    unsigned short orb$w_refcount;	/* reference count */
    union {
	long orb$q_mode_prot[2];	/* mode protection vector */
	struct {
	    unsigned long orb$l_mode_protl;	/* low longword of vector */
	    unsigned long orb$l_mode_proth;	/* high longword of vector */
	} orb$r_mode_fields;
	unsigned char orb$b_mode;	/* simple access mode */
    } orb$r_mode_overlay;
    union {
	unsigned long orb$l_sys_prot;	/* system protection field */
	unsigned short orb$w_prot;	/* standard SOGW protection */
    } orb$r_sys_prot_overlay;
    unsigned long orb$l_own_prot;	/* owner protection field */
    unsigned long orb$l_grp_prot;	/* group protection field */
    unsigned long orb$l_wor_prot;	/* world protection field */
    union {
	unsigned long orb$l_aclfl;	/* ACL queue forward link */
	unsigned long orb$l_acl_count;	/* count of ACL segments */
    } ord$r_acl_1_overlay;
    union {
	unsigned long orb$l_aclbl;	/* ACL queue backward link */
	unsigned long orb$l_acl_desc;	/* address of ACL segment descriptor list */
    } ord$r_acl_2_overlay;
    struct {
	unsigned char orb$r_min_class[20];
    } orb$r_min_class;
    struct {
	unsigned char orb$r_max_class[20];
    } orb$r_max_class;
};

#endif	/*_ORBDEF_H*/
