/* <vms/lib/pcbdef.h>
 *
 *	LIB - Process Control Block definitions		[not in Starlet]
 */
#ifndef _PCBDEF_H
#define _PCBDEF_H

/* PCB definitions */
#define PCB$V_RES	0
#define PCB$V_DELPEN	1
#define PCB$V_FORCPEN	2
#define PCB$V_INQUAN	3
#define PCB$V_PSWAPM	4
#define PCB$V_RESPEN	5
#define PCB$V_SSFEXC	6
#define PCB$V_SSFEXCE	7
#define PCB$V_SSFEXCS	8
#define PCB$V_SSFEXCU	9
#define PCB$V_SSRWAIT	10
#define PCB$V_SUSPEN	11
#define PCB$V_WAKEPEN	12
#define PCB$V_WALL	13
#define PCB$V_BATCH	14
#define PCB$V_NOACNT	15
#define PCB$V_NOSUSPEND 16
#define PCB$V_ASTPEN	17
#define PCB$V_PHDRES	18
#define PCB$V_HIBER	19
#define PCB$V_LOGIN	20
#define PCB$V_NETWRK	21
#define PCB$V_PWRAST	22
#define PCB$V_NODELET	23
#define PCB$V_DISAWS	24
#define PCB$V_INTER	25
#define PCB$V_RECOVER	26
#define PCB$V_SECAUDIT	27
#define PCB$V_HARDAFF	28
#define PCB$V_ERDACT	29
#define PCB$V_SOFTSUSP	30
#define PCB$V_PREEMPTED 31
#define PCB$M_RES	(1<<PCB$V_RES)		/* 0x01 */
#define PCB$M_DELPEN	(1<<PCB$V_DELPEN)	/* 0x02 */
#define PCB$M_FORCPEN	(1<<PCB$V_FORCPEN)	/* 0x04 */
#define PCB$M_INQUAN	(1<<PCB$V_INQUAN)	/* 0x08 */
#define PCB$M_PSWAPM	(1<<PCB$V_PSWAPM)	/* 0x10 */
#define PCB$M_RESPEN	(1<<PCB$V_RESPEN)	/* 0x20 */
#define PCB$M_SSFEXC	(1<<PCB$V_SSFEXC)	/* 0x40 */
#define PCB$M_SSFEXCE	(1<<PCB$V_SSFEXCE)	/* 0x80 */
#define PCB$M_SSFEXCS	(1<<PCB$V_SSFEXCS)	/* 0x0100 */
#define PCB$M_SSFEXCU	(1<<PCB$V_SSFEXCU)	/* 0x0200 */
#define PCB$M_SSRWAIT	(1<<PCB$V_SSRWAIT)	/* 0x0400 */
#define PCB$M_SUSPEN	(1<<PCB$V_SUSPEN)	/* 0x0800 */
#define PCB$M_WAKEPEN	(1<<PCB$V_WAKEPEN)	/* 0x1000 */
#define PCB$M_WALL	(1<<PCB$V_WALL)		/* 0x2000 */
#define PCB$M_BATCH	(1<<PCB$V_BATCH)	/* 0x4000 */
#define PCB$M_NOACNT	(1<<PCB$V_NOACNT)	/* 0x8000 */
#define PCB$M_NOSUSPEND (1<<PCB$V_NOSUSPEND)	/* 0x010000 */
#define PCB$M_ASTPEN	(1<<PCB$V_ASTPEN)	/* 0x020000 */
#define PCB$M_PHDRES	(1<<PCB$V_PHDRES)	/* 0x040000 */
#define PCB$M_HIBER	(1<<PCB$V_HIBER)	/* 0x080000 */
#define PCB$M_LOGIN	(1<<PCB$V_LOGIN)	/* 0x100000 */
#define PCB$M_NETWRK	(1<<PCB$V_NETWRK)	/* 0x200000 */
#define PCB$M_PWRAST	(1<<PCB$V_PWRAST)	/* 0x400000 */
#define PCB$M_NODELET	(1<<PCB$V_NODELET)	/* 0x800000 */
#define PCB$M_DISAWS	(1<<PCB$V_DISAWS)	/* 0x01000000 */
#define PCB$M_INTER	(1<<PCB$V_INTER)	/* 0x02000000 */
#define PCB$M_RECOVER	(1<<PCB$V_RECOVER)	/* 0x04000000 */
#define PCB$M_SECAUDIT	(1<<PCB$V_SECAUDIT)	/* 0x08000000 */
#define PCB$M_HARDAFF	(1<<PCB$V_HARDAFF)	/* 0x10000000 */
#define PCB$M_ERDACT	(1<<PCB$V_ERDACT)	/* 0x20000000 */
#define PCB$M_SOFTSUSP	(1<<PCB$V_SOFTSUSP)	/* 0x40000000 */
#define PCB$M_PREEMPTED (1<<PCB$V_PREEMPTED)	/* 0x80000000 */
#define PCB$V_QUANTUM_RESCHED	0
#define PCB$V_FORK_RESPEN	1
#define PCB$V_POSIX_SIGNAL	2
#define PCB$V_EPID_WILD		31
#define PCB$M_QUANTUM_RESCHED	(1<<PCB$V_QUANTUM_RESCHED)	/* 0x01 */
#define PCB$M_FORK_RESPEN	(1<<PCB$V_FORK_RESPEN)		/* 0x02 */
#define PCB$M_POSIX_SIGNAL	(1<<PCB$V_POSIX_SIGNAL)		/* 0x04 */
#define PCB$M_EPID_WILD		(1<<PCB$V_EPID_WILD)		/* 0x80000000 */

#define PCB$S_TERMINAL	8
#define PCB$S_EPID_PROC 21
#define PCB$S_EPID_NODE_IDX	8
#define PCB$S_EPID_NODE_SEQ	2
#define PCB$S_PCBARB	124
#define PCB$S_PRIV	8
#define PCB$S_LNAME	16
#define PCB$S_CWPSSRV_QUEUE	8
#define PCB$S_BUFOBJ_LIST	8
#define PCB$S_XSCB_QUE	8
#define PCB$S_RMCB_QUE	8
#define PCB$S_CD_QUE	8

#define PCB$K_SCHED_OTHER	0	/* Native VMS policy (MBZ) */
#define PCB$K_SCHED_FIFO	1	/* VIP FIFO policy */
#define PCB$K_SCHED_RR		2	/* VIP Round-Robbin policy */

#define PCB$K_LENGTH	432	/* length of PCB */
#define PCB$C_LENGTH	432
#define PCB$S_PCBDEF	432

struct pcbdef {
    unsigned long pcb$l_sqfl;		/* state queue forward link */
    unsigned long pcb$l_sqbl;		/* state queue backward link */
    unsigned short pcb$w_size;		/* size in bytes */
    unsigned char pcb$b_type;		/* structure type code for PCB */
    unsigned char pcb$b_wefc;		/* waiting EF cluster number */
    unsigned long pcb$l_phypcb;		/* physical address of HW PCB */
    unsigned long pcb$l_astqfl;		/* AST queue forward link(head) */
    unsigned long pcb$l_astqbl;		/* AST queue back link(tail) */
    unsigned char pcb$b_astact;		/* access modes with active ASTs */
    unsigned char pcb$b_asten;		/* access modes with ASTs enabled */
    unsigned short pcb$w_state;		/* process state */
    unsigned char pcb$b_pri;		/* process current priority */
    unsigned char pcb$b_prib;		/* base priority */
    unsigned char pcb$b_reserved_b1;	/* reserved */
    unsigned char pcb$b_affinity_skip;	/* affinity skip count */
    unsigned long pcb$l_owner;		/* PID of creator */
    union {
	unsigned long pcb$l_sts;	/* process status flags */
	struct {
	    unsigned pcb$v_res	     : 1; /* resident, in balance set */
	    unsigned pcb$v_delpen    : 1; /* delete pending */
	    unsigned pcb$v_forcpen   : 1; /* force exit pending */
	    unsigned pcb$v_inquan    : 1; /* initial quantum in progress */
	    unsigned pcb$v_pswapm    : 1; /* process swap mode (1=noswap) */
	    unsigned pcb$v_respen    : 1; /* resume pending, skip suspend */
	    unsigned pcb$v_ssfexc    : 1; /* system service exception enable (K) */
	    unsigned pcb$v_ssfexce   : 1; /* system service exception enable (E) */
	    unsigned pcb$v_ssfexcs   : 1; /* system service exception enable (S) */
	    unsigned pcb$v_ssfexcu   : 1; /* system service exception enable (U) */
	    unsigned pcb$v_ssrwait   : 1; /* system service resource wait disable */
	    unsigned pcb$v_suspen    : 1; /* suspend pending */
	    unsigned pcb$v_wakepen   : 1; /* wake pending, skip hibernate */
	    unsigned pcb$v_wall      : 1; /* wait for all events in mask */
	    unsigned pcb$v_batch     : 1; /* process is a batch job */
	    unsigned pcb$v_noacnt    : 1; /* no accounting for process */
	    unsigned pcb$v_nosuspend : 1; /* process cannot be suspended */
	    unsigned pcb$v_astpen    : 1; /* AST pending */
	    unsigned pcb$v_phdres    : 1; /* process header resident */
	    unsigned pcb$v_hiber     : 1; /* hibernate after initial image activate */
	    unsigned pcb$v_login     : 1; /* login without reading auth file */
	    unsigned pcb$v_netwrk    : 1; /* network connected job */
	    unsigned pcb$v_pwrast    : 1; /* power fail AST */
	    unsigned pcb$v_nodelet   : 1; /* no delete */
	    unsigned pcb$v_disaws    : 1; /* 1=disable automatic WS adjustment */
	    unsigned pcb$v_inter     : 1; /* process is an interactive job */
	    unsigned pcb$v_recover   : 1; /* process can recover locks */
	    unsigned pcb$v_secaudit  : 1; /* mandatory security auditing */
	    unsigned pcb$v_hardaff   : 1; /* process is bound to particular CPU */
	    unsigned pcb$v_erdact    : 1; /* exec mode rundown active */
	    unsigned pcb$v_softsusp  : 1; /* process is in "soft" suspend */
	    unsigned pcb$v_preempted : 1; /* hard suspend has preempted soft */
	} pcb$r_sts_bits;
    } pcb$r_sts_overlay;
    union {
	unsigned long pcb$l_sts2;	/* process status flags (2nd lw) */
	struct {
	    unsigned pcb$v_quantum_resched : 1; /* Quantum-oriented process reschedule */
	    unsigned pcb$v_fork_respen	   : 1; /* resume pending bit for a posix forked process */
	    unsigned pcb$v_posix_signal    : 1; /* pending and deliverable posix signal/event */
	    unsigned			  : 29; /* padding */
	} pcb$r_sts2_bits;
    } pcb$r_sts2_overlay;
    union {
	unsigned long pcb$l_wtime;	/* time at start of wait */
	struct {
	    unsigned char pcb$b_prisav;		/* saved current priority */
	    unsigned char pcb$b_pribsav;	/* save base priority */
	    unsigned char pcb$b_dpc;		/* delete pending count */
	    unsigned char pcb$b_authpri;	/* initial process priority */
	} pcb$r_wtime_fields;
    } pcb$r_wtime_overlay;
    unsigned long pcb$l_onqtime;	/* abs time when placed on COM/COMO queue, */
					/*  adjusted for process wait time	   */
    unsigned long pcb$l_waitime;	/* abs time of last process event */
    unsigned short pcb$w_astcnt;	/* AST count remaining */
    unsigned short pcb$w_biocnt;	/* buffered i/o count remaining */
    unsigned short pcb$w_biolm;		/* buffered i/o limit */
    unsigned short pcb$w_diocnt;	/* direct i/o count remaining */
    unsigned short pcb$w_diolm;		/* direct i/o count limit */
    unsigned short pcb$w_prccnt;	/* subprocess count */
    char pcb$t_terminal[8];		/* terminal device name string for interactive jobs */
    union {
	unsigned long pcb$l_pqb;	/* pointer to process quota block (process creation only) */
	unsigned long pcb$l_efwm;	/* event flag wait mask */
    } pcb$r_pqb_overlay;
    unsigned long pcb$l_efcs;		/* local event flag cluster,system */
    unsigned long pcb$l_efcu;		/* local event flag cluster, user */
    union {
	struct {
	    unsigned short pcb$w_pgflchar; /* page file characteristics */
	    unsigned char pcb$b_pgflindex; /* desired system page file index */
	    unsigned	: 8, : 32;
	} pcb$r_pgfl_fields;
	struct {
	    unsigned long pcb$l_efc2p;	/* pointer to global cluster !2 */
	    unsigned long pcb$l_efc3p;	/* pointer to global cluster !3 */
	} pcb$r_cefc_fields;
    } pcb$r_cefc_overlay;
    unsigned long pcb$l_pid;		/* process id used by exec on local node only */
    /* Warning - the internal structure of the epid is subject to radical change      */
    /* between versions of VMS.  No assumptions should ever be made about its format. */
    union {
	unsigned long pcb$l_epid;	/* cluster-wide process id seen by the world */
	struct {
	    unsigned pcb$v_epid_proc	 : 21;	/* process id field, can convert to pcb$l_pid */
	    unsigned pcb$v_epid_node_idx : 8;	/* idx - index to table of node identifications */
	    unsigned pcb$v_epid_node_seq : 2;	/* seq - sequence number for node table entry reuse */
	    unsigned pcb$v_epid_wild	 : 1;	/* flag that epid is wildcard context for $getjpi, and not a valid epid */
	} pcb$r_epid_bits;
    } pcb$r_epid_overlay;
    unsigned long pcb$l_eowner;		/* epid of process owner */
    unsigned long pcb$l_phd;		/* process header address */
    unsigned short pcb$w_aptcnt;	/* active page table count */
    unsigned short pcb$w_mtxcnt;	/* count of mutex semaphores owned */
    unsigned long pcb$l_gpgcnt;		/* global page count in WS */
    unsigned long pcb$l_ppgcnt;		/* process page count in WS */
    unsigned long pcb$l_jib;		/* address of job information block */
    unsigned long pcb$l_wsswp;		/* swap file disk address */
    unsigned long pcb$l_swapsize;	/* swap block allocation */
    struct {	/* pcbarb */
	long pcb$q_priv[2];		/* current privilege mask */
	unsigned long pcb$l_arb;	/* address of access rights block */
	char pcbarb$$_fill_1[48];
	union {
	    unsigned long pcb$l_uic;	/* logon UIC of process */
	    struct {
		unsigned short pcb$w_mem;	/* member number in UIC */
		unsigned short pcb$w_grp;	/* group number in UIC */
	    } pcb$r_uic_fields;
	} pcb$r_uic_overlay;
	char pcbarb$$_fill_2[60];
    } pcb$r_pcbarb;
    unsigned long pcb$l_orb;		/* address of the ORB */
    unsigned	: 16;			/* short fill; spare */
    unsigned short pcb$w_tmbu;		/* termination mailbox unit no. */
    unsigned long pcb$l_lockqfl;	/* lock queue forward link */
    unsigned long pcb$l_lockqbl;	/* lock queue backward link */
    unsigned long pcb$l_dlckpri;	/* deadlock resolution priority */
    unsigned long pcb$l_ipast;		/* vector of mode bits for IPASTs */
    unsigned long pcb$l_defprot;	/* process default protection */
    unsigned long pcb$l_pmb;		/* PMB address */
    unsigned long pcb$l_affinity;	/* CPU id for affinity */
    union {
	unsigned long pcb$l_sched_spare;	/* spare for scheduler */
	unsigned char pcb$b_sched_policy;	/* POSIX sched policy */
    } pcb$r_sched_overlay;
    unsigned long pcb$l_capability;	/* CPU capability selection bitmask */
    unsigned long pcb$l_cpu_id;		/* physical CPU id */
    unsigned long pcb$l_cputim;		/* accumulated CPU time at last outswap */
    char pcb$t_lname[16];		/* logical name of process */
    unsigned long pcb$l_prcpdb;		/* address of process performance data block */
					/*  NB: for DIGITAL software use only ***** */
    unsigned long pcb$l_pixhist;	/* PIXSCAN history summary LW */
    union {
	unsigned long pcb$l_ns_reserved_q1;	/* reserved for VP */
	unsigned long pcb$l_ns_reserved_q1_l1;
	unsigned long pcb$l_vp_context;		/* address of vector context area */
    } pcb$r_vp_overlay;
    unsigned long pcb$l_affinity_callback;	/* callback for breaking affinity */
    unsigned long pcb$l_permanent_capability;	/* permanent capability mask */
    unsigned long pcb$l_permanent_cpu_affinity; /* permanent CPU affinity */
    long pcb$q_cwpssrv_queue[2];		/* CWPS service block queue */
    unsigned long pcb$l_current_affinity;	/* current CPU mask */
    unsigned long pcb$l_capability_seq; /* copy of last sequence number */
    unsigned long pcb$l_xpcb;		/* address of the POSIX extended PCB */
    long pcb$q_bufobj_list[2];		/* defined buffer objects queue head */
    unsigned long pcb$l_adb_link;	/* address of AST Data Blocks (GEN) */
    unsigned short pcb$w_total_evtast;	/* total AST quota in use for event (GEN) */
    unsigned	: 16;			/* short fill; spare_tx1 */
    unsigned long pcb$a_current_tx;	/* pointer to process default transaction */
    unsigned long pcb$a_current_cd;	/* pointer to process default commit domain */
    unsigned long pcb$a_current_vertex; /* pointer to process default execution vertex */
    union {
	long pcb$q_xscb_que[2];		/* transaction segment list */
	struct {
	    unsigned long pcb$a_xscb_flink;
	    unsigned long pcb$a_xscb_blink;
	} pcb$r_xscb_que_fields;
    } pcb$r_xscb_que_overlay;
    union {
	long pcb$q_rmcb_que[2];		/* declared resource manager list */
	struct {
	    unsigned long pcb$a_rmcb_flink;
	    unsigned long pcb$a_rmcb_blink;
	} pcb$r_rmcb_que_fields;
    } pcb$r_rmcb_que_overlay;
    union {
	long pcb$q_cd_que[2];		/* commit domain membership list */
	struct {
	    unsigned long pcb$a_cd_flink;
	    unsigned long pcb$a_cd_blink;
	} pcb$r_cd_que_fields;
    } pcb$r_cd_que_overlay;
    unsigned long pcb$l_cputime_ref;	/* cputime at last tick time */
    unsigned long pcb$l_acc_waitime;	/* accumulated wait time */
};

#endif	/*_PCBDEF_H*/
