/* <ppl$routines.h>
 *
 *	Parallel processing run-time library routines.
 */
#ifndef _PPL$ROUTINES_H
#define _PPL$ROUTINES_H
# ifdef __cplusplus
extern "C" {
# endif

/*	PPL$ADJUST_QUORUM	-- adjust barrier quorum */
unsigned long ppl$adjust_quorum();
/*	PPL$ADJUST_SEMAPHORE_MAXIMUM -- adjust a semaphore maximum */
unsigned long ppl$adjust_semaphore_maximum();
/*	PPL$AWAIT_EVENT		-- await event occurrence */
unsigned long ppl$await_event();
/*	PPL$CREATE_APPLICATION	-- form or join a PPL$ application */
unsigned long ppl$create_application();
/*	PPL$CREATE_BARRIER	-- create a barrier */
unsigned long ppl$create_barrier();
/*	PPL$CREATE_EVENT	-- create an event */
unsigned long ppl$create_event();
/*	PPL$CREATE_SEMAPHORE	-- create a semaphore */
unsigned long ppl$create_semaphore();
/*	PPL$CREATE_SHARED_MEMORY -- create shared memory */
unsigned long ppl$create_shared_memory();
/*	PPL$CREATE_SPIN_LOCK	-- create spin lock */
unsigned long ppl$create_spin_loc();
/*	PPL$CREATE_VM_ZONE	-- create a new virtual memory zone */
unsigned long ppl$create_vm_zone();
/*	PPL$CREATE_WORK_QUEUE	-- create a work queue */
unsigned long ppl$create_work_queue();
/*	PPL$DECREMENT_SEMAPHORE -- decrement a semaphore */
unsigned long ppl$decrement_semaphore();
/*	PPL$DELETE_APPLICATION	-- delete a PPL$ application */
unsigned long ppl$delete_application();
/*	PPL$DELETE_WORK_ITEM	-- delete a work queue item */
unsigned long ppl$delete_work_item();
/*	PPL$DELETE_SHARED_MEMORY -- delete shared memory */
unsigned long ppl$delete_shared_memory();
/*	PPL$DELETE_WORK_QUEUE	-- delete a work queue */
unsigned long ppl$delete_work_queue();
/*	PPL$DISABLE_EVENT	-- disable asynchronous notification of an event */
unsigned long ppl$disable_event();
/*	PPL$ENABLE_EVENT_AST	-- enable AST notification of an event */
unsigned long ppl$enable_event_ast();
/*	PPL$ENABLE_EVENT_SIGNAL -- enable signal notification of avent */
unsigned long ppl$enable_event_signal();
/*	PPL$FIND_OBJECT_ID	-- find object identification */
unsigned long ppl$find_object_id();
/*	PPL$FIND_SYNCH_ELEMENT_ID -- find synchronizatin element identification */
unsigned long ppl$find_synch_element_id();	/*(obsolete)*/
/*	PPL$FLUSH_SHARED_MEMORY -- flush shared memory */
unsigned long ppl$flush_shared_memory();
/*	PPL$GET_INDEX		-- get index of a participant */
unsigned long ppl$get_index();
/*	PPL$INCREMENT_SEMAPHORE -- increment a semaphore */
unsigned long ppl$increment_semaphore();
/*	PPL$INDEX_TO_PID	-- convert participant index to vms pid */
unsigned long ppl$index_to_pid();
/*	PPL$INITIALIZE		-- initialize the PPL$ facility */
unsigned long ppl$initialize();			/*(obsolete)*/
/*	PPL$INSERT_WORK_ITEM	-- insert a work queue item */
unsigned long ppl$insert_work_item();
/*	PPL$PID_TO_INDEX	-- convert VMS PID to particant index */
unsigned long ppl$pid_to_index();
/*	PPL$READ_BARRIER	-- read a barrier */
unsigned long ppl$read_barrier();
/*	PPL$READ_EVENT		-- read an event state */
unsigned long ppl$read_event();
/*	PPL$READ_SEMAPHORE	-- read semaphore values */
unsigned long ppl$read_semaphore();
/*	PPL$READ_SPIN_LOCK	-- read a spin lock state */
unsigned long ppl$read_spin_lock();
/*	PPL$READ_WORK_QUEUE	-- read a work queue */
unsigned long ppl$read_work_queue();
/*	PPL$RELEASE_SPIN_LOCK	-- release spin lock */
unsigned long ppl$release_spin_lock();
/*	PPL$REMOVE_WORK_ITEM	-- remove a work queue item */
unsigned long ppl$remove_work_item();
/*	PPL$RESET_EVENT		-- reset an event */
unsigned long ppl$reset_event();
/*	PPL$SEIZE_SPIN_LOCK	-- seize spin lock */
unsigned long ppl$seize_spin_lock();
/*	PPL$SET_QUORUM		-- set barrier quorum */
unsigned long ppl$set_quorum();
/*	PPL$SET_SEMAPHORE_MAXIMUM -- set a semaphore maximum */
unsigned long ppl$set_semaphore_maximum();
/*	PPL$SPAWN		-- initiate parallel execution */
unsigned long ppl$spawn();
/*	PPL$STOP		-- stop a participant */
unsigned long ppl$stop();
/*	PPL$TERMINATE		-- abort PPL$ participation */
unsigned long ppl$terminate();
/*	PPL$TRIGGER_EVENT	-- trigger an event */
unsigned long ppl$trigger_event();
/*	PPL$UNIQUE_NAME		-- produce a unique name */
unsigned long ppl$unique_name();
/*	PPL$WAIT_AT_BARRIER	-- synchronize at a barrier */
unsigned long ppl$wait_at_barrier();

# ifdef __cplusplus
}
# endif
#endif	/*_PPL$ROUTINES_H*/
