/* <vms/lib/ttyucbdef.h>
 *
 *	LIB - terminal unit control block extension	[not in Starlet]
 */
#ifndef _TTYUCBDEF_H
#define _TTYUCBDEF_H

/*
   Terminal Driver Definitions

   These definitions define the device dependent extensions of the UCB.
 */

#define UCB$S_TL_BRKTHRU 8
#define UCB$S_TT_STATE	8

#define UCB$C_TL_LENGTH 196
#define UCB$K_TL_LENGTH 196

#define UCB$S_TTYRTTUCB 168
#define UCB$S_TTYUCB	168
#define UCB$S_RTTUCB	136

#define TTY$V_ST_POWER		0
#define TTY$V_ST_CTRLS		1
#define TTY$V_ST_MODEM_OFF	2
#define TTY$V_ST_FILL		3
#define TTY$V_ST_CURSOR		4
#define TTY$V_ST_SENDLF		5
#define TTY$V_ST_BACKSPACE	6
#define TTY$V_ST_MULTI		7
#define TTY$V_ST_WRITE		8
#define TTY$V_ST_EOL		9
#define TTY$V_ST_EDITREAD	10
#define TTY$V_ST_RDVERIFY	11
#define TTY$V_ST_RECALL		12
#define TTY$V_ST_READ		13
#define TTY$V_ST_POSIXREAD	14
#define TTY$M_ST_POWER		(1<<TTY$V_ST_POWER)		/* 0x01 */
#define TTY$M_ST_CTRLS		(1<<TTY$V_ST_CTRLS)		/* 0x02 */
#define TTY$M_ST_MODEM_OFF	(1<<TTY$V_ST_MODEM_OFF)		/* 0x04 */
#define TTY$M_ST_FILL		(1<<TTY$V_ST_FILL)		/* 0x08 */
#define TTY$M_ST_CURSOR		(1<<TTY$V_ST_CURSOR)		/* 0x10 */
#define TTY$M_ST_SENDLF		(1<<TTY$V_ST_SENDLF)		/* 0x20 */
#define TTY$M_ST_BACKSPACE	(1<<TTY$V_ST_BACKSPACE)		/* 0x40 */
#define TTY$M_ST_MULTI		(1<<TTY$V_ST_MULTI)		/* 0x80 */
#define TTY$M_ST_WRITE		(1<<TTY$V_ST_WRITE)		/* 0x0100 */
#define TTY$M_ST_EOL		(1<<TTY$V_ST_EOL)		/* 0x0200 */
#define TTY$M_ST_EDITREAD	(1<<TTY$V_ST_EDITREAD)		/* 0x0400 */
#define TTY$M_ST_RDVERIFY	(1<<TTY$V_ST_RDVERIFY)		/* 0x0800 */
#define TTY$M_ST_RECALL		(1<<TTY$V_ST_RECALL)		/* 0x1000 */
#define TTY$M_ST_READ		(1<<TTY$V_ST_READ)		/* 0x2000 */
#define TTY$M_ST_POSIXREAD	(1<<TTY$V_ST_POSIXREAD)		/* 0x4000 */
#define TTY$V_ST_CTRLO		0
#define TTY$V_ST_DEL		1
#define TTY$V_ST_PASALL		2
#define TTY$V_ST_NOECHO		3
#define TTY$V_ST_WRTALL		4
#define TTY$V_ST_PROMPT		5
#define TTY$V_ST_NOFLTR		6
#define TTY$V_ST_ESC		7
#define TTY$V_ST_BADESC		8
#define TTY$V_ST_NL		9
#define TTY$V_ST_REFRSH		10
#define TTY$V_ST_ESCAPE		11
#define TTY$V_ST_TYPFUL		12
#define TTY$V_ST_SKIPLF		13
#define TTY$V_ST_ESC_O		14
#define TTY$V_ST_WRAP		15
#define TTY$V_ST_OVRFLO		16
#define TTY$V_ST_AUTOP		17
#define TTY$V_ST_CTRLR		18
#define TTY$V_ST_SKIPCRLF	19
#define TTY$V_ST_EDITING	20
#define TTY$V_ST_TABEXPAND	21
#define TTY$V_ST_QUOTING	22
#define TTY$V_ST_OVERSTRIKE	23
#define TTY$V_ST_TERMNORM	24
#define TTY$V_ST_ECHAES		25
#define TTY$V_ST_PRE		26
#define TTY$V_ST_NINTMULTI	27
#define TTY$V_ST_RECONNECT	28
#define TTY$V_ST_CTSLOW		29
#define TTY$V_ST_TABRIGHT	30
#define TTY$M_ST_CTRLO		(1<<TTY$V_ST_CTRLO)		/* 0x01 */
#define TTY$M_ST_DEL		(1<<TTY$V_ST_DEL)		/* 0x02 */
#define TTY$M_ST_PASALL		(1<<TTY$V_ST_PASALL)		/* 0x04 */
#define TTY$M_ST_NOECHO		(1<<TTY$V_ST_NOECHO)		/* 0x08 */
#define TTY$M_ST_WRTALL		(1<<TTY$V_ST_WRTALL)		/* 0x10 */
#define TTY$M_ST_PROMPT		(1<<TTY$V_ST_PROMPT)		/* 0x20 */
#define TTY$M_ST_NOFLTR		(1<<TTY$V_ST_NOFLTR)		/* 0x40 */
#define TTY$M_ST_ESC		(1<<TTY$V_ST_ESC)		/* 0x80 */
#define TTY$M_ST_BADESC		(1<<TTY$V_ST_BADESC)		/* 0x0100 */
#define TTY$M_ST_NL		(1<<TTY$V_ST_NL)		/* 0x0200 */
#define TTY$M_ST_REFRSH		(1<<TTY$V_ST_REFRSH)		/* 0x0400 */
#define TTY$M_ST_ESCAPE		(1<<TTY$V_ST_ESCAPE)		/* 0x0800 */
#define TTY$M_ST_TYPFUL		(1<<TTY$V_ST_TYPFUL)		/* 0x1000 */
#define TTY$M_ST_SKIPLF		(1<<TTY$V_ST_SKIPLF)		/* 0x2000 */
#define TTY$M_ST_ESC_O		(1<<TTY$V_ST_ESC_O)		/* 0x4000 */
#define TTY$M_ST_WRAP		(1<<TTY$V_ST_WRAP)		/* 0x8000 */
#define TTY$M_ST_OVRFLO		(1<<TTY$V_ST_OVRFLO)		/* 0x010000 */
#define TTY$M_ST_AUTOP		(1<<TTY$V_ST_AUTOP)		/* 0x020000 */
#define TTY$M_ST_CTRLR		(1<<TTY$V_ST_CTRLR)		/* 0x040000 */
#define TTY$M_ST_SKIPCRLF	(1<<TTY$V_ST_SKIPCRLF)		/* 0x080000 */
#define TTY$M_ST_EDITING	(1<<TTY$V_ST_EDITING)		/* 0x100000 */
#define TTY$M_ST_TABEXPAND	(1<<TTY$V_ST_TABEXPAND)		/* 0x200000 */
#define TTY$M_ST_QUOTING	(1<<TTY$V_ST_QUOTING)		/* 0x400000 */
#define TTY$M_ST_OVERSTRIKE	(1<<TTY$V_ST_OVERSTRIKE)	/* 0x800000 */
#define TTY$M_ST_TERMNORM	(1<<TTY$V_ST_TERMNORM)		/* 0x01000000 */
#define TTY$M_ST_ECHAES		(1<<TTY$V_ST_ECHAES)		/* 0x02000000 */
#define TTY$M_ST_PRE		(1<<TTY$V_ST_PRE)		/* 0x04000000 */
#define TTY$M_ST_NINTMULTI	(1<<TTY$V_ST_NINTMULTI)		/* 0x08000000 */
#define TTY$M_ST_RECONNECT	(1<<TTY$V_ST_RECONNECT)		/* 0x10000000 */
#define TTY$M_ST_CTSLOW		(1<<TTY$V_ST_CTSLOW)		/* 0x20000000 */
#define TTY$M_ST_TABRIGHT	(1<<TTY$V_ST_TABRIGHT)		/* 0x40000000 */
#define UCB$V_TT_XXPARITY	0
#define UCB$V_TT_DISPARERR	1
#define UCB$V_TT_USERFRAME	2
#define UCB$V_TT_LEN		3
#define UCB$V_TT_STOP		5
#define UCB$V_TT_PARTY		6
#define UCB$V_TT_ODD		7
#define UCB$S_TT_LEN		2
#define UCB$M_TT_XXPARITY	(1<<UCB$V_TT_XXPARITY)	/* 0x01 */
#define UCB$M_TT_DISPARERR	(1<<UCB$V_TT_DISPARERR) /* 0x02 */
#define UCB$M_TT_USERFRAME	(1<<UCB$V_TT_USERFRAME) /* 0x04 */
#define UCB$M_TT_LEN		(3<<UCB$V_TT_LEN)	/* 0x18 */
#define UCB$M_TT_STOP		(1<<UCB$V_TT_STOP)	/* 0x20 */
#define UCB$M_TT_PARTY		(1<<UCB$V_TT_PARTY)	/* 0x40 */
#define UCB$M_TT_ODD		(1<<UCB$V_TT_ODD)	/* 0x80 */
#define TTY$V_TANK_PREMPT	8
#define TTY$V_TANK_STOP		9
#define TTY$V_TANK_HOLD		10
#define TTY$V_TANK_BURST	11
#define TTY$V_TANK_DMA		12
#define TTY$M_TANK_PREMPT	(1<<TTY$V_TANK_PREMPT)	/* 0x0100 */
#define TTY$M_TANK_STOP		(1<<TTY$V_TANK_STOP)	/* 0x0200 */
#define TTY$M_TANK_HOLD		(1<<TTY$V_TANK_HOLD)	/* 0x0400 */
#define TTY$M_TANK_BURST	(1<<TTY$V_TANK_BURST)	/* 0x0800 */
#define TTY$M_TANK_DMA		(1<<TTY$V_TANK_DMA)	/* 0x1000 */
#define TTY$V_PC_NOTIME		0
#define TTY$V_PC_DMAENA		1
#define TTY$V_PC_DMAAVL		2
#define TTY$V_PC_PRMMAP		3
#define TTY$V_PC_MAPAVL		4
#define TTY$V_PC_XOFAVL		5
#define TTY$V_PC_XOFENA		6
#define TTY$V_PC_NOCRLF		7
#define TTY$V_PC_BREAK		8
#define TTY$V_PC_PORTFDT	9
#define TTY$V_PC_NOMODEM	10
#define TTY$V_PC_NODISCONNECT	11
#define TTY$V_PC_SMART_READ	12
#define TTY$V_PC_ACCPORNAM	13
#define TTY$V_PC_MULTISESSION	15
#define TTY$M_PC_NOTIME		(1<<TTY$V_PC_NOTIME)		/* 0x01 */
#define TTY$M_PC_DMAENA		(1<<TTY$V_PC_DMAENA)		/* 0x02 */
#define TTY$M_PC_DMAAVL		(1<<TTY$V_PC_DMAAVL)		/* 0x04 */
#define TTY$M_PC_PRMMAP		(1<<TTY$V_PC_PRMMAP)		/* 0x08 */
#define TTY$M_PC_MAPAVL		(1<<TTY$V_PC_MAPAVL)		/* 0x10 */
#define TTY$M_PC_XOFAVL		(1<<TTY$V_PC_XOFAVL)		/* 0x20 */
#define TTY$M_PC_XOFENA		(1<<TTY$V_PC_XOFENA)		/* 0x40 */
#define TTY$M_PC_NOCRLF		(1<<TTY$V_PC_NOCRLF)		/* 0x80 */
#define TTY$M_PC_BREAK		(1<<TTY$V_PC_BREAK)		/* 0x0100 */
#define TTY$M_PC_PORTFDT	(1<<TTY$V_PC_PORTFDT)		/* 0x0200 */
#define TTY$M_PC_NOMODEM	(1<<TTY$V_PC_NOMODEM)		/* 0x0400 */
#define TTY$M_PC_NODISCONNECT	(1<<TTY$V_PC_NODISCONNECT)	/* 0x0800 */
#define TTY$M_PC_SMART_READ	(1<<TTY$V_PC_SMART_READ)	/* 0x1000 */
#define TTY$M_PC_ACCPORNAM	(1<<TTY$V_PC_ACCPORNAM)		/* 0x2000 */
#define TTY$M_PC_MULTISESSION	(1<<TTY$V_PC_MULTISESSION)	/* 0x8000 */

#define UCB$S_TT_MAINT_FILL	7
#define UCB$V_TT_DSBL		7
#define UCB$M_TT_DSBL		(1<<UCB$V_TT_DSBL)	/* 0x80 */
#define UCB$C_TT_CLSLEN 348
#define UCB$K_TT_CLSLEN 348

#define TTY$S_TT_STATE_SX	8
#define TTY$S_SX_FILLBITS	17

#define TTY$V_TP_ABORT		0
#define TTY$V_TP_ALLOC		1
#define TTY$V_TP_DLLOC		2
#define TTY$M_TP_ABORT		(1<<TTY$V_TP_ABORT)	/* 0x01 */
#define TTY$M_TP_ALLOC		(1<<TTY$V_TP_ALLOC)	/* 0x02 */
#define TTY$M_TP_DLLOC		(1<<TTY$V_TP_DLLOC)	/* 0x04 */
#define UCB$C_TP_LENGTH 356
#define UCB$K_TP_LENGTH 356
#define UCB$C_TT_LENGTH 356
#define UCB$K_TT_LENGTH 356

/* terminal driver sx state table */
#define FLG$V_CTRLO		0
#define FLG$V_CANCTRLO		1
#define FLG$V_VAXTOVAX		2
#define FLG$V_CTRLC		3
#define FLG$V_INIT		4
#define FLG$V_RESET_TIMER	5
#define FLG$V_DECNET_BUSY	6
#define FLG$V_OUTPUT_BUSY	7
#define FLG$V_READ_BUSY		8
#define FLG$V_SENSE_BUSY	9
#define FLG$V_OOB_CHAR		10
#define FLG$V_FLUSH_OUTPUT	11
#define FLG$V_CLR_NOBRDCST	12
#define FLG$V_READ_ABORT	13
#define FLG$V_READ_ABORTED	14
#define FLG$V_ISUPPORT		15
#define FLG$V_PARTIAL_READ	16
#define FLG$M_CTRLO		(1<<FLG$V_CTRLO)		/* 0x01 */
#define FLG$M_CANCTRLO		(1<<FLG$V_CANCTRLO)		/* 0x02 */
#define FLG$M_VAXTOVAX		(1<<FLG$V_VAXTOVAX)		/* 0x04 */
#define FLG$M_CTRLC		(1<<FLG$V_CTRLC)		/* 0x08 */
#define FLG$M_INIT		(1<<FLG$V_INIT)			/* 0x10 */
#define FLG$M_RESET_TIMER	(1<<FLG$V_RESET_TIMER)		/* 0x20 */
#define FLG$M_DECNET_BUSY	(1<<FLG$V_DECNET_BUSY)		/* 0x40 */
#define FLG$M_OUTPUT_BUSY	(1<<FLG$V_OUTPUT_BUSY)		/* 0x80 */
#define FLG$M_READ_BUSY		(1<<FLG$V_READ_BUSY)		/* 0x0100 */
#define FLG$M_SENSE_BUSY	(1<<FLG$V_SENSE_BUSY)		/* 0x0200 */
#define FLG$M_OOB_CHAR		(1<<FLG$V_OOB_CHAR)		/* 0x0400 */
#define FLG$M_FLUSH_OUTPUT	(1<<FLG$V_FLUSH_OUTPUT)		/* 0x0800 */
#define FLG$M_CLR_NOBRDCST	(1<<FLG$V_CLR_NOBRDCST)		/* 0x1000 */
#define FLG$M_READ_ABORT	(1<<FLG$V_READ_ABORT)		/* 0x2000 */
#define FLG$M_READ_ABORTED	(1<<FLG$V_READ_ABORTED)		/* 0x4000 */
#define FLG$M_ISUPPORT		(1<<FLG$V_ISUPPORT)		/* 0x8000 */
#define FLG$M_PARTIAL_READ	(1<<FLG$V_PARTIAL_READ)		/* 0x010000 */

#define UCB$S_CT_ISUPPORT	8

#define UCB$C_RTT_LENGTH	332	/* Length must be same for both RTTDRIVER */
#define UCB$K_RTT_LENGTH	332	/* and CTDRIVER. */
#define UCB$S_TTYUCBDEF 364

struct ttyucbdef {
    char ucb$l_tt_ucbfill[164];		/* char fill[UCB$K_LENGTH]; */
	/* logical terminal UCB extension */
    unsigned long ucb$l_tl_ctrly;	/* control Y AST block list head */
    unsigned long ucb$l_tl_ctrlc;	/* control C AST block list head */
    unsigned long ucb$l_tl_outband;	/* out of band character mask */
    unsigned long ucb$l_tl_bandque;	/* out of band AST queue */
    unsigned long ucb$l_tl_phyucb;	/* the physical UCB address */
    unsigned long ucb$l_tl_ctlpid;	/* controling PID (used with spawn) */
    long ucb$q_tl_brkthru[2];		/* facility broadcast bitmask */
#if 0
    unsigned long ucb$l_tl_posix_data;		/* Posix PTC pointer */
    union {
	unsigned char ucb$b_tl_a_mode;		/* current Asian modes */
	unsigned long ucb$l_tl_a_charset;	/* character set bitmask */
    } ucb$r_tl_a_mode_overlay;
#endif
	/* terminal class driver dependant region	      */
	/* split here between local and remote terminal UCB's */
    union {		/* local/remote union (overlay) */

    /* this structure defines remainder of local UCB */
	struct {
		/* read timeout control */
	    unsigned long ucb$l_tt_rdue;	/* abstime when read timeout due */
	    unsigned long ucb$l_tt_rtimou;	/* address of read timeout routine */
		/* terminal driver state table */
	    union {
		long ucb$q_tt_state[2];		/* current unit state vector */
		struct {
		    union {
			unsigned long ucb$l_tt_state1;
			struct {
			    unsigned tty$v_st_power	: 1;
			    unsigned tty$v_st_ctrls	: 1;
			    unsigned tty$v_st_modem_off : 1;
			    unsigned tty$v_st_fill	: 1;
			    unsigned tty$v_st_cursor	: 1;
			    unsigned tty$v_st_sendlf	: 1;
			    unsigned tty$v_st_backspace : 1;
			    unsigned tty$v_st_multi	: 1;
			    unsigned tty$v_st_write	: 1;
			    unsigned tty$v_st_eol	: 1;
			    unsigned tty$v_st_editread	: 1;
			    unsigned tty$v_st_rdverify	: 1;
			    unsigned tty$v_st_recall	: 1;
			    unsigned tty$v_st_read	: 1;
			    unsigned tty$v_st_posixread : 1;
			} ucb$r_tt_state1_fields;
		    } ucb$r_tt_state1_overlay;
		    union {
			unsigned long ucb$l_tt_state2;
			struct {
			    unsigned tty$v_st_ctrlo	: 1;
			    unsigned tty$v_st_del	: 1;
			    unsigned tty$v_st_pasall	: 1;
			    unsigned tty$v_st_noecho	: 1;
			    unsigned tty$v_st_wrtall	: 1;
			    unsigned tty$v_st_prompt	: 1;
			    unsigned tty$v_st_nofltr	: 1;
			    unsigned tty$v_st_esc	: 1;
			    unsigned tty$v_st_badesc	: 1;
			    unsigned tty$v_st_nl	: 1;
			    unsigned tty$v_st_refrsh	: 1;
			    unsigned tty$v_st_escape	: 1;
			    unsigned tty$v_st_typful	: 1;
			    unsigned tty$v_st_skiplf	: 1;
			    unsigned tty$v_st_esc_o	: 1;
			    unsigned tty$v_st_wrap	: 1;
			    unsigned tty$v_st_ovrflo	: 1;
			    unsigned tty$v_st_autop	: 1;
			    unsigned tty$v_st_ctrlr	: 1;
			    unsigned tty$v_st_skipcrlf	: 1;
			    unsigned tty$v_st_editing	: 1;
			    unsigned tty$v_st_tabexpand : 1;
			    unsigned tty$v_st_quoting	: 1;
			    unsigned tty$v_st_overstrike: 1;
			    unsigned tty$v_st_termnorm	: 1;
			    unsigned tty$v_st_echaes	: 1;
			    unsigned tty$v_st_pre	: 1;
			    unsigned tty$v_st_nintmulti : 1;
			    unsigned tty$v_st_reconnect : 1;
			    unsigned tty$v_st_ctslow	: 1;
			    unsigned tty$v_st_tabright	: 1;
			} ucb$r_tt_state2_fields;
		    } ucb$r_tt_state2_overlay;
		} ucb$r_tt_state_q_block;
	    } ucb$r_tt_state_overlay;
	    unsigned long ucb$l_tt_logucb;	/* address of the logical UCB */
		/* default characteristics */
	    unsigned long ucb$l_tt_dechar;	/* default device characteristics */
	    unsigned long ucb$l_tt_decha1;	/* default device char extensions */
	    unsigned long ucb$l_tt_decha2;	/* more device characteristics */
	    unsigned long ucb$l_tt_decha3;	/* another device char extensions */
		/* write queue pointers */
	    unsigned long ucb$l_tt_wflink;	/* write queue forward link. */
	    unsigned long ucb$l_tt_wblink;	/* write queue backward link. */
	    unsigned long ucb$l_tt_wrtbuf;	/* current write buffer block. */
		/* address and length of multi-echo string */
	    unsigned long ucb$l_tt_multi;	/* current multiecho buffer address */
	    unsigned short ucb$w_tt_multilen;	/* length of string to output */
	    unsigned short ucb$w_tt_smltlen;	/* saved multi length */
	    unsigned long ucb$l_tt_smlt;	/* and the saved address */
		/* default speed, fill ,parity (must be contiguous) */
	    unsigned short ucb$w_tt_despee;	/* default speed */
	    unsigned char ucb$b_tt_decrf;	/* default CR fill */
	    unsigned char ucb$b_tt_delff;	/* default LF fill */
	    unsigned char ucb$b_tt_depari;	/* default parity/char size */
	    unsigned char ucb$b_tt_defspe_spare1;
	    unsigned short ucb$w_tt_defspe_spare2;
		/* default terminal type and size (must be contiguous) */
	    unsigned char ucb$b_tt_detype;	/* default terminal type */
	    unsigned short ucb$w_tt_desize;	/* default line size */
	    unsigned char ucb$b_tt_spare1;	/* spare byte must follow */
		/* speed, fill, parity (must be contiguous) */
	    union {
		unsigned short ucb$w_tt_speed;	/* speed codes (split speed) */
		struct {
		    unsigned char ucb$b_tt_tspeed;  /* transmit speed */
		    unsigned char ucb$b_tt_rspeed;  /* receive speed */
		} ucb$tt_speed_fields;
	    } ucb$tt_speed_overlay;
	    unsigned char ucb$b_tt_crfill;	/* number fills to output on CR */
	    unsigned char ucb$b_tt_lffill;	/* number fills to output on LF */
	    union {
		unsigned char ucb$b_tt_parity;	/* parity and character size definitions */
		struct {
		    unsigned ucb$v_tt_xxparity	: 1;	/* unused ?? */
		    unsigned ucb$v_tt_disparerr : 1;	/* specify disregard parity errors */
		    unsigned ucb$v_tt_userframe : 1;	/* specify user frame setup */
		    unsigned ucb$v_tt_len	: 2;	/* character length */
		    unsigned ucb$v_tt_stop	: 1;	/* stop bits */
		    unsigned ucb$v_tt_party	: 1;	/* parity enabled */
		    unsigned ucb$v_tt_odd	: 1;	/* odd parity */
		} ucb$r_parity_bits;
	    } ucb$r_parity_overlay;
	    unsigned char ucb$b_tt_par_spare1;
	    unsigned short ucb$w_tt_par_spare2;
		/* typeahead buffer address */
	    unsigned long ucb$l_tt_typahd;	/* typeahead buffer address */
		/* current cursor and line position for formatted operations */
	    unsigned short ucb$w_tt_cursor;	/* current cursor position */
	    unsigned char ucb$b_tt_line;	/* current line on page */
	    unsigned char ucb$b_tt_lastc;	/* last formatted output character */
		/* number of back spaces to output for non-ansi terminals */
	    unsigned short ucb$w_tt_bsplen;	/* number of backspaces */
		/* fill handling */
	    unsigned char ucb$b_tt_fill;	/* current fill count */
		/* escape syntax rule state */
	    unsigned char ucb$b_tt_esc;		/* current read escape syntax state */
	    unsigned char ucb$b_tt_esc_o;	/* output escape state */
		/* count of characters in interrupt string */
	    unsigned char ucb$b_tt_intcnt;
		/* bit used for modem control */
	    unsigned short ucb$w_tt_unitbit;	/* bit used to enable and disable modem control. */
		/* port specific output control */
	    union {
		unsigned short ucb$w_tt_hold;	/* unit holding tank and port dispatch */
		struct {
		    unsigned char tty$b_tank_char;	/* character */
		    unsigned tty$v_tank_prempt	: 1;	/* send prempt character */
		    unsigned tty$v_tank_stop	: 1;	/* stop output */
		    unsigned tty$v_tank_hold	: 1;	/* char in tank */
		    unsigned tty$v_tank_burst	: 1;	/* burst active */
		    unsigned tty$v_tank_dma	: 1;	/* DMA active **** should move before burst **** */
		} ucb$r_tt_hold_bits;
	    } ucb$r_tt_hold_overlay;
	    unsigned char ucb$b_tt_prempt;	/* the byte used to prempt input */
	    unsigned char ucb$b_tt_outype;	/* type of output that this call */
		/* class & port vector pointers */
	    unsigned long ucb$l_tt_getnxt;	/* address of class input routine */
	    unsigned long ucb$l_tt_putnxt;	/* address of class output routine */
	    unsigned long ucb$l_tt_class;	/* address of class vector */
	    unsigned long ucb$l_tt_port;	/* address of port vector */
	    unsigned long ucb$l_tt_outadr;	/* address of output current stream */
	    unsigned short ucb$w_tt_outlen;	/* length of output stream */
	    union {
		unsigned short ucb$w_tt_prtctl; /* the port driver control word */
		struct {
		    unsigned tty$v_pc_notime	: 1;	/* if set no timeout will be calculated */
		    unsigned tty$v_pc_dmaena	: 1;	/* DMA currently enabled */
		    unsigned tty$v_pc_dmaavl	: 1;	/* DMA supported on this port */
		    unsigned tty$v_pc_prmmap	: 1;	/* unit can have permanent map registers */
		    unsigned tty$v_pc_mapavl	: 1;	/* map register currently allocated */
		    unsigned tty$v_pc_xofavl	: 1;	/* auto XOFF supported on this port */
		    unsigned tty$v_pc_xofena	: 1;	/* auto XOFF currently enabled */
		    unsigned tty$v_pc_nocrlf	: 1;	/* don't do free linefeed after creturn */
		    unsigned tty$v_pc_break	: 1;	/* turn on or off break */
		    unsigned tty$v_pc_portfdt	: 1;	/* port contains FDT routine */
		    unsigned tty$v_pc_nomodem	: 1;	/* port cannot support modem operations */
		    unsigned tty$v_pc_nodisconnect : 1; /* device cannot support virtual terminal operations */
		    unsigned tty$v_pc_smart_read : 1;	/* port contains additional read capabilities */
		    unsigned tty$v_pc_accpornam : 1;	/* port supports access port name */
		    unsigned			: 1;	/* fill */
		    unsigned tty$v_pc_multisession : 1; /* part of multi-session terminal */
		} ucb$r_tt_prtctl_bits;
	    } ucb$r_tt_prtctl_overlay;
		/* modem control definitions */
	    unsigned char ucb$b_tt_ds_rcv;	/* current receive modem */
	    unsigned char ucb$b_tt_ds_tx;	/* current transmit modem */
	    unsigned short ucb$w_tt_ds_st;	/* current modem state */
	    unsigned short ucb$w_tt_ds_tim;	/* current modem timeout */
	    union {
		unsigned char ucb$b_tt_maint;	/* maintenance parameters */
		struct {
		    unsigned ucb$v_tt_maint_fill : 7;
		    unsigned ucb$v_tt_dsbl	: 1;	/* line disabled */
		} ucb$r_tt_maint_bits;
	    } ucb$r_tt_maint_overlay;
	    unsigned char ucb$b_tt_oldcpzorg;	/* spare byte make this longword alligned */
	    unsigned long ucb$l_tt_fbk;		/* ptr to fallback block */
	    unsigned long ucb$l_tt_rdverify;	/* ptr to read/verify table */
	    union {
		unsigned long ucb$l_tt_class1;	/* class driver longword */
		union {
		    unsigned char ucb$b_tt_a_char;	/* default Asian modes */
		    unsigned long ucb$l_tt_a_dechset;	/* default char set bitmask */
		} ucb$r_tt_a_char_overlay;
	    } ucb$r_tt_class1_overlay;
	    unsigned long ucb$l_tt_class2;	/* and another one */
	    unsigned long ucb$l_tt_accpornam;	/* dddress of counted string describing the port */
						/* typically LAT server name / and port name or number */
#if 0
		/* Asian VMS extension */
	    unsigned long ucb$l_tt_a_gcbadr;	/* glyph Control Block address */
	    unsigned short ucb$w_tt_a_edsts;	/* multi-byte line edit states */
	    unsigned char ucb$b_tt_a_state;	/* on-demand loading states */
	    unsigned char ucb$b_tt_a_parse;	/* ODL parse states */
	    unsigned char ucb$b_tt_a_trans;	/* JIS conversion states */
	    unsigned char ucb$b_tt_a_xedsts;	/* extended line edit states */
	    unsigned short ucb$w_tt_a_resrv1;	/* reserved */
	    union {
		unsigned char ucb$b_tt_a_char;		/* default Asian modes */
		unsigned long ucb$l_tt_a_dechset;	/* default char set bitmask */
	    } ucb$r_tt_a_char_overlay;
#endif

		/* terminal port driver dependant extension region */
	    unsigned long ucb$l_tp_map;		/* UNIBUS map registers */
	    union {
		unsigned char ucb$b_tp_stat;	/* DMA port specific status */
		struct {
		    unsigned tty$v_tp_abort : 1; /* DMA abort requested on this line */
		    unsigned tty$v_tp_alloc : 1; /* alloc map fork in progress */
		    unsigned tty$v_tp_dlloc : 1; /* deallocate map fork in progress */
		} ucb$r_tp_stat_bits;
	    } ucb$r_tp_stat_overlay;
	    unsigned char ucb$b_tp_spare1;
	    unsigned short ucb$w_tp_spare2;
	    struct {
		unsigned tty$v_sx_power     : 1;
		unsigned tty$v_sx_ctrls     : 1;
		unsigned tty$v_sx_modem_off : 1;
		unsigned tty$v_sx_fill	    : 1;
		unsigned tty$v_sx_cursor    : 1;
		unsigned tty$v_sx_sendlf    : 1;
		unsigned tty$v_sx_backspace : 1;    /* output backspaces for several loops */
		unsigned tty$v_sx_multi     : 1;
		unsigned tty$v_sx_write     : 1;    /* write state */
		unsigned tty$v_sx_eol	    : 1;
		unsigned tty$v_sx_editread  : 1;
		unsigned tty$v_sx_rdverify  : 1;
		unsigned tty$v_sx_recall    : 1;
		unsigned tty$v_sx_read	    : 1;
		unsigned tty$v_sx_posixread : 1;
		unsigned tty$v_sx_fillbits  : 17;   /* end of first longword */
		/* */
		unsigned tty$v_sx_ctrlo     : 1;
		unsigned tty$v_sx_del	    : 1;
		unsigned tty$v_sx_pasall    : 1;
		unsigned tty$v_sx_noecho    : 1;
		unsigned tty$v_sx_wrtall    : 1;
		unsigned tty$v_sx_prompt    : 1;
		unsigned tty$v_sx_nofltr    : 1;
		unsigned tty$v_sx_esc	    : 1;
		unsigned tty$v_sx_badesc    : 1;
		unsigned tty$v_sx_nl	    : 1;    /* new line must directly precede */
		unsigned tty$v_sx_refrsh    : 1;    /* refresh, or all breaks. */
		unsigned tty$v_sx_escape    : 1;
		unsigned tty$v_sx_typful    : 1;
		unsigned tty$v_sx_skiplf    : 1;
		unsigned tty$v_sx_esc_o     : 1;
		unsigned tty$v_sx_wrap	    : 1;
		unsigned tty$v_sx_ovrflo    : 1;
		unsigned tty$v_sx_autop     : 1;
		unsigned tty$v_sx_ctrlr     : 1;
		unsigned tty$v_sx_skipcrlf  : 1;
		unsigned tty$v_sx_editing   : 1;
		unsigned tty$v_sx_tabexpand : 1;
		unsigned tty$v_sx_quoting   : 1;
		unsigned tty$v_sx_overstrike: 1;
		unsigned tty$v_sx_termnorm  : 1;
		unsigned tty$v_sx_echaes    : 1;
		unsigned tty$v_sx_pre	    : 1;
		unsigned tty$v_sx_nintmulti : 1;
		unsigned tty$v_sx_reconnect : 1;
		unsigned tty$v_sx_ctslow    : 1;
		unsigned tty$v_sx_tabright  : 1;
	    } ucb$r_tt_state_sx;
	} ucb$r_ttyucb;

    /* remote terminal extension */
	struct {
	    unsigned long ucb$l_rtt_netucb;	/* net device UCB */
	    unsigned long ucb$l_rtt_netwind;	/* net device WCB */
	    unsigned long ucb$l_rtt_irpfl;	/* IRP queue */
	    unsigned long ucb$l_rtt_irpbl;	/* IRP queue */
	    unsigned long ucb$l_rtt_netirp;	/* read net IIRP */
	    unsigned long ucb$l_rtt_bandincl;	/* out of band includes */
	    unsigned long ucb$l_rtt_bandinmsk;	/* out of band include mask */
	    unsigned long ucb$l_rtt_bandexcl;	/* out of band exclude mask */
	    unsigned long ucb$l_rtt_bandexmsk;	/* out of band exclude */
	    unsigned char ucb$b_rtt_provrs;	/* protocol version */
	    unsigned char ucb$b_rtt_proeco;	/* protocol ECO */
	    unsigned short ucb$w_rtt_link;	/* link number (for LOGINOUT) */
	    unsigned char ucb$b_rtt_obj;	/* object number connected */
	    unsigned short ucb$w_rtt_systype;	/* system type (VMS=7) */
	    unsigned char ucb$b_rtt_fillbyte;	/* fill - use when convenient */
		/* CTERM driver only */
	    union {
		unsigned long ucb$l_ct_flags;	/* misc flags */
		struct {
		    unsigned flg$v_ctrlo	: 1;	/* ctrl/O in progress */
		    unsigned flg$v_canctrlo	: 1;	/* cancel ctrl/O on write */
		    unsigned flg$v_vaxtovax	: 1;	/* VAX to VAX */
		    unsigned flg$v_ctrlc	: 1;	/* ctrl/C delivered */
		    unsigned flg$v_init		: 1;	/* awaiting first write */
		    unsigned flg$v_reset_timer	: 1;	/* restart timer due to write */
		    unsigned flg$v_decnet_busy	: 1;	/* DECnet output task busy */
		    unsigned flg$v_output_busy	: 1;	/* output task busy */
		    unsigned flg$v_read_busy	: 1;	/* read task busy */
		    unsigned flg$v_sense_busy	: 1;	/* sense task busy */
		    unsigned flg$v_oob_char	: 1;	/* process OOB character later */
		    unsigned flg$v_flush_output : 1;	/* flush output for out-of-band abort */
		    unsigned flg$v_clr_nobrdcst : 1;	/* don't broadcast until after first write */
		    unsigned flg$v_read_abort	: 1;	/* read abort in progress */
		    unsigned flg$v_read_aborted : 1;	/* read has already been aborted */
		    unsigned flg$v_isupport	: 1;	/* support of ISUPPORT msg */
		    unsigned flg$v_partial_read : 1;	/* partial read in progress */
		} ucb$r_ct_flags_bits;
	    } ucb$r_ct_flags_overlay;
	    unsigned long ucb$l_ct_wiirp;	/* write IIRP */
	    unsigned long ucb$l_ct_tqe;		/* TQE address */
	    unsigned long ucb$l_ct_netqfl;	/* queue of DCB's waiting */
	    unsigned long ucb$l_ct_netqbl;	/*  for write IRP */
	    unsigned long ucb$l_ct_senseqfl;	/* queue for pending */
	    unsigned long ucb$l_ct_senseqbl;	/*  IO$_SENSExxxx IRPs */
	    unsigned long ucb$l_ct_readqfl;	/* queue for pending */
	    unsigned long ucb$l_ct_readqbl;	/*  read IRPs */
	    unsigned long ucb$l_ct_wrtdcb;	/* first DCB in current write chain */
	    unsigned long ucb$l_ct_curdcb;	/* last DCB added to write chain */
	    unsigned short ucb$w_ct_remsiz;	/* remaining size in message */
	    short ucb$w_ct_qdcbcnt;		/* Number of queued DCBs */
	    unsigned short ucb$w_ct_maxmsg;	/* max write to net size */
	    unsigned short ucb$w_ct_maxread;	/* max read in server */
	    unsigned long ucb$l_ct_legalmsg;	/* legal message mask */
	    unsigned char ucb$b_ct_version;	/* CTERM version */
	    unsigned char ucb$b_ct_eco;		/* CTERM ECO */
	    unsigned short ucb$w_ct_speed;	/* speed */
	    unsigned char ucb$b_ct_crfill;	/* CR fill */
	    unsigned char ucb$b_ct_lffill;	/* LF fill */
	    unsigned short ucb$w_ct_parity;	/* CTERM parity */
	    unsigned long ucb$l_ct_include;	/* include out-of-band character mask */
	    unsigned long ucb$l_ct_exclude;	/* exclude out-of-band character mask */
	    unsigned long ucb$l_ct_abort;	/* abort out-of-band character mask */
	    unsigned char ucb$b_ct_oob_char;	/* received out of band character. */
	    unsigned char ucb$b_ct_fill_byte;	/* fill */
	    unsigned short ucb$w_ct_prtctl;	/* same as UCB$W_TT_PRTCTL */
	    long ucb$q_ct_isupport[2];		/* messages supported */
	    unsigned long ucb$l_ct_fill_longword;	/* fill */
	} ucb$r_rttucb;

    } ucb$r_ttyrttucb;	  /* end union */

}; /* ttyucbdef */

#endif	/*_TTYUCBDEF_H*/
