/* <vms/lib/ucbdef.h>
 *
 *	LIB - unit control block definitions		[not in Starlet]
 */
#ifndef _UCBDEF_H
#define _UCBDEF_H

/*
 *	UCB - Unit Control Block
 *
 * There is one UCB for each device unit in a system.
 */
#define UCB$V_TIM	0
#define UCB$V_INT	1
#define UCB$V_ERLOGIP	2
#define UCB$V_CANCEL	3
#define UCB$V_ONLINE	4
#define UCB$V_POWER	5
#define UCB$V_TIMOUT	6
#define UCB$V_INTTYPE	7
#define UCB$V_BSY	8
#define UCB$V_MOUNTING	9
#define UCB$V_DEADMO	10
#define UCB$V_VALID	11
#define UCB$V_UNLOAD	12
#define UCB$V_TEMPLATE	13
#define UCB$V_MNTVERIP	14
#define UCB$V_WRONGVOL	15
#define UCB$V_DELETEUCB 16
#define UCB$V_LCL_VALID 17
#define UCB$V_SUPMVMSG	18
#define UCB$V_MNTVERPND 19
#define UCB$V_DISMOUNT	20
#define UCB$V_CLUTRAN	21
#define UCB$V_WRTLOCKMV 22
#define UCB$V_SVPN_END	23
#define UCB$V_ALTBSY	24
#define UCB$V_SNAPSHOT	25
#define UCB$M_TIM	(1<<UCB$V_TIM)		/* 0x01 */
#define UCB$M_INT	(1<<UCB$V_INT)		/* 0x02 */
#define UCB$M_ERLOGIP	(1<<UCB$V_ERLOGIP)	/* 0x04 */
#define UCB$M_CANCEL	(1<<UCB$V_CANCEL)	/* 0x08 */
#define UCB$M_ONLINE	(1<<UCB$V_ONLINE)	/* 0x10 */
#define UCB$M_POWER	(1<<UCB$V_POWER)	/* 0x20 */
#define UCB$M_TIMOUT	(1<<UCB$V_TIMOUT)	/* 0x40 */
#define UCB$M_INTTYPE	(1<<UCB$V_INTTYPE)	/* 0x80 */
#define UCB$M_BSY	(1<<UCB$V_BSY)		/* 0x0100 */
#define UCB$M_MOUNTING	(1<<UCB$V_MOUNTING)	/* 0x0200 */
#define UCB$M_DEADMO	(1<<UCB$V_DEADMO)	/* 0x0400 */
#define UCB$M_VALID	(1<<UCB$V_VALID)	/* 0x0800 */
#define UCB$M_UNLOAD	(1<<UCB$V_UNLOAD)	/* 0x1000 */
#define UCB$M_TEMPLATE	(1<<UCB$V_TEMPLATE)	/* 0x2000 */
#define UCB$M_MNTVERIP	(1<<UCB$V_MNTVERIP)	/* 0x4000 */
#define UCB$M_WRONGVOL	(1<<UCB$V_WRONGVOL)	/* 0x8000 */
#define UCB$M_DELETEUCB (1<<UCB$V_DELETEUCB)	/* 0x010000 */
#define UCB$M_LCL_VALID (1<<UCB$V_LCL_VALID)	/* 0x020000 */
#define UCB$M_SUPMVMSG	(1<<UCB$V_SUPMVMSG)	/* 0x040000 */
#define UCB$M_MNTVERPND (1<<UCB$V_MNTVERPND)	/* 0x080000 */
#define UCB$M_DISMOUNT	(1<<UCB$V_DISMOUNT)	/* 0x100000 */
#define UCB$M_CLUTRAN	(1<<UCB$V_CLUTRAN)	/* 0x200000 */
#define UCB$M_WRTLOCKMV (1<<UCB$V_WRTLOCKMV)	/* 0x400000 */
#define UCB$M_SVPN_END	(1<<UCB$V_SVPN_END)	/* 0x800000 */
#define UCB$M_ALTBSY	(1<<UCB$V_ALTBSY)	/* 0x01000000 */
#define UCB$M_SNAPSHOT	(1<<UCB$V_SNAPSHOT)	/* 0x02000000 */
#define UCB$V_JOB		0
#define UCB$V_TEMPL_BSY		6
#define UCB$M_JOB		(1<<UCB$V_JOB)		/* 0x01 */
#define UCB$M_TEMPL_BSY		(1<<UCB$V_TEMPL_BSY)	/* 0x40 */
#define UCB$V_PRMMBX		0
#define UCB$V_DELMBX		1
#define UCB$V_SHMMBX		3
#define UCB$M_PRMMBX		(1<<UCB$V_PRMMBX)	/* 0x01 */
#define UCB$M_DELMBX		(1<<UCB$V_DELMBX)	/* 0x02 */
#define UCB$M_SHMMBX		(1<<UCB$V_SHMMBX)	/* 0x08 */
#define UCB$V_TT_TIMO		1
#define UCB$V_TT_NOTIF		2
#define UCB$V_TT_HANGUP		3
#define UCB$V_TT_NOLOGINS	15
#define UCB$M_TT_TIMO		(1<<UCB$V_TT_TIMO)	/* 0x02 */
#define UCB$M_TT_NOTIF		(1<<UCB$V_TT_NOTIF)	/* 0x04 */
#define UCB$M_TT_HANGUP		(1<<UCB$V_TT_HANGUP)	/* 0x08 */
#define UCB$M_TT_NOLOGINS	(1<<UCB$V_TT_NOLOGINS)	/* 0x8000 */
#define UCB$V_NT_BFROVF		2
#define UCB$V_NT_NAME		4
#define UCB$V_NT_BREAK		5
#define UCB$M_NT_BFROVF		(1<<UCB$V_NT_BFROVF)	/* 0x04 */
#define UCB$M_NT_NAME		(1<<UCB$V_NT_NAME)	/* 0x10 */
#define UCB$M_NT_BREAK		(1<<UCB$V_NT_BREAK)	/* 0x20 */
#define UCB$V_ECC		0
#define UCB$V_DIAGBUF		1
#define UCB$V_NOCNVRT		2
#define UCB$V_DX_WRITE		3
#define UCB$V_DATACACHE		4
#define UCB$M_ECC		(1<<UCB$V_ECC)		/* 0x01 */
#define UCB$M_DIAGBUF		(1<<UCB$V_DIAGBUF)	/* 0x02 */
#define UCB$M_NOCNVRT		(1<<UCB$V_NOCNVRT)	/* 0x04 */
#define UCB$M_DX_WRITE		(1<<UCB$V_DX_WRITE)	/* 0x08 */
#define UCB$M_DATACACHE		(1<<UCB$V_DATACACHE)	/* 0x10 */
#define UCB$V_MSCP_MNTVERIP	8
#define UCB$V_MSCP_INITING	9
#define UCB$V_MSCP_WAITBMP	10
#define UCB$V_MSCP_FLOVR	11
#define UCB$V_MSCP_PKACK	12
#define UCB$V_MSCP_WRTP		13
#define UCB$V_MSCP_IGNSRV	14
#define UCB$M_MSCP_MNTVERIP	(1<<UCB$V_MSCP_MNTVERIP)	/* 0x0100 */
#define UCB$M_MSCP_INITING	(1<<UCB$V_MSCP_INITING)		/* 0x0200 */
#define UCB$M_MSCP_WAITBMP	(1<<UCB$V_MSCP_WAITBMP)		/* 0x0400 */
#define UCB$M_MSCP_FLOVR	(1<<UCB$V_MSCP_FLOVR)		/* 0x0800 */
#define UCB$M_MSCP_PKACK	(1<<UCB$V_MSCP_PKACK)		/* 0x1000 */
#define UCB$M_MSCP_WRTP		(1<<UCB$V_MSCP_WRTP)		/* 0x2000 */
#define UCB$M_MSCP_IGNSRV	(1<<UCB$V_MSCP_IGNSRV)		/* 0x4000 */
#define UCB$V_DU_SHMV_STRTD	3
#define UCB$V_DU_0MNOTE		5
#define UCB$M_DU_SHMV_STRTD	(1<<UCB$V_DU_SHMV_STRTD)	/* 0x08 */
#define UCB$M_DU_0MNOTE		(1<<UCB$V_DU_0MNOTE)		/* 0x20 */
#define UCB$V_TU_OVRSQCHK	0
#define UCB$V_TU_TRACEACT	1
#define UCB$V_TU_SEQNOP		2
#define UCB$V_TU_1DENS		3
#define UCB$V_TU_DENS_DETERMINED 4
#define UCB$V_TU_MEDIA_LOADED	5
#define UCB$M_TU_OVRSQCHK	(1<<UCB$V_TU_OVRSQCHK)		/* 0x01 */
#define UCB$M_TU_TRACEACT	(1<<UCB$V_TU_TRACEACT)		/* 0x02 */
#define UCB$M_TU_SEQNOP		(1<<UCB$V_TU_SEQNOP)		/* 0x04 */
#define UCB$M_TU_1DENS		(1<<UCB$V_TU_1DENS)		/* 0x08 */
#define UCB$M_TU_DENS_DETERMINED (1<<UCB$V_TU_DENS_DETERMINED)	/* 0x10 */
#define UCB$M_TU_MEDIA_LOADED	(1<<UCB$V_TU_MEDIA_LOADED)	/* 0x20 */
#define UCB$V_SHD_SEQCMD_HERE	10
#define UCB$V_SHD_SEQCMD_THERE	11
#define UCB$V_SHD_PASSIVE_MV	12
#define UCB$V_SHD_NODE_FAILURE	13
#define UCB$M_SHD_SEQCMD_HERE	(1<<UCB$V_SHD_SEQCMD_HERE)	/* 0x0400 */
#define UCB$M_SHD_SEQCMD_THERE	(1<<UCB$V_SHD_SEQCMD_THERE)	/* 0x0800 */
#define UCB$M_SHD_PASSIVE_MV	(1<<UCB$V_SHD_PASSIVE_MV)	/* 0x1000 */
#define UCB$M_SHD_NODE_FAILURE	(1<<UCB$V_SHD_NODE_FAILURE)	/* 0x2000 */

#define UCB$S_DEVCHAR		8
#define UCB$S_DEVDEPEND		8
#define UCB$S_DEVDEPEND_Q_BLOCK 8
#define UCB$S_DISK_DEVDEPEND	4
#define UCB$S_TERM_DEVDEPEND	4
#define UCB$S_NET_DEVDEPEND	4
#define UCB$S_DEVDEPEND2	8
#define UCB$S_DEVDEPEND2_Q_BLOCK 8
#define UCB$S_TMV_BCNT		8
#define UCB$S_CHAR_SET		4
#define UCB$S_CHAR_SET_2	5
#define UCB$S_TT_DEVSTS_FILL	11
#define UCB$S_MEDIA_ID_NN	7
#define UCB$S_MEDIA_ID_N2	5
#define UCB$S_MEDIA_ID_N1	5
#define UCB$S_MEDIA_ID_N0	5
#define UCB$S_MEDIA_ID_T1	5
#define UCB$S_MEDIA_ID_T0	5

#define UCB$K_LENGTH	164	/* length of standard UCB */
#define UCB$C_LENGTH	164
#define UCB$S_UCBDEF	164

struct ucbdef {
    union {
	unsigned long ucb$l_fqfl;	/* fork queue forward link */
	unsigned short ucb$w_unit_seed; /* unit number seed */
	unsigned short ucb$w_mb_seed;	/* mb -- unit number seed */
	unsigned long ucb$l_rqfl;	/* net -- rcv queue forward link */
	unsigned long ucb$l_mb_msgqfl;	/* mailbox message queue listhead */
    } ucb$r_fqfl_overlay;
    union {
	unsigned long ucb$l_fqbl;	/* fork queue backward link */
	unsigned long ucb$l_rqbl;	/* net -- rcv queue backward link */
	unsigned long ucb$l_mb_msgqbl;	/* mailbox message queue listhead */
    } ucb$r_fqbl_overlay;
    unsigned short ucb$w_size;		/* size of UCB in bytes */
    unsigned char ucb$b_type;		/* structure type for UCB */
    union {
	unsigned char ucb$b_flck;	/* fork lock number */
	unsigned char ucb$b_fipl;	/* fork IPL */
    } ucb$r_flck_overlay;
    union {
	unsigned long ucb$l_fpc;	/* fork PC */
	unsigned long ucb$l_astqfl;	/* mb -- AST queue listhead forward link */
	unsigned long ucb$l_mb_w_ast;	/* mailbox write attn AST list */
	char ucb$t_partner;		/* net -- partner's nodename */
    } ucb$r_fpc_overlay;
    union {
	unsigned long ucb$l_fr3;	/* fork R3 */
	unsigned long ucb$l_astqbl;	/* mb -- AST queue listhead backward link */
	unsigned long ucb$l_mb_r_ast;	/* mailbox read attn AST list */
    } ucb$r_fr3_overlay;
    union {
	unsigned long ucb$l_fr4;	/* fork R4 */
	struct {
	    unsigned short ucb$w_msgmax; /* mb -- maximum messages allowed */
	    unsigned short ucb$w_msgcnt; /* mb -- current number of messages */
	} ucb$r_mb_fr4_fields;
	unsigned long ucb$l_first;	/* net -- addr of 1st seg of chained msg */
    } ucb$r_fr4_overlay;
    union {
	unsigned short ucb$w_bufquo;	/* buffered I/O quota charged for this UCB */
	unsigned short ucb$w_dstaddr;	/* net -- remote connect no. */
    } ucb$r_bufquo_overlay;
    union {
	unsigned short ucb$w_iniquo;	/* initial buffered I/O quota for this UCB */
	unsigned short ucb$w_srcaddr;	/* net -- local connect no. */
    } ucb$r_iniquo_overlay;
    unsigned long ucb$l_orb;		/* object's rights block address */
    union {
	unsigned long ucb$l_lockid;	/* device lock ID */
	unsigned long ucb$l_cpid;	/* PID charged for bufquo by ucbcredel */
    } ucb$r_lockid_overlay;
    unsigned long ucb$l_crb;		/* address of primary channel request block */
    unsigned long ucb$l_dlck;		/* address of device IPL spinlock */
    unsigned long ucb$l_ddb;		/* backpointer to device data block */
    unsigned long ucb$l_pid;		/* process ID of owner process */
    unsigned long ucb$l_link;		/* address of next UCB for respective DDB */
    unsigned long ucb$l_vcb;		/* address of volume control block */
    union {
	unsigned long ucb$q_devchar[2];   /* device characteristic bits quadword */
	struct {
	    unsigned long ucb$l_devchar;  /* original device characteristic bits */
	    unsigned long ucb$l_devchar2; /* extended device characteristic bits */
	} ucb$r_devchar_q_block;
    } ucb$r_devchar;
    unsigned long ucb$l_affinity;	/* device affinity */
    union {
	unsigned long ucb$l_xtra;	/* extra longword (for SMP) */
	unsigned long ucb$l_altiowq;	/* alternate startio wait queue */
    } ucb$r_xtra_overlay;
    unsigned char ucb$b_devclass;	/* device class */
    unsigned char ucb$b_devtype;	/* device type */
    unsigned short ucb$w_devbufsiz;	/* device default buffer size */
    union {
	unsigned long ucb$q_devdepend[2];	/* device dependent quadword */
	struct {
	    union {
		unsigned long ucb$l_devdepend;	/* first device dependent longword */
		struct {			/* disk fields */
		    unsigned char ucb$b_sectors;	/* sectors per track */
		    unsigned char ucb$b_tracks;		/* track per cylinder */
		    unsigned short ucb$w_cylinders;	/* cylinders per disk */
		} ucb$r_disk_devdepend;
		struct {			/* terminal fields */
		    unsigned	: 24;			/* char fill[3]; */
		    unsigned char ucb$b_vertsz;		/* vertical page size (lines per page) */
		} ucb$r_term_devdepend;
		struct {			/* network fields */
		    unsigned char ucb$b_locsrv;		/* local link services */
		    unsigned char ucb$b_remsrv;		/* remote link services */
		    unsigned short ucb$w_bytestogo;	/* no. of bytes left in rcv bfr */
		} ucb$r_net_devdepend;
	    } ucb$r_devdepend_overlay;
	    union {
		unsigned long ucb$l_devdepnd2;	/* second device dependent long word */
		unsigned long ucb$l_tt_devdp1;	/* terminal -- device dependent long word */
		unsigned short ucb$w_tu_formenu; /* TU/TMSCP -- supported formats (returned by GETDVI). */
	    } ucb$r_devdepnd2_overlay;
	} ucb$r_devdepend_q_block;
    } ucb$r_devdepend_q_overlay;
    union {
	unsigned long ucb$q_devdepend2[2];	/* device dependent quadword */
	struct {
	    union {
		unsigned long ucb$l_devdepnd3;	/* 3rd device dependent longword */
	    } ucb$r_devdepnd3_overlay;
	    union {
		unsigned long ucb$l_devdepnd4;	/* 4th device dependent long word */
	    } ucb$r_devdepnd4_overlay;
	} ucb$r_devdepend2_q_block;
	unsigned long ucb$l_tl_posix_data;	/* pointer to POSIX data block */
	struct {			/* tape mount verification byte counts */
	    unsigned short ucb$w_tmv_bcnt1;	/* byte count for 1st CRC */
	    unsigned short ucb$w_tmv_bcnt2;	/* ...2nd CRC */
	    unsigned short ucb$w_tmv_bcnt3;	/* ...3rd CRC */
	    unsigned short ucb$w_tmv_bcnt4;	/* ...4th CRC */
	} ucb$r_tmv_bcnt;
	struct {			/* overlay to hold Asian character set */
	    unsigned short ucb$w_tl_a_reserved; /* reserved for device characteristics bits */
	    unsigned short ucb$w_tl_a_charset;	/* character set data */
	} ucb$r_char_set;
	struct {			/* define a second overlay of DEVDEPND3 */
	    unsigned char ucb$b_tl_a_pseudo_mode; /* to make adding $GETDVI support easier and */
	    unsigned long ucb$l_tl_a_charset;	/* to be compatible with other planned versions */
	} ucb$r_char_set_2;
    } ucb$r_devdepend2_q_overlay;
    unsigned long ucb$l_ioqfl;		/* I/O queue listhead forward link */
    unsigned long ucb$l_ioqbl;		/* I/O queue listhead backward link */
    unsigned short ucb$w_unit;		/* physical device unit number */
    union {
	unsigned short ucb$w_charge;	/* mailbox byte count quota charge */
	unsigned short ucb$w_rwaitcnt;	/* class drivers -- threads waiting resources */
	struct {
	    unsigned char ucb$b_cm1;	/* level 1 controller allocation mask */
	    unsigned char ucb$b_cm2;	/* level 2 controller allocation mask */
	} ucb$r_ctrlr_alloc_fields;
    } ucb$r_charge_overlay;
    unsigned long ucb$l_irp;		/* current i/o request packet address */
    unsigned short ucb$w_refc;		/* reference count of processes */
    union {
	unsigned char ucb$b_dipl;	/* device interrupt priority level */
	unsigned char ucb$b_state;	/* net -- link state for network transitions */
    } ucb$r_dipl_overlay;
    unsigned char ucb$b_amod;		/* allocation access mode */
    unsigned long ucb$l_amb;		/* associated unit control block pointer */
    union {
	unsigned long ucb$l_sts;	/* device unit status */
	unsigned short ucb$w_sts;
	struct {
	    unsigned ucb$v_tim		: 1;	/* time out enabled (1=yes) */
	    unsigned ucb$v_int		: 1;	/* interrupt expected (1=yes) */
	    unsigned ucb$v_erlogip	: 1;	/* error log in progress on unit (1=yes) */
	    unsigned ucb$v_cancel	: 1;	/* cancel I/O on unit (1=yes) */
	    unsigned ucb$v_online	: 1;	/* unit online (1=yes) */
	    unsigned ucb$v_power	: 1;	/* power failed while unit busy (1=yes) */
	    unsigned ucb$v_timout	: 1;	/* unit timed out (1=yes) */
	    unsigned ucb$v_inttype	: 1;	/* receiver interrupt if set */
	    unsigned ucb$v_bsy		: 1;	/* unit is busy (1=yes) */
	    unsigned ucb$v_mounting	: 1;	/* device is being mounted */
	    unsigned ucb$v_deadmo	: 1;	/* deallocate at dismount */
	    unsigned ucb$v_valid	: 1;	/* volume is software valid */
	    unsigned ucb$v_unload	: 1;	/* unload volume at dismount */
	    unsigned ucb$v_template	: 1;	/* set if this is template UCB */
	    unsigned ucb$v_mntverip	: 1;	/* mount verification in progress */
	    unsigned ucb$v_wrongvol	: 1;	/* wrong volume detected during mount verification */
	    unsigned ucb$v_deleteucb	: 1;	/* delete this UCB when refc reaches zero */
	    unsigned ucb$v_lcl_valid	: 1;	/* volume is valid on the local node */
	    unsigned ucb$v_supmvmsg	: 1;	/* if set, suppress success type mount ver. msgs. */
	    unsigned ucb$v_mntverpnd	: 1;	/* mount verification is pending on busy device. */
	    unsigned ucb$v_dismount	: 1;	/* dismount in progress */
	    unsigned ucb$v_clutran	: 1;	/* VAXcluster state transition in progress */
	    unsigned ucb$v_wrtlockmv	: 1;	/* write-locked mount verification in progress */
	    unsigned ucb$v_svpn_end	: 1;	/* last byte used from page mapped by SVPN */
	    unsigned ucb$v_altbsy	: 1;	/* unit is busy via alternate startio path */
	    unsigned ucb$v_snapshot	: 1;	/* restart validation is in progress */
	} ucb$r_sts_bits;
    } ucb$r_sts_overlay;
    union {
	unsigned short ucb$w_devsts;		/* device dependent status */
	struct {
	    unsigned ucb$v_job		: 1;	/* job Controller notified */
	    unsigned			: 5;	/* devsts_gen_fill */
	    unsigned ucb$v_templ_bsy	: 1;	/* template UCB is busy */
	} ucb$r_devsts_general_bits;
	struct {
	    unsigned ucb$v_prmmbx	: 1;	/* permanent mailbox */
	    unsigned ucb$v_delmbx	: 1;	/* mailbox marked for delete */
	    unsigned			: 1;	/* devsts_mb_fill */
	    unsigned ucb$v_shmmbx	: 1;	/* shared memory mailbox */
	} ucb$r_devsts_mailbx_bits;
	struct {
	    unsigned			: 1;	/* devsts_tt_fill */
	    unsigned ucb$v_tt_timo	: 1;	/* terminal read timeout in progress */
	    unsigned ucb$v_tt_notif	: 1;	/* terminal user notified of unsolicted data */
	    unsigned ucb$v_tt_hangup	: 1;	/* process hang up */
	    unsigned ucb$v_tt_devsts_fill : 11; /* fill to the end the word */
	    unsigned ucb$v_tt_nologins	: 1;	/* nologins allowed */
	} ucb$r_devsts_term_bits;
	struct {
	    unsigned			: 2;	/* devsts_net_fill1 */
	    unsigned ucb$v_nt_bfrovf	: 1;	/* too many bytes rcvd */
	    unsigned			: 1;	/* devsts_net_fill2 */
	    unsigned ucb$v_nt_name	: 1;	/* link has declared a connect name */
	    unsigned ucb$v_nt_break	: 1;	/* link is being broken */
	} ucb$r_devsts_net_bits;
	struct {
	    unsigned ucb$v_ecc		: 1;	/* ECC correction was made */
	    unsigned ucb$v_diagbuf	: 1;	/* diagnostic buffer specified */
	    unsigned ucb$v_nocnvrt	: 1;	/* no LBN to media address conversion */
	    unsigned ucb$v_dx_write	: 1;	/* console floppy write operation */
	    unsigned ucb$v_datacache	: 1;	/* data blocks being cached */
	} ucb$r_devsts_disks;
	struct {
	    unsigned			: 8;	/* byte_fill */
	    unsigned ucb$v_mscp_mntverip: 1;	/* mount verification in progress */
	    unsigned ucb$v_mscp_initing : 1;	/* UCB is being initialized */
	    unsigned ucb$v_mscp_waitbmp : 1;	/* RWAITCNT has been bumped */
	    unsigned ucb$v_mscp_flovr	: 1;	/* bit toggled everytime a failover succeeds. */
	    unsigned ucb$v_mscp_pkack	: 1;	/* set when a IO$_PACKACK is in progress. */
	    unsigned ucb$v_mscp_wrtp	: 1;	/* unit MSCP write protected in some way. */
	    unsigned ucb$v_mscp_ignsrv	: 1;	/* ignore served paths during connection failover. */
	} ucb$devsts_mscp_class_bits;
	struct {
	    unsigned			: 3;	/* {dx_write_fill} */
	    unsigned ucb$v_du_shmv_strtd: 1;	/* shadowing mount verification started */
	    unsigned			: 1;	/* skip_datacache */
	    unsigned ucb$v_du_0mnote	: 1;	/* zero members message sent */
	} ucb$devsts_du_class_bits;
	struct {
	    unsigned ucb$v_tu_ovrsqchk	: 1;	/* override sequence checking */
	    unsigned ucb$v_tu_traceact	: 1;	/* IRP trace table active */
	    unsigned ucb$v_tu_seqnop	: 1;	/* sequential NOP tape operation in progress */
	    unsigned ucb$v_tu_1dens	: 1;	/* single density device */
	    unsigned ucb$v_tu_dens_determined : 1; /* Density already determined. Basically a */
						/* bit that says that a particular part of */
						/* PACKACK processing has already been done */
						/* once for this unit. */
	    unsigned ucb$v_tu_media_loaded : 1; /* media loaded into drive and drive available. */
	} ucb$r_devsts_tu_class_bits;
	struct {
	    unsigned			  : 10; /* byte_fill */
	    unsigned ucb$v_shd_seqcmd_here : 1; /* sequential command in progress on this node */
	    unsigned ucb$v_shd_seqcmd_there: 1; /* sequential command in progress on another node */
	    unsigned ucb$v_shd_passive_mv  : 1; /* passive MV in progress */
	    unsigned ucb$v_shd_node_failure: 1; /* node failure in progress */
	} ucb$devsts_shd_bits;
    } ucb$r_devsts_overlay;
    unsigned short ucb$w_qlen;		/* device queue length */
    unsigned long ucb$l_duetim;		/* due time for I/O completion */
    unsigned long ucb$l_opcnt;		/* count of operations completed */
    union {
	unsigned long ucb$l_svpn;	/* system virtual page/map register number */
	unsigned long ucb$l_logadr;	/* mb -- logical name block address */
    } ucb$r_svpn_overlay;
    unsigned long ucb$l_svapte;		/* system virtual address of PTE */
    unsigned short ucb$w_boff;		/* byte offset in first page */
    unsigned short ucb$w_bcnt;		/* byte count of transfer */
    unsigned char ucb$b_ertcnt;		/* error log device current error retry count */
    union {
	unsigned char ucb$b_ertmax;	/* error log device maximum error retry count */
	unsigned char ucb$b_tl_a_mode;	/* ttdriver slot for Asian driver mode */
    } ucb$r_ertmax_overlay;
    unsigned short ucb$w_errcnt;	/* device error count */
    unsigned long ucb$l_pdt;		/* addr of port descriptor table */
    unsigned long ucb$l_ddt;		/* addr of DDT (optional but preferred) */
    union {
	unsigned long ucb$l_media_id;	/* bit encoded media identification */
	struct {
	    unsigned ucb$v_media_id_nn : 7;	/* media name number */
	    unsigned ucb$v_media_id_n2 : 5;	/* media name char 2 */
	    unsigned ucb$v_media_id_n1 : 5;	/* media name char 1 */
	    unsigned ucb$v_media_id_n0 : 5;	/* media name char 0 */
	    unsigned ucb$v_media_id_t1 : 5;	/* media type char 1 */
	    unsigned ucb$v_media_id_t0 : 5;	/* media type char 0 */
	} ucb$r_media_id_subfields;
	unsigned long ucb$l_tl_asian_data; /* pointer to Asian data block */
    } ucb$r_media_overlay;
}; /* ucbdef */

/*
   device dependent UCB extensions
 */

/* mailbox */
#define UCB$K_MB_LENGTH 192	/* size of mailbox UCB */
#define UCB$C_MB_LENGTH 192
#define UCB$S_UCBDEF3	192
struct ucbdef3 {
    char ucbdef3$$_fill[UCB$K_LENGTH];
    unsigned long ucb$l_mb_wast;	/* write attention AST block addr */
    unsigned long ucb$l_mb_rast;	/* read attention AST block addr */
    unsigned long ucb$l_mb_mbx;		/* mailbox control block addr */
    unsigned long ucb$l_mb_shb;		/* shared mem. control block addr */
    unsigned long ucb$l_mb_wioqfl;	/* write I/O queue forward link */
    unsigned long ucb$l_mb_wioqbl;	/* write I/O queue backward link */
    unsigned long ucb$l_mb_port;	/* shared mem. port number */
};

/* error log devices (all) */
#define UCB$K_ERL_LENGTH 180	/* size of error log UCB */
#define UCB$C_ERL_LENGTH 180
#define UCB$S_UCBDEF4	 180
struct ucbdef4 {
    char ucbdef4$$_fill[UCB$K_LENGTH];
    unsigned char ucb$b_slave;	/* slave controller number */
    unsigned char ucb$b_spr;	/* spare unused byte */
    unsigned char ucb$b_fex;	/* function dispatch table index */
    unsigned char ucb$b_cex;	/* case table function execution index */
    unsigned long ucb$l_emb;	/* address of error message buffer */
    unsigned	: 16;		/* spare unused word */
    unsigned short ucb$w_func;	/* I/O function modifiers */
    unsigned long ucb$l_dpc;	/* saved driver subroutine return address */
};

/* dual ported devices (all disks and most tapes) */
#define UCB$K_DP_LENGTH 192	/* size of dual path UCB */
#define UCB$C_DP_LENGTH 192
#define UCB$K_2P_LENGTH 192
#define UCB$C_2P_LENGTH 192
#define UCB$S_DUALPATH_EXTENSION 192
struct dualpath_extension {
    char dualpath_extension$$_fill[UCB$K_ERL_LENGTH];
    union {
	struct {
	    unsigned long ucb$l_dp_ddb;		/* pointer to alternate DDB */
	    unsigned long ucb$l_dp_link;	/* address of next UCB for this DDB */
	    unsigned long ucb$l_dp_altucb;	/* addr of alternate UCB for this unit */
	} ucb$r_old_dual_path;
	struct {
	    unsigned long ucb$l_2p_ddb;		/* pointer to alternate DDB */
	    unsigned long ucb$l_2p_link;	/* address of next UCB for this DDB */
	    unsigned long ucb$l_2p_altucb;	/* addr of alternate UCB for this unit */
	} ucb$r_prefered_dual_path;
    } ucb$r_dual_path;
};

/* all disks and tapes */
#define UCB$V_AST_ARMED 15
#define UCB$M_AST_ARMED (1<<UCB$V_AST_ARMED)	/* 0x8000 */
#define UCB$K_LCL_TAPE_LENGTH	216	/* size of local tape UCB */
#define UCB$C_LCL_TAPE_LENGTH	216
#define UCB$S_DISKTAPE_UCB_EXTENSION 216
struct disktape_ucb_extension {
    char disktape_ucb_extension$$_fill[UCB$K_2P_LENGTH];
    union {
	unsigned short ucb$w_dirseq;		/* directory sequence number */
	struct {
	    unsigned		     : 15;	/* fill */
	    unsigned ucb$v_ast_armed : 1;	/* blocking AST armed flag */
	} ucb$r_dirseq_bits;
    } ucb$r_dirseq_overlay;
    unsigned char ucb$b_onlcnt;		/* online count */
    union {
	struct {
	    unsigned	: 8;			/* fill */
	    unsigned long ucb$l_maxblock;	/* random access device highest block */
	    unsigned long ucb$l_maxbcnt;	/* maximum transfer BCNT */
	    unsigned long ucb$l_dccb;		/* pointer to data cache control block */
	    unsigned long ucb$l_qlenacc;	/* queue length accumulator */
	} ucb$r_disk_fields;
	struct {
	    unsigned char ucb$b_prev_record;	/* tape position prior at start of last I/O */
	    unsigned long ucb$l_record;		/* current tape position or frame counter */
	    unsigned	: 32;			/* fill for MAXBCNT */
	    unsigned long ucb$l_tmv_record;	/* Position following last guaranteed successful I/O */
	    unsigned short ucb$w_tmv_crc1;	/* 1st CRC for Mount Ver's media validation */
	    unsigned short ucb$w_tmv_crc2;	/* 2nd CRC ... */
	    unsigned short ucb$w_tmv_crc3;	/* 3rd CRC ... */
	    unsigned short ucb$w_tmv_crc4;	/* 4th CRC ... */
	} ucb$r_tape_fields;
    } ucb$r_disktape_overlay;
};

#define UCB$K_LCL_DISK_LENGTH	228	/* size of local disk UCB */
#define UCB$C_LCL_DISK_LENGTH	228
#define UCB$S_LCL_DISK_UCB_EXTENSION 244
struct lcl_disk_ucb_extension {
    char lcl_disk_ucb_extension$$_fill[UCB$K_LCL_TAPE_LENGTH-4];	/** substract (tape_fields - disk_fields) **/
    union {
	unsigned long ucb$l_media;	/* media address (longword) */
	struct {
	    unsigned short ucb$w_da;	/* saved desired sector/track address register */
	    unsigned short ucb$w_dc;	/* saved desired cylinder address register */
	} ucb$r_media_fields;
    } ucb$r_media;
    union {
	unsigned long ucb$l_bcr;	/* byte count register */
	unsigned short ucb$w_bcr;
    } ucb$r_bcr;
    unsigned short ucb$w_ec1;		/* ECC position register */
    unsigned short ucb$w_ec2;		/* ECC pattern register */
    unsigned short ucb$w_offset;	/* current offset register contents */
    unsigned char ucb$b_offndx;		/* current offset table index */
    unsigned char ucb$b_offrtc;		/* current offset retry count */
 /* floppy dependent bit definitions */
    unsigned long ucb$l_dx_buf;		/* address of sector buffer */
    unsigned long ucb$l_dx_bfpnt;	/* current sector buffer pointer */
    unsigned long ucb$l_dx_rxdb;	/* saved receiver data buffer */
    unsigned short ucb$w_dx_bcr;	/* current floppy byte count */
    unsigned char ucb$b_dx_sctcnt;	/* current sector byte count */
    unsigned	: 8;			/* char fill; spare unused byte */
};

/* MSCP disks and tapes UCB extension */
#define UCB$S_UNIT_ID	8
#define UCB$K_MSCP_DISK_LENGTH	268	/* size of MSCP disk UCB */
#define UCB$K_MSCP_TAPE_LENGTH	268
#define UCB$S_MSCP_UCB_EXTENSION 268
struct mscp_ucb_extension {
    char mscp_ucb_extension$$_fill[UCB$K_LCL_TAPE_LENGTH];
    unsigned long ucb$l_cddb;		/* pointer to active CDDB */
    unsigned long ucb$l_2p_cddb;	/* pointer to alternate CDDB */
    unsigned long ucb$l_cddb_link;	/* pointer to next UCB in CDDB chain */
    unsigned long ucb$l_cdt;		/* pointer to active CDT */
    unsigned long ucb$l_wait_cddb;	/* address of CDDB waiting for mnt. ver. to complete on this UCB */
    unsigned long ucb$l_pref_cddb;	/* CDDB address for preferred path */
    long ucb$q_unit_id[2];		/* unique MSCP unit identifier */
    unsigned short ucb$w_mscpunit;	/* primary path MSCP unit number */
    unsigned short ucb$w_unit_flags;	/* MSCP unit flags */
    unsigned short ucb$w_lcl_mscpunit;	/* MSCP unit number for local (non-emulated) controllers */
    unsigned short ucb$w_srv_mscpunit;	/* MSCP unit number for served (emulated) controllers */
    unsigned long ucb$l_mscpdevparam;	/* MSCP device-dependent parameters */
    unsigned char ucb$b_freecap;	/* free capacity */
    unsigned	: 8;			/* char fill; reserved, for alignment */
    unsigned short ucb$w_mscp_resvdw;	/* reserved for MSCP enhancements */
    unsigned long ucb$l_shad;		/* virtual Unit Pointer to HBS SHAD */
};

/* disk class driver device dependent unit control block offsets */
#define UCB$K_DU_LENGTH 294	/* size of DISK CLASS DRIVER dependent UCB */
#define UCB$S_DUDRIVER_EXTENSION 294
struct dudriver_extension {
    char dudriver_extension$$_fill[UCB$K_MSCP_DISK_LENGTH];
    unsigned long ucb$l_du_volser;	/* Serial umber as returned in ONLINE end packet. */
    unsigned long ucb$l_du_usize;	/* Size of user visible area of unit in logical blocks */
    unsigned long ucb$l_du_totsz;	/* Size of unit including RCT area in logical blocks */
    unsigned short ucb$w_du_rctsize;	/* Size of the RCT in blocks */
    unsigned char ucb$b_du_rctcpys;	/* Number of RCT copies on the unit */
    unsigned char ucb$b_du_rbnptrk;	/* RBNs per track */
    unsigned short ucb$w_du_lbnptrk;	/* LBNs per track */
    unsigned short ucb$w_du_trkpgrp;	/* Tracks per group */
    unsigned short ucb$w_du_grppcyl;	/* Groups per cylinder */
    unsigned short ucb$w_du_muntc;	/* Multi-unit code */
    unsigned char ucb$b_du_usvr;	/* Unit software version */
    unsigned char ucb$b_du_uhvr;	/* Unit hardware version */
};

/* tape class driver device dependent unit control block offsets */
#define UCB$V_TU_RPTREQ		0
#define UCB$V_TU_RPTPND		1
#define UCB$V_TU_DENSITY	2
#define UCB$M_TU_RPTREQ		(1<<UCB$V_TU_RPTREQ)	/* 0x01 */
#define UCB$M_TU_RPTPND		(1<<UCB$V_TU_RPTPND)	/* 0x02 */
#define UCB$M_TU_DENSITY	(1<<UCB$V_TU_DENSITY)	/* 0x04 */
#define UCB$K_TU_LENGTH 280	/* size of TAPE CLASS DRIVER dependent UCB */
#define UCB$S_TUDRIVER_EXTENSION 280
struct tudriver_extension {
    char tudriver_extension$$_fill[UCB$K_MSCP_TAPE_LENGTH];
    unsigned long ucb$l_tu_maxwrcnt;	/* largest size record likely to have reliability statistics */
    unsigned short ucb$w_tu_format;	/* format (density) */
    unsigned short ucb$w_tu_speed;	/* current speed */
    unsigned short ucb$w_tu_noise;	/* size of noise records ignored by controller */
    unsigned char ucb$b_tu_softerr;	/* media quality reporting counter */
    union {
	unsigned char ucb$b_tu_softflags;	/* media quality reporting flags */
	struct {
	    unsigned ucb$v_tu_rptreq  : 1;	/* report request */
	    unsigned ucb$v_tu_rptpnd  : 1;	/* report pending */
	    unsigned ucb$v_tu_density : 1;	/* density check done if set */
	    unsigned		      : 5;	/* padding */
	} ucb$r_tu_softflags_bits;
    } ucb$r_tu_softflags_overlay;
};

/* network logical link (network mailbox) extension */
#define UCB$V_LTYPE	0
#define UCB$M_LTYPE	(3<<UCB$V_LTYPE)	/* 0x03 */
#define UCB$S_LTYPE	2
#define UCB$V_SEGFLO	2
#define UCB$M_SEGFLO	(1<<UCB$V_SEGFLO)	/* 0x04 */
#define UCB$V_MSGFLO	3
#define UCB$M_MSGFLO	(1<<UCB$V_MSGFLO)	/* 0x08 */
#define UCB$V_MSGACK	4
#define UCB$M_MSGACK	(1<<UCB$V_MSGACK)	/* 0x10 */
#define UCB$V_BACKP	5
#define UCB$M_BACKP	(1<<UCB$V_BACKP)	/* 0x20 */
#define UCB$V_LNKPRI	6
#define UCB$M_LNKPRI	(3<<UCB$V_LNKPRI)	/* 0xC0 */
#define UCB$S_LNKPRI	2
/* network constants */
#define UCB$C_LOGLNK	1	/* connect is for logical link (not single msg) */
#define UCB$S_UCBDEF7	176
struct ucbdef7 {
    char ucbdef7$$_fill[UCB$K_LENGTH];
    unsigned long ucb$l_nt_datssb;	/* address of data subchannel status block */
    unsigned long ucb$l_nt_intssb;	/* address of INT/LS SSB */
    unsigned short ucb$w_nt_chan;	/* ddcmp channel no. */
    union {
	unsigned short ucb$w_nt_link;	/*(invented field name)*/
	struct {
	    unsigned ucb$v_ltype  : 2;	/* link type bits */
	    unsigned ucb$v_segflo : 1;	/* segment request counts */
	    unsigned ucb$v_msgflo : 1;	/* message request counts */
	    unsigned ucb$v_msgack : 1;	/* message ack/nak */
	    unsigned ucb$v_backp  : 1;	/* backpressure (1=> no flow) */
	    unsigned ucb$v_lnkpri : 2;	/* link priority (ignored) */
	} ucb$r_nt_link_bits;
    } ucb$r_nt_link_overlay;
};

/* NI device extension */
#define UCB$K_NI_LENGTH 172	/* size of NI device UCB */
#define UCB$C_NI_LENGTH 172
#define UCB$S_UCBDEF9	172
struct ucbdef9 {
    char ucbdef9$$_fill[UCB$K_LENGTH];
    unsigned long ucb$l_ni_hwaptr;	/* address of NI device hardware address */
    unsigned long ucb$l_ni_mltptr;	/* address of protocol multicast table */
};

/* DAP device extension (for devices that use the DAP interface without */
/* undelying DECnet, such as certain console disks).			*/
#define UCB$S_DAPDEVNAM 32
#define UCB$K_DAPDEV_LENGTH	196	/* size of DAP device UCB */
#define UCB$C_DAPDEV_LENGTH	196
#define UCB$S_UCBDEF10		196
struct ucbdef10 {
    char ucbdef10$$_fill[UCB$K_LENGTH];
    char ucb$t_dapdevnam[32];		/* equivalence name string */
};

/* MAILBOX (Extended Mailbox - Above definitions are for Shared Memory Mailboxes.) */
#define UCB$K_MB_UCBLENGTH	212	/* size of mailbox UCB */
#define UCB$C_MB_UCBLENGTH	212
#define UCB$S_UCBDEF11	212
struct mailbox_extension {
    char mailbox_extension$$_fill[UCB$K_LENGTH];
    unsigned short ucb$w_mb_readerrefc;		/* reference count of read enabled channels to device */
    unsigned short ucb$w_mb_writerrefc;		/* reference count of write enabled channels to device */
    unsigned long ucb$l_mb_readqfl;		/* mailbox read IRP queue listhead */
    unsigned long ucb$l_mb_readqbl;
    unsigned long ucb$l_mb_writerwaitqfl;	/* mailbox wait for write channel to be assigned queue */
    unsigned long ucb$l_mb_writerwaitqbl;
    unsigned long ucb$l_mb_readerwaitqfl;	/* mailbox wait for read channel to be assigned queue */
    unsigned long ucb$l_mb_readerwaitqbl;
    unsigned long ucb$l_mb_nowriterwaitqfl;	/* mailbox wait for all write channels to be deassigned queue */
    unsigned long ucb$l_mb_nowriterwaitqbl;
    unsigned long ucb$l_mb_noreaderwaitqfl;	/* mailbox wait for all read channels to be deassigned queue */
    unsigned long ucb$l_mb_noreaderwaitqbl;
    unsigned long ucb$l_mb_room_notify;		/* room notify AST list */
};

#endif	/*_UCBDEF_H*/
