/* <vms/lib/uncdef.h>
 *
 *	LIB - universal context definitions	[not in Starlet]
 */
#ifndef _UNCDEF_H
#define _UNCDEF_H

/*
   UNCHDRDEF - universal Context Segment Header definition
 */
#define UNC$C_JPI	1	/* JPI context segment */
#define UNC$C_UAI	2	/* UAI context segment */
#define UNC$C_HDR_LENGTH 16	/* size of context segment header */
#define UNC$C_LIST	16	/* offset to first context block */
#define UNC$S_UNCHDRDEF 16
struct unchdrdef {
    unsigned long unc$l_flink;		/* forward link to next context segment */
    unsigned long unc$l_blink;		/* back link to prev context segment */
    unsigned short unc$w_size;		/* total size of context segment */
    unsigned char unc$b_type;		/* VMS type of block (DYN$C_UNC) */
    unsigned char unc$b_subtype;	/* type of context segment */
    unsigned short unc$w_count;		/* number of context blocks in segment */
    unsigned short unc$w_unused_w1;
};

/*
   universal Context Block definition
 */
#define UNC$C_LENGTH	16	/* size of context block */
#define UNC$C_SEGMENTS	31	/* natural number of blocks/segment */
#define UNC$S_UNCDEF	16
struct uncdef {
    unsigned short unc$w_flags;		/* context cell flags */
    unsigned char unc$b_access_mode;	/* access mode of context cell */
    unsigned char unc$b_unused_b1;
    unsigned long unc$l_image_count;	/* imgcnt when context cell assigned */
    union {
	struct {
	    unsigned long unc$l_target_pid;	/* target process PID */
	    unsigned short unc$w_segidx;	/* rights segment index */
	    unsigned short unc$w_rights;	/* rights list index */
	} unc$r_jpi_context;
	struct {
	    unsigned short unc$w_ifi;		/* FAB$W_IFI */
	    unsigned short unc$w_isi;		/* RAB$W_ISI */
	    unsigned short unc$w_channel;	/* UAF channel */
	    unsigned	: 16;			/* padding */
	} unc$r_uai_context;
    } unc$r_context_overlay;
};

#endif	/*_UNCDEF_H*/
