/* <xabdatdef.h>
 *
 *	RMS date/time XAB definitions
 */
#ifndef _XABDATDEF_H
#define _XABDATDEF_H

#define XAB$C_DAT	18	/* xabdat ID code */
#define XAB$K_DATLEN_V2 36	/* version 2 XABDAT length */
#define XAB$C_DATLEN_V2 36
#define XAB$K_DATLEN	44	/* length of XABDAT */
#define XAB$C_DATLEN	44

struct XABDAT {
    unsigned char  xab$b_cod;		/* xab ID code */
    unsigned char  xab$b_bln;		/* block length */
	unsigned : 16;			/* (filler) */
    void	  *xab$l_nxt;		/* xab chain link */
    unsigned short xab$w_rvn;		/* revision number */
	unsigned : 16;			/* spare */
    unsigned long xab$q_rdt[2];		/* revision date & time */
    unsigned long xab$q_cdt[2];		/* creation date & time */
    unsigned long xab$q_edt[2];		/* expiration date & time */
 /*- end of old XABDAT -*/
    unsigned long xab$q_bdt[2];		/* backup date and time */
};

struct xabdatdef {
    unsigned	: 8, : 8, : 16, : 32;	/* common of all xabs (see $XABDEF) */
    unsigned short xab$w_rvn;		/* revision no. (common to $xabrdt) */
    unsigned	: 16;			/* short fill; spare */
    union {
	long xab$q_rdt[2];		/* revision date & time */
	struct {
	    unsigned long xab$l_rdt0;
	    long xab$l_rdt4;
	} xab$r_rdt_fields;
    } xab$r_rdt_overlay;
    union {
	long xab$q_cdt[2];		/* creation date & time */
	struct {
	    unsigned long xab$l_cdt0;
	    long xab$l_cdt4;
	} xab$r_cdt_fields;
    } xab$r_cdt_overlay;
    union {
	long xab$q_edt[2];		/* expiration date & time */
	struct {
	    unsigned long xab$l_edt0;
	    long xab$l_edt4;
	} xab$r_edt_fields;
    } xab$r_edt_overlay;
 /*- end of old XABDAT -*/
    union {
	long xab$q_bdt[2];		/* backup date and time */
	struct {
	    unsigned long xab$l_bdt0;
	    long xab$l_bdt4;
	} xab$r_bdt_fields;
    } xab$r_bdt_overlay;
};

/* declare initialized prototype data structure */
extern struct XABDAT cc$rms_xabdat __asm("_$$PsectAttributes_GLOBALSYMBOL$$cc$rms_xabdat");
/* globalref struct XABDAT cc$rms_xabdat; */

#endif	/*_XABDATDEF_H*/
